#ifndef _COMMON_H_
#define _COMMON_H_
//Definitions common between ArcadeOS real mode stub
//and protected mode app.

//always useful
#define TRUE           1
#define FALSE          0

//BIOS extensions
//flag indicating it's an AOS command
#define AOS_BIOS_FLAG		0xff
//commands
#define CHECK_BIOS         99 //presence test
#define SET_INCABINET      100   //set monitor type
#define SET_CENTER         101   //center screen
#define SET_SCANLINES      102   //activate scanlines
#define SET_VESA           103   //allow VESA modes
#define SET_VH_TOTALS      104   //set monitor mode timings
#define SET_VH_SCANLINE    105   //set scanlines mode timing
#define LAST_MODE_SET      106   //number of last mode set
#define USER_ESCAPE			107	//user escaped out of game
#define MODEX_SETUP        108   //ModeX delay
#define BLOCK_MODES			109	//block all modes apart from 13h
#define JUKE_DELAY			110	//delay for jukebox
#define SET_COMMANDS       111   //store AOS commands
#define SET_CONFIG			112	//store emu's config
#define SET_WRAP           113   //store wrapper commands
#define GET_COMMANDS       114   //get AOS commands
#define GET_CONFIG			115	//get emu's config
#define GET_WRAP           116   //get wrapper commands


//'BIOS is present' return value
#define AOS_BIOS_PRESENT	24


//ArcadeOS RM<->PM commands
#define COMMAND_HEADER    "$$ArcadeOS Command$$"
#define COMMAND_COMMAND   "$com$"
#define COMMAND_FCOPY     "$fil$"
#define COMMAND_RETURNS   "$rets$"
#define COMMAND_GAMENAME  "$name$"
#define COMMAND_JUKEBOX   "$jukebox$"
#define COMMAND_REMAP     "$remap$"
#define COMMAND_SHIFTS    "$shift$"
#define COMMAND_NAG       "$nag$"
#define COMMAND_END       "$END"


#define NO_REMAPS       "$NOREMAPS$"
#define NO_SHIFTS			"$NOSHIFTS$"

#endif
