#include	"main.h"
#include "con_lc.h"

extern char szVersion[];
static int savedvals[256];
static int savedtotal=0;

void writecfgvalues(void)
{
   int cidx;
   int outval;
   char szFile[512];

   FILE *fCfg;

   sprintf(szFile,"%sarcadeos.cfg",szStartDir);
   fCfg=fopen(szFile,"wt");

   fprintf(fCfg,"#############################\n# %s Config File #\n#############################\n",szVersion);
   if(fCfg)
   {
      cidx=0;
      while(textvals[cidx].pvalue)
      {
         if(*textvals[cidx].comment)
            fprintf(fCfg,"\n#%s\n",textvals[cidx].comment);
         fprintf(fCfg,"%s=%s\n",textvals[cidx].name,textvals[cidx].pvalue);
         cidx++;
      }
      cidx=0;
      while(convals[cidx].pvalue)
      {
         if(*convals[cidx].comment)
            fprintf(fCfg,"\n#%s\n",convals[cidx].comment);
         switch(convals[cidx].cfgtype)
         {
            case CFG_BYTE:
               outval=(int)(*((BYTE *)(convals[cidx].pvalue))-convals[cidx].offset);
               break;
            default:
               outval=(*convals[cidx].pvalue)-convals[cidx].offset;
               break;
         }
         if(convals[cidx].invert)
            outval=!outval;
         fprintf(fCfg,"%s=%d\n",convals[cidx].name,outval);
         cidx++;
      }

      fclose(fCfg);
   }
}

void getcfgvalues(void)
{
   int cidx;
   FILE *fin;
   char buffer[256];
   char ident[256];
   char workbuf[256];
   char *work;
   char *itemval;
   int inval;

   setdefvals();

   fin=fopen("arcadeos.cfg","rt");

   if(fin)
   {
      while(fgets(buffer,255,fin))
      {
         if(buffer[0]!='#')
         {
//make sure it's terminated
            buffer[strlen(buffer)-1]=0;
//get rid of white space
            tidybuffer(buffer);
            cidx=0;
            while(textvals[cidx].pvalue)
            {
               sprintf(ident,"%s=",textvals[cidx].name);
               if(strstr(buffer,ident)==buffer)
                  if((itemval=getitem(workbuf,buffer,1,255,'=')))
                     strcpy(textvals[cidx].pvalue,itemval);
               cidx++;
            }
            cidx=0;
            while(convals[cidx].pvalue)
            {
               sprintf(ident,"%s=",convals[cidx].name);
               if(strstr(buffer,ident)==buffer)
               {
                  work=getitem(workbuf,buffer,1,255,'=');
                  if(work)
                  {
                     inval=(atoi(work)+convals[cidx].offset);
                     if(convals[cidx].invert)
                        inval=!inval;
                     switch(convals[cidx].cfgtype)
                     {
                        case CFG_BYTE:
                           *((BYTE *)convals[cidx].pvalue)=(BYTE)inval;
                           break;
                        default:
                           *convals[cidx].pvalue=inval;
                           break;
                     }
                  }
               }
               cidx++;
            }
         }
      }
      fclose(fin);
   }
}

void setdefvals(void)
{
   int i=0;
   while(textvals[i].pvalue)
   {
      strcpy(textvals[i].pvalue,textvals[i].defval);
      i++;
   }
   i=0;
   while(convals[i].pvalue)
   {
      *convals[i].pvalue=convals[i].defval+convals[i].offset;
      if(convals[i].invert)
         *convals[i].pvalue=!*convals[i].pvalue;

      i++;
   }
}

int getcmdlineargs(int argc,char **argv)
{
   int i,cidx;
   char buffer[128];
//SVGA info
   SupportedSVGA=atoi(argv[1]);
//check for help
   if(argc>2)
   {
      if(!stricmp(argv[2],"-help")||!stricmp(argv[2],"-?"))
      {
         cmdlinehelp();
         return 0;
      }
//check for values
      for(i=2;i<argc;i++)
      {
         cidx=0;
         while(convals[cidx].pvalue)
         {
            sprintf(buffer,"-%s",convals[cidx].name);
            if(!stricmp(argv[i],buffer))
               if((i+1)<argc)
                  *convals[cidx].pvalue=atoi(argv[i+1]);
            cidx++;
         }
         cidx=0;
         while(textvals[cidx].pvalue)
         {
            sprintf(buffer,"-%s",textvals[cidx].name);
            if(!stricmp(argv[i],buffer))
               if((i+1)<argc)
                  strcpy(textvals[cidx].pvalue,argv[i+1]);
            cidx++;
         }

      }

   }


   return 1;
}

void cmdlinehelp(void)
{
   int cidx;
   cidx=0;
   printf("%s\n",szVersion);
   printf("Command Line Options:\n-----------------------------------\n");
   while(textvals[cidx].pvalue)
   {
      printf("-%s <val>  : %s\n",textvals[cidx].name,textvals[cidx].comment);
      cidx++;
   }
   cidx=0;
   while(convals[cidx].pvalue)
   {
      printf("-%s <val>  : %s\n",convals[cidx].name,convals[cidx].comment);
      cidx++;
   }
   printf("-----------------------------------\n");

}

void tidybuffer(char *pin)
{
   int state;
   int fndspace=TRUE;
   int outpos=0;
   int i;
//remove white space from config line, but leave imbedded spaces in value
//idea is - we get something like this:
//>     ident     =       value1 and value 2        <
//and convert it to:
//>ident=value1 and value 2<

   state=BUFFER_START;
//top and tail
   pin=trimspaces(pin);
//intelligentally remove space from line
   for(i=0;i<strlen(pin);i++)
   {
      switch(state)
      {
//look for the ident
         case BUFFER_START:
            if(!isspace(pin[i]))
            {
               state=BUFFER_FOUND_IDENT;
               pin[outpos++]=pin[i];
            }
            break;
//look for the '='
         case BUFFER_FOUND_IDENT:
            if(!isspace(pin[i]))
            {
               if(pin[i]=='=')
                  state=BUFFER_FOUND_EQUAL;
               pin[outpos++]=pin[i];
            }
            break;
//look for the value
         case BUFFER_FOUND_EQUAL:
            if(!isspace(pin[i]))
            {
               state=BUFFER_FOUND_VALUE;
               pin[outpos++]=pin[i];
            }
            break;
//don't remove any spaces from the value
         case BUFFER_FOUND_VALUE:
            pin[outpos++]=pin[i];
            break;
      }

   }
//make sure it's terminated
   pin[outpos]=0;
}

void saveinitconfig(int nTotal)
{
   int n;
   if(nTotal>255)
      nTotal=255;

   savedtotal=nTotal;
   for(n=0;n<savedtotal;n++)
      savedvals[n]=*cfgDefValues[n].pArcValue;
}

int configchanged(void)
{
   int n;
   int ret=FALSE;

   for(n=0;n<savedtotal;n++)
   {
      if(savedvals[n]!=*cfgDefValues[n].pArcValue)
      {
         ret=TRUE;
         break;
      }
   }
   savedtotal=0;
   return ret;
}

// LasVegas - Added szMenu item for Menu Filtering.

void setarcconfig(char *szMenu,char *szIdent,int *pOrig,int nType,int nMin,int nMax,int nIndex,int nOffSet,int cfgtype)
{
   setarcconfigdef(szMenu,szIdent,pOrig,nType,nMin,nMax,nIndex,nOffSet,cfgtype,*pOrig);
}

void setarcconfigdef(char *szMenu,char *szIdent,int *pOrig,int nType,int nMin,int nMax,int nIndex,int nOffSet,int cfgtype,int def)
{
	strcpy(cfgDefValues[nIndex].szMenu,szMenu);
	strcpy(cfgDefValues[nIndex].szIdent,szIdent);
	cfgDefValues[nIndex].pArcValue=pOrig;
   cfgDefValues[nIndex].pbArcValue=(pBYTE)pOrig;
   cfgDefValues[nIndex].CfgType=cfgtype;
   cfgDefValues[nIndex].nValue=def;
   cfgDefValues[nIndex].nDefault=def;
	cfgDefValues[nIndex].min=nMin;
	cfgDefValues[nIndex].max=nMax;
	cfgDefValues[nIndex].nType=nType;
	cfgDefValues[nIndex].nOffSet=nOffSet;
	nCfgValues[nIndex]=*pOrig;
}



void restoldconfig()
{
   int bReload;
	NoCfgValues=NoSaveCfgs;
	if(!pcfgSave)
		return;

   bReload=(SavedNoMR!=noMergedROMs[CurEmu]);
   bReload|=(SavedUNK!=noUnknowns);
   bReload|=((CustNeo!=(CUSTOM_LIST_OFFSET+NO_CUSTOM_LISTS))&(CustNeo!=SavedNeo))|
                     ((CustVector!=(CUSTOM_LIST_OFFSET+NO_CUSTOM_LISTS))&(CustVector!=SavedVector));
   bReload|=(SavedCapitalise!=Capitalise);
   bReload|=(SavedNoFiltActive!=noFiltersActive);
   bReload|=(SavedNoCustomAll!=noCustomContainsAll[CurEmu]);
   bReload|=configchanged();

	memcpy(cfgDefValues,pcfgSave,CFG_ALL_SIZE);
   if(bReload)
		reloadgames(TRUE);
   SavedNoMR=noMergedROMs[CurEmu];
   SavedUNK=noUnknowns;
   SavedCapitalise=Capitalise;
   SavedNoFiltActive=noFiltersActive;
   SavedNoCustomAll=noCustomContainsAll[CurEmu];
}
