#include "main.h"
#include "disp.h"
#include "con_ex.h"
#include "conmenu.h"
#include "conm_lc.h"


void subcontrolmenu(void)
{

	int	ypos,txtpos;
	WINSTRUCT	winstruct;

	SubControlItems=0;
	txtpos=0;
	while(*submenu[txtpos++])
		SubControlItems++;

	createwin(&winstruct,3,5,21,SubControlItems+6,0,0);

	winstruct.winproc=stdproc;
	winstruct.bHasScrollBar=FALSE;

	pStdPos=&SubControlPos;
	pStdMax=&SubControlItems;
	registerwindow(&winstruct);
	drawwindow(&winstruct,WinColour,TRUE,bFirstSubControl,"Config Sub Menu");
	dispcursorbar(SubControlPos,0,19,4,7);
	ypos=7;
//see what we're going to display

	txtpos=0;
	while(*submenu[txtpos])
		dispstring(4,ypos++,submenu[txtpos++],ForeColour,TRUE,0,0,DISP_FONT);

	dispcentre(ypos+1,"Start 2 to Close",ExtraColour,4,18,TRUE,0,0,DISP_FONT);

	if(bFirstSubControl)
	{
		SavedNoMR=noMergedROMs[CurEmu];
		SavedUNK=noUnknowns;
		SavedNeo=CustNeo;
		SavedVector=CustVector;
		SavedCapitalise=Capitalise;
		SavedNoFiltActive=noFiltersActive;
		SavedNoCustomAll=noCustomContainsAll[CurEmu];

		NoSaveCfgs=NoCfgValues;
		memcpy(pcfgSave,cfgDefValues,CFG_ALL_SIZE);
	}
	bFirstSubControl=FALSE;
}

void movesubconfig(void)
{
	int dummy=0;

	if(startpressed())
	{
		if(nGameIndex>=0)
			nSaveIndex=nGameIndex;
		nGameIndex=-2;
		makearcadeosconfig(SubControlPos);
		State=MENU_STATE_CONFIG;
		bFirstConfig=TRUE;
		bExplodeConfig=TRUE;
		ConfigPos=0;
		ConfigOff=0;
		SavedNoMR=noMergedROMs[CurEmu];
		SavedUNK=noUnknowns;
		SavedNeo=CustNeo;
		SavedVector=CustVector;
		SavedCapitalise=Capitalise;
		SavedNoFiltActive=noFiltersActive;
		SavedNoCustomAll=noCustomContainsAll[CurEmu];
		subitem=submenu[SubControlPos];
	} else
		handlemovement(&SubControlPos,&SubControlItems,&dummy,SubControlItems);
}

int makearcadeosconfig(int nType)
{
	int	n,i;
	static char	szWork[64];

	n=0;

	switch(nType)
	{
		case	0:  //general
			if(CurEmu==EMU_MAME)
				setarcconfig("Skip Nag Scrns","",&Nag,1,0,1,n++,0,CFG_INT);

	        if(CurEmu==EMU_MAME)
				setarcconfig("Legacy List Generation","",&MameLegacy,1,0,1,n++,0,CFG_INT);


			setarcconfig("Cocktail mode","",&noCocktailMode,1,0,1,n++,0,CFG_INT);
			setarcconfig("Cocktail delay","",&FlipDelay,0,0,50,n++,0,CFG_INT);
			setarcconfig("Diagonals","",&noDiagonals,1,0,1,n++,0,CFG_INT);
			for(i=0;i<3;i++)
			{
				sprintf(szWork,"Button %d",i+1);
				setarcconfig(szWork,"",&noButtonOn[i],1,0,1,n++,0,CFG_INT);
			}

			if(CurEmu==EMU_MAME)
			{
				for(i=0;i<NO_CUSTOM_LISTS;i++)
					strcpy(pszTextValues[i+CUSTOM_LIST_OFFSET],Emulators[CurEmu].szCustomList[i]);
				strcpy(pszTextValues[i+CUSTOM_LIST_OFFSET],"Don't Move");
				setarcconfig("NeoGeo C.List","",&CustNeo,1,CUSTOM_LIST_OFFSET,CUSTOM_LIST_OFFSET+NO_CUSTOM_LISTS,n++,0,CFG_INT);
				setarcconfig("Vector C.List","",&CustVector,1,CUSTOM_LIST_OFFSET,CUSTOM_LIST_OFFSET+NO_CUSTOM_LISTS,n++,0,CFG_INT);
			}
			setarcconfig("Quick Start","",&noInstantStart,1,0,1,n++,0,CFG_INT);
			if(CurEmu==EMU_MAME)
			{
				setarcconfig("Auto Disable","",&noAutoDisable,1,0,1,n++,0,CFG_INT);
				setarcconfig("Disable Imperfect","",&DisableImperfect,1,0,1,n++,0,CFG_INT);
				setarcconfig("Auto Rotate","",&nAutoRotate,1,AUTO_ROTATE_OFFSET,AUTO_ROTATE_OFFSET+2,n++,0,CFG_INT);
				setarcconfig("Easy Center","",&noEasyCenter,1,0,1,n++,0,CFG_INT);
			}
			setarcconfig("Use CRC32's","",&noUseCRC,1,0,1,n++,0,CFG_INT);
			setarcconfig("Run last game","",&StartLastGame,1,START_OFFSET,START_OFFSET+2,n++,0,CFG_INT);
			setarcconfig("FileMenu Drive","",&nFileDrive,1,FILE_OFFSET,FILE_OFFSET+25,n++,0,CFG_INT);
			break;
		case	1:  //display
			if(!BIOSCab||SupportedSVGA)
				setarcconfig("320x200 mode","",&ShadowHires,1,0,1,n++,0,CFG_INT);
			if(Hires)
				setarcconfig("Font Size","",&FontSize,1,FONT_OFFSET,FONT_OFFSET+3,n++,0,CFG_INT);
			setarcconfig("Font Shadow","",&FontShadow,0,0,2,n++,0,CFG_INT);
			nWidthIndex=n;
			setarcconfig("Main Width","",pWidthVar,0,24,ScreenOrient.maxx-2,n++,0,CFG_INT);

			if(BIOSCab==ARCADE_MODE)
			{
				setarcconfig("H.Timing","",&ArcadeH,0,100,120,n++,0,CFG_INT);
				setarcconfig("V.Timing","",&ArcadeV,0,0,60,n++,0,CFG_INT);
			}
			setarcconfig("Transparency","",&Transparent,0,0,100,n++,0,CFG_INT);
			setarcconfig("Flip X","",&noflipx,1,0,1,n++,0,CFG_INT);
			setarcconfig("Flip Y","",&noflipy,1,0,1,n++,0,CFG_INT);
			if(!Hires)
				setarcconfig("Scanlines","",&noScanLines,1,0,1,n++,0,CFG_INT);
			setarcconfig("Explode Window","",&noExplodeWin,1,0,1,n++,0,CFG_INT);
			setarcconfig("Wrap Cursor","",&noWrapMenus,1,0,1,n++,0,CFG_INT);
			break;
		case	2:  //colours
			setarcconfig("Scheme","",&Scheme,1,SCHEME_OFFSET,SCHEME_OFFSET+3,n++,0,CFG_INT);
			setarcconfig("Forecolour","",&ForeColour,0,0,15,n++,0,CFG_INT);
			setarcconfig("Extra Colour","",&ExtraColour,0,0,15,n++,0,CFG_INT);
			setarcconfig("Cursor Colour","",&CursorColour,0,0,15,n++,0,CFG_INT);
			setarcconfig("Clone Colour","",&CloneColour,0,0,15,n++,0,CFG_INT);
			setarcconfig("Disable Colour","",&DisColour,0,0,15,n++,0,CFG_INT);
			break;
		case	3: //screen shots
			setarcconfig("Rotate BD","",&noRotatePics,1,0,1,n++,0,CFG_INT);
			setarcconfig("S.Shot on run","",&noUseLastShot,1,0,1,n++,0,CFG_INT);
			setarcconfig("S.Shot on move","",&noMoveShot,1,0,1,n++,0,CFG_INT);
			setarcconfig("S.S. dir: move","",&SSMove,1,SCREEN_OFFSET,SCREEN_OFFSET+2,n++,0,CFG_INT);  // EEA Changed these 3 from noAltSS
			setarcconfig("S.S. dir: run","",&SSRun,1,SCREEN_OFFSET,SCREEN_OFFSET+2,n++,0,CFG_INT);	  // EEA
			setarcconfig("S.S. dir: info","",&SSInfo,1,SCREEN_OFFSET,SCREEN_OFFSET+2,n++,0,CFG_INT);  // EEA
			setarcconfig("Scale S.S up","",&noScaleToFit,1,0,1,n++,0,CFG_INT);
			setarcconfig("S.S Position","",&SSPosition,1,SSPOS_OFFSET,SSPOS_OFFSET+3,n++,0,CFG_INT);
			setarcconfig("Screen Tint","",&TintType,1,TINT_OFFSET,TINT_OFFSET+4,n++,0,CFG_INT);
			break;
		case	4: //information
			setarcconfig("Information","",&Information,1,INFO_OFFSET,INFO_OFFSET+4,n++,0,CFG_INT);
			if(Emulators[CurEmu].bSupportsMerged)
				setarcconfig("Merged ROMs","",&noMergedROMs[CurEmu],1,0,1,n++,0,CFG_INT);
			setarcconfig("C.List is Copy","",&noCustomContainsAll[CurEmu],1,0,1,n++,0,CFG_INT);
			if(CurEmu==EMU_MAME)
				setarcconfig("Filters Active","",&noFiltersActive,1,0,1,n++,0,CFG_INT);
			setarcconfig("Unknowns","",&noUnknowns,1,0,1,n++,0,CFG_INT);
			setarcconfig("Show Command","",&noShowCommand,1,0,1,n++,0,CFG_INT);
			setarcconfig("Trap Errors","",&Emulators[CurEmu].bNoRedirect,1,0,1,n++,0,CFG_INT);
			setarcconfig("Hide Warnings","",&noHideWarnings,1,0,1,n++,0,CFG_INT);
			setarcconfig("Show 'Run' dlg","",&noShowRun,1,0,1,n++,0,CFG_INT);
			setarcconfig("Capitalise","",&Capitalise,1,CAPITAL_NONE,CAPITAL_ALL,n++,0,CFG_INT);
			break;
		case	5: //screen saver
			setarcconfig("Saver Type","",&SaverType,1,SAVER_OFFSET,SAVER_JUKEBOX-(CurEmu==EMU_MAME?0:1),n++,0,CFG_INT);
			setarcconfig("Saver Time","",&SaverCount,0,0,360,n++,0,CFG_INT);
			setarcconfig("Shot Type","",&SaverSSType,1,SSHOT_OFFSET,SSHOT_RANDOM,n++,0,CFG_INT);
			setarcconfig("Shot delay","",&ShotDelay,0,0,360,n++,0,CFG_INT);
			if(CurEmu==EMU_MAME)
				setarcconfig("JBox Delay","",&JukeDelay,0,0,255,n++,0,CFG_INT);
			break;
		case	6: //keys
			setarcconfig("Auto Repeat","",&AutoRepeat,0,0,100,n++,0,CFG_INT);
			n=setupkeymenu(n);
			break;
		case	7: //joystick
			n=setupjoymenu(n);
			break;
		case	8: //Mouse
			setarcconfig("Mouse Type","",&nMouseType,1,MOUSE_OFFSET,MOUSE_OFFSET+3,n++,0,CFG_INT);
			switch(nMouseType)
			{
				case STANDARD_MOUSE:
					setarcconfig("Mouse Trails","",&noMouseTrails,1,0,1,n++,0,CFG_INT);
					setarcconfig("Double Click","",&nDblClick,0,0,20,n++,0,CFG_INT);
					setarcconfig("Swap Buttons","",&noSwapMouse,1,0,1,n++,0,CFG_INT);
					setarcconfig("Mouse X Sens.","",&MouseSensX,0,50,200,n++,0,CFG_INT);
					setarcconfig("Mouse Y Sens.","",&MouseSensY,0,50,200,n++,0,CFG_INT);
					break;
				case TRACKBALL_MOUSE:
					setarcconfig("Double Click","",&nDblClick,0,0,20,n++,0,CFG_INT);
					setarcconfig("Swap Buttons","",&noSwapMouse,1,0,1,n++,0,CFG_INT);
					setarcconfig("Trac Sens.","",&nMouseSens,0,-64,64,n++,0,CFG_INT);
					break;
				case SPINNER_MOUSE:
					setarcconfig("Double Click","",&nDblClick,0,0,20,n++,0,CFG_INT);
					setarcconfig("Swap Buttons","",&noSwapMouse,1,0,1,n++,0,CFG_INT);
					setarcconfig("Spin Sens.","",&nMouseSens,0,-64,64,n++,0,CFG_INT);
					break;
			}
			break;
		case	9: //shift keys
			setarcconfig("Start1+2=Esc","",&noStart12Esc,1,0,1,n++,0,CFG_INT);
			setarcconfig("Shift/Remap On","",&noShiftKeys,1,0,1,n++,0,CFG_INT);
			if(!noShiftKeys)
			{
				setarcconfig("Shift Key","",&ShiftKey,1,1,2,n++,SHIFT_OFFSET-1,CFG_INT);
				n=setupshiftmenu(n);
			}
			break;
		case	10: //sounds
			setarcconfig("Overall Volume","",&vol,0,0,15,n++,0,CFG_INT);
			setarcconfig("StartUp Volume","",&sampvol[0],0,0,15,n++,0,CFG_INT);
			setarcconfig("StartUp Pitch","",&sampfreq[0],0,0,100,n++,0,CFG_INT);
			setarcconfig("Exit Volume","",&sampvol[1],0,0,15,n++,0,CFG_INT);
			setarcconfig("Exit Pitch","",&sampfreq[1],0,0,100,n++,0,CFG_INT);
			setarcconfig("Window Volume","",&sampvol[2],0,0,15,n++,0,CFG_INT);
			setarcconfig("Window Pitch","",&sampfreq[2],0,0,100,n++,0,CFG_INT);
			setarcconfig("Error Volume","",&sampvol[3],0,0,15,n++,0,CFG_INT);
			setarcconfig("Error Pitch","",&sampfreq[3],0,0,100,n++,0,CFG_INT);
			setarcconfig("Saver Volume","",&sampvol[4],0,0,15,n++,0,CFG_INT);
			setarcconfig("Saver Pitch","",&sampfreq[4],0,0,100,n++,0,CFG_INT);
			setarcconfig("Launch Volume","",&sampvol[5],0,0,15,n++,0,CFG_INT);
			setarcconfig("Launch Pitch","",&sampfreq[5],0,0,100,n++,0,CFG_INT);
			break;
		case 11:

// LasVegas - Added ROM folder filering.

			setarcconfigdef("ROM Folder","",&filtrom[CUSTOM_LIST],0,0,10,n++,0,CFG_INT,0);

			setarcconfigdef("Horizontal","",&filthorz[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Vertical","",&filtvert[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Vector","",&filtvector[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Raster","",&filtraster[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Min Year","",&minfiltyear[CUSTOM_LIST],0,1970,2010,n++,0,CFG_INT,1970);
			setarcconfigdef("Max Year","",&maxfiltyear[CUSTOM_LIST],0,1970,2010,n++,0,CFG_INT,2010);
			setarcconfigdef("Min Players","",&minfiltplayers[CUSTOM_LIST],0,1,8,n++,0,CFG_INT,1);
			setarcconfigdef("Max Players","",&maxfiltplayers[CUSTOM_LIST],0,1,8,n++,0,CFG_INT,8);
			setarcconfigdef("Min Buttons","",&minfiltbuttons[CUSTOM_LIST],0,0,10,n++,0,CFG_INT,0);
			setarcconfigdef("Max Buttons","",&maxfiltbuttons[CUSTOM_LIST],0,0,10,n++,0,CFG_INT,10);
			setarcconfigdef("2 Way Joy","",&filtjoy2way[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("4 Way Joy","",&filtjoy4way[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("8 Way Joy","",&filtjoy8way[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Double 2 Way","",&filtdoublejoy2way[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Double 4 Way","",&filtdoublejoy4way[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Double 8 Way","",&filtdoublejoy8way[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Paddle","",&filtpaddle[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Dial","",&filtdial[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Trackball","",&filttrackball[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
			setarcconfigdef("Stick","",&filtstick[CUSTOM_LIST],1,0,1,n++,0,CFG_INT,0);
//			setarcconfigdef("Min Col. Depth","",&minfiltdepth[CUSTOM_LIST],0,0,24,n++,0,CFG_INT,0);
//			setarcconfigdef("Max Col. Depth","",&maxfiltdepth[CUSTOM_LIST],0,0,24,n++,0,CFG_INT,24);
			setarcconfigdef("Min X Res.","",&minfiltx[CUSTOM_LIST],0,0,1280,n++,0,CFG_INT,0);
			setarcconfigdef("Max X Res.","",&maxfiltx[CUSTOM_LIST],0,0,1280,n++,0,CFG_INT,1280);
			setarcconfigdef("Min Y Res.","",&minfilty[CUSTOM_LIST],0,0,1280,n++,0,CFG_INT,0);
			setarcconfigdef("Max Y Res.","",&maxfilty[CUSTOM_LIST],0,0,1280,n++,0,CFG_INT,1280);
			setarcconfigdef("Min Frequency","",&minfiltfreq[CUSTOM_LIST],0,30,75,n++,0,CFG_INT,30);
			setarcconfigdef("Max Frequency","",&maxfiltfreq[CUSTOM_LIST],0,30,75,n++,0,CFG_INT,75);
			setarcconfigdef("Min Coin","",&minfiltcoin[CUSTOM_LIST],0,1,4,n++,0,CFG_INT,1);
			setarcconfigdef("Max Coin","",&maxfiltcoin[CUSTOM_LIST],0,1,4,n++,0,CFG_INT,4);
			saveinitconfig(n);
	}
	NoCfgValues=n;

	return TRUE;
}
