#include	"main.h"
#include	"keyasm.h"
#include	"lens.h"
#include "disp.h"
#include "scrasm.h"
#include	"png.h"
#include	"scrn.h"
#include	"mouse.h"
#include	"winchar.h"
#include	"screen.h"
#include "sound.h"

static BYTE CursorBar;
static char OrientType[]="HRLXD ";
int oldmode=0;
static OLDMOUSEPOS oldmousepos[4]={{-1,-1},{-1,-1},{-1,-1},{-1,-1}};
static int oldmouseindex=0;
static int bSaveBack;
static int testpos;
pBYTE pCharSet;
pBYTE pDispSet;
static int *winscheme;
static pSNOW pSnow;
extern BYTE	DimPalette[256];


void flipscreen(int bMouse)
{
   if(bHasMouse&&bMouse&&nMouseType==STANDARD_MOUSE)
      dispmouse();

	if(Hires)
      putsvga();
	else
		put(screen,DosDataSeg);
   updatesound();
}


void dispmouse()
{
   int n;
   pBYTE   pcWork;
   static int wait=0;

	GetRealMousePos();

	pcWork=pCharSet+(WIN_CURSOR<<6);
   if(!noMouseTrails)
   {
      if(wait<8)
         wait++;
      else
      {
         for(n=0;n<4;n++)
         {
            tblit(pcWork,oldmousepos[n].oldx,oldmousepos[n].oldy,screen,2,8,8);
            if(n==3)
               tblit(pcWork,oldmousepos[n].oldx+((MouseX-oldmousepos[n].oldx)>>1),
                  oldmousepos[n].oldy+((MouseY-oldmousepos[n].oldy)>>1),screen,2,8,8);
            else
               tblit(pcWork,oldmousepos[n].oldx+((oldmousepos[n+1].oldx-oldmousepos[n].oldx)>>1),
                           oldmousepos[n].oldy+((oldmousepos[n+1].oldy-oldmousepos[n].oldy)>>1),screen,2,8,8);

         }
      }
   }
   tblit(pcWork,MouseX,MouseY,screen,-WinTrans,8,8);
   oldmousepos[oldmouseindex].oldx=MouseX;
   oldmousepos[oldmouseindex++].oldy=MouseY;
   oldmouseindex&=3;
}


void setuppat()
{
	loadpcx("chart.pcx",&pcxback);
	makepcxpal();
	setpcxpal(pcxback.palette);
	bSaveBack=bGotBack;
	bGotBack=TRUE;
}


void resetpat()
{
	memset(screen,0,ScreenOrient.memsize);
	flipscreen(FALSE);
   nLastGame[CurEmu]=-1;
	bGotBack=bSaveBack;
}



void tofromdot(int nDir)
{
	pBYTE   pBitmap;
	int	perc;


	pBitmap=myalloc(ScreenOrient.memsize);
	if(!pBitmap)
		return;

	memcpy(pBitmap,screen,(size_t)ScreenOrient.memsize);

	if(nDir>0)
      perc=1;
	else
		perc=100;


	while(perc>0&&perc<=100)
	{
      scalebitmap(screen,pBitmap,perc,ScreenOrient.xpixel,ScreenOrient.ypixel,TRUE);
		flipscreen(FALSE);
		perc+=nDir;
	}
	myfree(pBitmap);
}

void slats(void)
{
   pBYTE pBitmap;
   pBYTE pOut;
   pBYTE pIn;
   pBYTE pOut2;
   pBYTE pIn2;

	int	perc;
   int y;


	pBitmap=myalloc(ScreenOrient.memsize);
	if(!pBitmap)
		return;

	memcpy(pBitmap,screen,(size_t)ScreenOrient.memsize);

   memset(screen,BackColour,ScreenOrient.memsize);

   pOut=screen;
   pIn=pBitmap;
   pOut2=screen+(ScreenOrient.xpixel*(ScreenOrient.ypixel-1));
   pIn2=pBitmap+(ScreenOrient.xpixel*(ScreenOrient.ypixel-1));

   for(y=0;y<(ScreenOrient.ypixel>>1);y++)
   {
      memcpy(pOut,pIn,ScreenOrient.xpixel);
      memcpy(pOut2,pIn2,ScreenOrient.xpixel);

      pOut+=(ScreenOrient.xpixel<<1);
      pIn+=(ScreenOrient.xpixel<<1);
      pOut2-=(ScreenOrient.xpixel<<1);
      pIn2-=(ScreenOrient.xpixel<<1);

      flipscreen(FALSE);
   }
	myfree(pBitmap);
}



void scalebitmap(pBYTE pDest,pBYTE pSrc,int perc,int w,int h,int bCentre)
{

	int	yerror,xerror;
	int	x,y;
	int	xoff,yoff;

	unsigned int	inpos,outpos,oldin,oldout;

	if(perc==100)
	{
		memcpy(pDest,pSrc,(size_t)ScreenOrient.memsize);
		return;
	}

   memset(pDest,0,(size_t)ScreenOrient.memsize);

	inpos=0;
	if(bCentre)
	{
		yoff=(ScreenOrient.ypixel/10)*perc/10;
		xoff=(ScreenOrient.xpixel/10)*perc/10;

		outpos=((ScreenOrient.xpixel-xoff)/2)+(((ScreenOrient.ypixel-yoff)/2)*ScreenOrient.xpixel);
	}
	else
	{
		yoff=0;
		xoff=0;
		outpos=0;
	}
	yerror=0;



	for(y=0;y<h;y++)
	{
		yerror+=perc;
		while(yerror>100)
		{
			yerror-=100;
			xerror=0;
			oldout=outpos;
			oldin=inpos;
			for(x=0;x<w;x++)
			{
				xerror+=perc;
				while(xerror>100)
				{
					xerror-=100;
//               if(outpos<ScreenOrient.memsize&&inpos<ScreenOrient.memsize)
						pDest[outpos]=pSrc[inpos];
					outpos++;
				}
				inpos++;
			}
			outpos=oldout+ScreenOrient.xpixel;
			inpos=oldin;
		}
		inpos+=w;
	}
}

void setgmode(int mode)
{
	__dpmi_regs r;
   loginfo(1,"Setting mode %x",mode);
	if(mode<0x100)
		r.x.ax = mode;
	else
	{
		r.x.ax = 0x4f02;
		r.x.bx = mode;
	}
	__dpmi_int(0x10, &r);

}

void setgraphmode(int bSaveMode)
{
	 __dpmi_regs r;

//get the current screen mode
	if(bSaveMode)
	{
		oldmode=0x03;
	}


	if(Hires)
   {
      callAOSBios(SET_VESA,99,0);
		setgmode(0x101);
   }
	else
   {
      callAOSBios(SET_SCANLINES,!noScanLines,0);
		setgmode(0x13);
   }
	callAOSBios(SET_SCANLINES,0,0);
}

void callAOSBios(int fno,int val1,int val2)
{
//Call ArcadeOS's bios extensions
	__dpmi_regs r;
	r.h.ah=AOS_BIOS_FLAG;
	r.h.al=fno;
	r.h.bl=val1;
	r.h.bh=val2;
	__dpmi_int(0x10, &r);
}

void callAOSMemBios(int fno,int seg,int off,int size)
{
//Call ArcadeOS's bios extensions
	__dpmi_regs r;
	r.h.ah=AOS_BIOS_FLAG;
	r.h.al=fno;
   r.x.bx=seg;
   r.x.dx=off;
   r.x.cx=size;
	__dpmi_int(0x10, &r);
}

void writebuffertoRM(char *buffer,int cmd)
{
	unsigned long seg;
	int sel;
//allocate some space in real mode memory
   seg = __dpmi_allocate_dos_memory( 2048, &sel);
//copy our data into real mode memory
   dosmemput( buffer, strlen(buffer)+1, ((seg << 4) & 0xfffff));
//and pass it to our BIOS
   callAOSMemBios(cmd,seg,0,strlen(buffer)+1);
   __dpmi_free_dos_memory (sel);
}

int checkAOSBios(void)
{
//make sure ArcadeOS's bios extensions are in place
	__dpmi_regs r;
	r.h.ah=AOS_BIOS_FLAG;
	r.h.al=CHECK_BIOS;
	__dpmi_int(0x10, &r);

	if(r.x.bx==AOS_BIOS_PRESENT)
		return TRUE;
	return FALSE;

}

int userescape(void)
{
	__dpmi_regs r;
	r.h.ah=AOS_BIOS_FLAG;
	r.h.al=USER_ESCAPE;
	__dpmi_int(0x10, &r);

	if(r.x.bx==24)
		return TRUE;
	return FALSE;
}

int getlastmodeset(void)
{
	__dpmi_regs r;
    r.h.ah=AOS_BIOS_FLAG;
    r.h.al=LAST_MODE_SET;
	__dpmi_int(0x10, &r);

    return r.x.bx;
}


void setgraphmodeback()
{
	setgmode(oldmode);
}

int initdisp()
{
//cursor bar
	int	fx;
	CursorBar=219;
	pCharSet=myalloc(16384);
	pDispSet=myalloc(ScreenOrient.mx*ScreenOrient.fy*256);

	if(!pCharSet)
		return FALSE;

	return TRUE;


}

int getwinchars(pBYTE pWinChars)
{
	FILE	*fin;
	FILE	*fout;
	int	n;

   fin=fopen("arcadeos.fnt","rb");

	if(!fin)
		return FALSE;
	fseek(fin,20000L,SEEK_SET);
#ifdef CREATE_WIN
	fout=fopen("gui.win","wb");
#endif
	for(n=0;n<NO_WIN_CHARS;n++,pWinChars+=64)
	{
		fread(pWinChars,1,64,fin);
#ifdef CREATE_WIN
		fwrite(pWinChars,1,64,fout);
#endif
	}

	fclose(fin);
#ifdef CREATE_WIN
	fclose(fout);
#endif
	return TRUE;

}

void setscheme(void)
{
    winscheme=schemes[Scheme-SCHEME_OFFSET].scheme;
    WinTrans=schemes[Scheme-SCHEME_OFFSET].trans;
    WinColour=schemes[Scheme-SCHEME_OFFSET].win;
}

void precalcfont(void)
{
   int   pcloop;
	char	buffer[256];
   char  work;
   int   twofonts,maxy,maxx,mcpy,fx;
	FILE	*fout;
   int   outer,inner,winc;
   BYTE  cAnd,cOut;
   pBYTE pcout;
	pBYTE	pcout2;
   pBYTE romchar;
	pBYTE	pSource;
   pBYTE pFileFont;
	pBYTE	pDispFont;
	FILE	*fin;
   int x,y;

   setscheme();

	pFileFont=myalloc(2048);

	if(!pFileFont)
		return;


	pDispFont=myalloc(ScreenOrient.fsize);
	if(!pDispFont)
		return;
	fin=fopen("arcadeos.fnt","rb");
	if(!fin)
	{
		myfree(pFileFont);
		myfree(pDispFont);
		return;
	}

   fseek(fin,-11264L,SEEK_END);

	fread(pFileFont,1,2048,fin);

	fseek(fin,-ScreenOrient.fpos,SEEK_END);
	fread(pDispFont,1,ScreenOrient.fsize,fin);

	fclose(fin);
#ifdef CREATE_FONT
	fout=fopen("gui.fnt","wb");
	fwrite(pFileFont,1,2048,fout);
	fclose(fout);
#endif

	for(twofonts=0;twofonts<2;twofonts++)
	{
		if(twofonts)
		{
			pcout=pDispSet;
			maxy=ScreenOrient.fy;
         maxx=ScreenOrient.mx;
			mcpy=ScreenOrient.mx*ScreenOrient.fy;
			pSource=pDispFont;
		}
		else
		{
			pSource=pFileFont;
			pcout=pCharSet;
			maxy=8;
         maxx=8;
			mcpy=64;
		}


		for(pcloop=0;pcloop<256;pcloop++)
		{
			memset(buffer,0,mcpy);
			romchar=pSource+(pcloop*maxy);
			switch(ScreenOrient.Orientation)
			{
            case ORIENT_ROTATED_LEFT:
               for(outer=0;outer<maxy;outer++)
					{
						cAnd=128;
						for(inner=0;inner<8;inner++)
						{
							if(*romchar&cAnd)
                        buffer[((7-inner)*maxy)+outer]=1;
							cAnd>>=1;

						}
						romchar++;
					}
					break;
            case ORIENT_ROTATED_RIGHT:
					for(outer=0;outer<maxy;outer++)
					{
						cAnd=128;
						for(inner=0;inner<8;inner++)
						{
							if(*romchar&cAnd)
                        buffer[(inner*maxy)+((maxy-1)-outer)]=1;
							cAnd>>=1;
						}
						romchar++;
					}
					break;
            case ORIENT_NORMAL:
					for(outer=0;outer<maxy;outer++)
					{
						cAnd=128;
                  for(inner=0;inner<maxx;inner++)
						{
							if(*romchar&cAnd)
                        buffer[(outer*maxx)+inner]=1;
							cAnd>>=1;
                     if(cAnd==0)
                        cAnd=128;

						}
						romchar++;
					}
					break;
			}
	 		memcpy(pcout,buffer,mcpy);
			pcout+=mcpy;
		}
	}

	pcout=pCharSet+(200*64);
	getwinchars(pcout);
	for(winc=0;winc<NO_WIN_CHARS;winc++)
	{
		romchar=pcout;
		switch(ScreenOrient.Orientation)
		{
         case ORIENT_ROTATED_LEFT:
				for(outer=0;outer<8;outer++)
				{
					for(inner=0;inner<8;inner++)
                  buffer[((7-inner)<<3)+outer]=winscheme[*pcout++];
				}
				break;
         case ORIENT_ROTATED_RIGHT:
				for(outer=0;outer<8;outer++)
				{
					for(inner=0;inner<8;inner++)
                  buffer[(inner<<3)+(7-outer)]=winscheme[*pcout++];
				}
				break;
         case ORIENT_NORMAL:
				for(outer=0;outer<8;outer++)
				{
					for(inner=0;inner<8;inner++)
					{
                  buffer[(outer<<3)+inner]=winscheme[*pcout++];
					}
				}
				break;
		}
		memcpy(romchar,buffer,64);
	}

	myfree(pFileFont);
	myfree(pDispFont);
}

void clearfonts()
{
	myfree(pCharSet);
	myfree(pDispSet);
}
void drawshadow(int x,int y,int w,int h)
{
	int	pos;
	x++;
	y+=h;

	for(pos=0;pos<w;pos++)
      shadowchar(x++,y,WIN_FONT);
	x--;
	y--;

	for(pos=0;pos<h-1;pos++)
      shadowchar(x,y--,WIN_FONT);

}

void shadowchar(int x,int y,int fnt)
{
   int i,j,xmul,ymul,xoff,yoff;
   pBYTE pInOut;

   getrealxy(&x,&y,&xmul,&ymul,&xoff,&yoff,fnt);

   pInOut=(screen+(x*xmul)+xoff+(((y*ymul)+yoff)*ScreenOrient.xpixel));

   for(i=0;i<ymul;i++,pInOut+=(ScreenOrient.xpixel-xmul))
      for(j=0;j<xmul;j++,pInOut++)
         *pInOut=DimPalette[*pInOut];
}



void drawwindow(pWINSTRUCT pWin,int colour,int bShadow,int bExplode,char *szTitle)
{
	int	i,j;
	BYTE	chars[3];
	int	expos[3];
	static char stdchars[3]={(char)WIN_TOP,(char)WIN_TOP2,(char)WIN_BOTTOM};
	static char topchars[3]={(char)WIN_TOP_LEFT,(char)WIN_TOP_LEFT2,(char)WIN_BOTT_LEFT};
	static char rightchars[3]={(char)WIN_TOP_RIGHT,(char)WIN_TOP_RIGHT2,(char)WIN_BOTT_RIGHT};

	int	yend,xend;
	int	n,x,y,w,h;
	x=pWin->xtopleft;
	y=pWin->ytopleft;
	h=pWin->ybotright-y;
	w=pWin->xbotright-x;


   if(bExplode)
      soundinterface(SOUND_WINDOW);

	if(bExplode&&!noExplodeWin&&colour>=0)
	{
		n=0;
		while(w>2&&h>2)
		{
			x++;
			y++;
			w-=2;
			h-=2;
			n++;
		}

		for(i=0;i<n;i++)
		{
			clearrect(x,y,w,h,colour);
			flipscreen(FALSE);
			x--;
			y--;
			w+=2;
			h+=2;
		}
	}
	if(colour>=0)
	{
		clearrect(x,y,w,h,colour);
		if(bShadow)
			drawshadow(x,y,w,h);
	}
	else
	{
		for(i=y;i<(y+h);i++)
		{
			for(j=x;j<(x+w);j++)
            shadowchar(j,i,WIN_FONT);
		}

	}

	yend=y+h-1;
	xend=x+w-1;
	expos[0]=y;
	expos[1]=y+1;
	expos[2]=yend;
	for(i=x;i<=xend;i++)
	{
		memcpy(chars,stdchars,3);
		if(i==x)
			memcpy(chars,topchars,3);
		else
			if(i==xend)
				memcpy(chars,rightchars,3);

		for(n=0;n<3;n++)
            dispchar(i,expos[n],chars[n],WinTrans,FALSE,0,0,WIN_FONT);
	}
	for(i=y+2;i<yend;i++)
	{
        dispchar(x,i,WIN_LEFT_VERT,WinTrans,FALSE,0,0,WIN_FONT);
        dispchar(xend,i,WIN_RIGHT_VERT,WinTrans,FALSE,0,0,WIN_FONT);
	}

    dispchar(x+w-2,y,WIN_BUTTON,WinTrans,FALSE,2,4,WIN_FONT);

	if(szTitle)
		dispstring(x+1,y,szTitle,ExtraColour,TRUE,0,4,WIN_FONT);
}

void dispcentre(int y,char *data,int color,int xstart,int w,int b3D,int xoset,int yoset,int fnt)
{
	int	slen;
	int	xpos;
	slen=strlen(data);
	xpos=((w-slen)/2)+xstart;
	dispstring(xpos,y,data,color,b3D,xoset,yoset,fnt);
}

//display a given string with orientation and colour
void dispstring(int x,int y,char *data,int color,int b3D,int xoset,int yoset,int fnt)
{
   static int snd_trip=0;
	int n;

	for(n=0;n<strlen(data);n++)
		dispchar(x+n,y,data[n],color,b3D,xoset,yoset,fnt);

   snd_trip++;
   if(snd_trip==30)
   {
      snd_trip=0;
      updatesound();
   }

}
//display a given character with orientation and colour
void dispchar(int x,int y,BYTE data,int color,int b3D,int xoset,int yoset,int fnt)
{
   pBYTE pcwork;
   int fx,fy,shadx,shady,savex,w,h;
   int xmul,ymul,dbly;
   int x2off,y2off;



   getrealxy(&x,&y,&xmul,&ymul,&x2off,&y2off,fnt);
   if(fnt==WIN_FONT)
	{
		pcwork=pCharSet+(data<<6);
		h=8;
		w=8;
      dbly=0;
	}
	else
	{
		pcwork=pDispSet+(data*(ScreenOrient.mx*ScreenOrient.fy));
		h=ScreenOrient.fy;
		w=ScreenOrient.mx;
      dbly=0;
	}
	shadx=shady=1;

   switch(ScreenOrient.Orientation)
	{
      case ORIENT_ROTATED_LEFT:
         shady=-1;
			shadx=1;
			savex=xoset;
			xoset=yoset;
			yoset=-savex;
         savex=w;
         w=h;
         h=savex;
			break;
      case ORIENT_ROTATED_RIGHT:
			shadx=-1;
			shady=1;
			savex=xoset;
			xoset=-yoset;
			yoset=savex;
         savex=w;
         w=h;
         h=savex;
			break;
	}
	fx=(x*xmul)+xoset+x2off;
	fy=(y*ymul)+yoset+y2off;

	if(color>=0)
	{
		if(b3D)
		{
			switch(FontShadow)
			{
				case	2:
               blit(pcwork,fx+(shadx*2),fy+shady,screen,0,w,h,dbly);
				case	1:
               blit(pcwork,fx+shadx,fy+shady,screen,0,w,h,dbly);
			}
		}
      blit(pcwork,fx,fy,screen,(BYTE)color,w,h,dbly);
	}
	else
	{
		color=-color;
		tblit(pcwork,fx,fy,screen,(BYTE)color,w,h);
	}
}

void getrealxy(int *x,int *y,int *xmul,int *ymul,int *xoff,int *yoff,int fnt)
{
   int savex;
	if(fnt==DISP_FONT)
	{
		*xoff=ScreenOrient.xoff;
		*yoff=ScreenOrient.yoff;
	}
	else
	{
		*xoff=ScreenOrient.xwinoff;
		*yoff=ScreenOrient.ywinoff;
	}

	switch(ScreenOrient.Orientation)
	{
      case ORIENT_ROTATED_LEFT:
         if(fnt==DISP_FONT)
         {
            *ymul=ScreenOrient.fx;
            *xmul=ScreenOrient.fy;
			}
			else
			{
				*ymul=6;
				*xmul=8;
			}
         savex=*x;
			*x=*y;
			if(fnt==DISP_FONT)
				*y=(ScreenOrient.xcalc-savex);
			else
				*y=(ScreenOrient.xcalcwin-savex);
			savex=*xoff;
			*xoff=*yoff;
			*yoff=-savex;
			break;

      case ORIENT_ROTATED_RIGHT:
			if(fnt==DISP_FONT)
			{
				*ymul=ScreenOrient.fx;
            *xmul=ScreenOrient.fy;
			}
			else
			{
				*ymul=6;
				*xmul=8;
			}

			savex=*x;
			if(fnt==DISP_FONT)
				*x=(ScreenOrient.ycalc-*y);
			else
				*x=(ScreenOrient.ycalcwin-*y);

			*y=savex;
			savex=*xoff;
			*xoff=-*yoff;
			*yoff=savex;

			break;
      case ORIENT_NORMAL:
			if(fnt==DISP_FONT)
			{
            *ymul=ScreenOrient.fy;
				*xmul=ScreenOrient.fx;
			}
			else
			{
				*xmul=6;
				*ymul=8;
			}
	}
}

void clearscreen()
{
	if(bGotBack)
		fastback();
	else
		memset(screen,BackColour,ScreenOrient.memsize);

}

void dispcursorbar(int curpos,int nOffSet,int nLen,int xoff,int yoff)
{

	int	actpos,n;
   pBYTE pInOut;

	actpos=curpos-nOffSet;
   yoff+=actpos;

   for(n=0;n<nLen;n++,xoff++)
      dispchar(xoff,yoff,CursorBar,CursorColour,FALSE,0,0,DISP_FONT);
}

void dispcfgs(int nCut)
{
	char 	ccfgdis[64];
	char 	cout[64];
	int 	n,x,y,nodis;
	int 	npad,nindex;
	int	valcol;
	int	quot,rem;

	nodis=n=0;
	x=4;
	y=2;
	while(TRUE)
	{
		if(n<NoCfgValues)
		{
			nindex=n+ConfigOff;
			memset(ccfgdis,32,64);

// LasVegas - No longer use szIdent for Menu item. Use szMenu instead.

			strncpy(ccfgdis,cfgDefValues[nindex].szMenu,16);
			for(npad=strlen(ccfgdis);npad<16;npad++)
				ccfgdis[npad]=32;
			ccfgdis[nCut]=0;


			sprintf(cout,"%s:",ccfgdis);
			switch(cfgDefValues[nindex].nType)
			{
				case CFG_TYPE_MIXED:
				case CFG_TYPE_TEXT:
					safecopy(ccfgdis,pszTextValues[nCfgValues[nindex]+cfgDefValues[nindex].nOffSet],11);
					break;
				case CFG_TYPE_REAL:
					sprintf(ccfgdis,"%d.00",nCfgValues[nindex]);
					break;
				case CFG_TYPE_FLOAT:
					quot=nCfgValues[nindex]/100;
					rem=(nCfgValues[nindex]-(quot*100));

					sprintf(ccfgdis,"%d.%02d",quot,rem);
					break;
				case CFG_TYPE_CMD:
					safecopy(ccfgdis,pszTextValues[nCfgValues[nindex]],11);
					break;
				default:
					sprintf(ccfgdis,"%d",nCfgValues[nindex]);
					break;
			}
			dispstring(x,y,cout,ForeColour,TRUE,0,0,DISP_FONT);
			if(cfgDefValues[nindex].nValue==nCfgValues[nindex])
				valcol=CloneColour;
			else
				valcol=ExtraColour;
			dispstring(x+nCut+1,y,ccfgdis,valcol,TRUE,0,0,DISP_FONT);

			y++;
			nodis++;

			if(nodis>=ScreenOrient.NoOnScreen)
				break;

		}
		else
		{
			break;
		}
		n++;
	}
}


void getnicename(char *szIn,char *szOut,int nLen)
{
	int	npad;
	char	*pWork;
	char	szWork[256];
	int	nSpace;
	memset(szOut,32,64);
	szOut[63]=0;
	pWork=strstr(szIn,":");
	if(pWork)
	{
		*pWork=0;
		pWork++;
		nSpace=nLen-(strlen(szIn)+1);
		if(nSpace>0)
		{
			copylastn(pWork,szWork,nSpace);
			sprintf(szOut,"%s:%s",szIn,szWork);
		}
		else
		{
			strcpy(szOut,szIn);
		}
		pWork--;
		*pWork=':';


	}
	else
		strncpy(szOut,szIn,nLen);
//pad it and terminate it
	for(npad=strlen(szOut);npad<nLen;npad++)
		szOut[npad]=32;

	szOut[nLen]=0;

}

void copylastn(char *szIn,char *szOut,int nNo)
{
	char	*pWork;
	char	szWork[128];
	int	n;

	if(!*szIn)
	{
		*szOut=0;
		return;
	}
	strcpy(szWork,szIn);
//get rid of any spaces at the end of the string
	pWork=&szWork[strlen(szWork)-1];
	while(isspace(*pWork)&&pWork>szWork)
		pWork--;
	if(isspace(*pWork))
		*pWork=0;
//get nNo chars from the end of the string
	for(n=0;n<nNo;n++)
	{
		pWork--;
		if(pWork==szWork)
			break;
	}
//try and land on a complete word
	while(isspace(*pWork))
		pWork++;
	if(pWork!=szWork&&!isspace(*(pWork-1)))
	{
		while(TRUE)
		{
			if(!*pWork)
				break;
			if(isspace(*pWork))
			{
				pWork++;
				break;
			}
			pWork++;
		}
	}
//copy to the output
	strcpy(szOut,pWork);
}

void dispgames(void)
{
   char cgamedis[128];
   char cout[128];
   int nTLen;
   int n,x,y;
   int nreal,nTagColour,nGameColour;

	x=1;
	y=2;

	nTLen=ScreenOrient.DispWidth;
//display a screen full
	for(n=0;n<ScreenOrient.NoOnScreen;n++)
	{
      nreal=n+OffSet[CurEmu];

      if(n+OffSet[CurEmu]>=Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION])
			break;

		getnicename(pMameGames[nreal].szDispName,cgamedis,nTLen);
		if(pMameGames[nreal].bLocalConfig)
			nTagColour=ExtraColour;
		else
			nTagColour=ForeColour;

		if((pMameGames[nreal].nGameType&128))
			nGameColour=CloneColour;
		else
			nGameColour=ForeColour;

		if((pMameGames[nreal].Orientation&7)==4)
			nGameColour=DisColour;

      if(Information<INFO_OFFSET+2||!Emulators[CurEmu].bSupportsRotation)
			dispstring(x,y,cgamedis,nGameColour,TRUE,0,0,DISP_FONT);
		else
		{
			strcat(cgamedis,"-");
			dispstring(x,y,cgamedis,nGameColour,TRUE,0,0,DISP_FONT);
			sprintf(cout,"%c",OrientType[pMameGames[nreal].Orientation&7]);
			dispstring(x+nTLen+1,y,cout,nTagColour,TRUE,0,0,DISP_FONT);
		}
		y++;
		if(y>=ScreenOrient.maxy)
			break;
	}

}

int drawscrollbar(pWINSTRUCT pWinStruct,int *pos,int max,int ControlState)
{
   int n,cx,cy,ncol;
   int blockpos;
   int sspace;
   long iwork;
   int spos;
   int quot,rem;
   int x,y,h,col;

   x=pWinStruct->xbotright-2;
   y=pWinStruct->ytopleft+2;
   h=(pWinStruct->ybotright-(pWinStruct->ytopleft+4));

	if(ControlState&CTRL_SCROLLUP)
	{
		n=7;
		cx=1;
		cy=1;
	}
	else
	{
      n=WinTrans;
		cx=1;
		cy=0;
	}


//scroll position
	sspace=h-2;
	iwork=(long)(((long)sspace*800)/(max-1));
   spos=(int)(long)(((long)(*pos)*iwork)/100);


	quot=spos>>3;
	rem=(spos-(quot<<3));
   quot+=y;



   if(pWinStruct->ScrollDrag!=WM_SCROLLDRAG_NONE)
   {
      long work;
      spos=(pWinStruct->NewScrollPos-pWinStruct->ScrollOffset)+((pWinStruct->ytopleft+1)<<3);
      quot=spos>>3;
      rem=(spos-(quot<<3));
      work=((quot-y)<<3)+rem;
      *pos=((int)((work*(long)100)/iwork)+1);
   }





	dispchar(x,y,WIN_UP,n,FALSE,cx,cy,WIN_FONT);


	for(n=1;n<h;n++)
   {
      col=WinTrans;
      if(pWinStruct->flashup&&((y+n)<=(quot+1)))
         col=8;
      if(pWinStruct->flashdown&&((y+n)>(quot+1)))
         col=8;

      dispchar(x,y+n,WIN_STRIPE,col,FALSE,1,0,WIN_FONT);
   }

	if(ControlState&CTRL_SCROLLDOWN)
	{
		ncol=7;
		cx=1;
		cy=1;
	}
	else
	{
      ncol=WinTrans;
		cx=1;
		cy=0;
	}

	dispchar(x,y+n,WIN_DOWN,ncol,FALSE,cx,cy,WIN_FONT);


   dispchar(x,quot+1,WIN_POS,WinTrans,FALSE,1,rem,WIN_FONT);

	blockpos=rem+((quot+1)<<3);
   if(pWinStruct->flashup)
      pWinStruct->flashup--;

   if(pWinStruct->flashdown)
      pWinStruct->flashdown--;

	return blockpos;

}
void clearrect(int x,int y,int width,int height,int color)
{
	int 		n,xmul,ymul;
	int 		save;
	int		xend,yend,xoff,yoff;
	pBYTE   pOut;


	xend=x+width;
	yend=y+height;
   getrealxy(&x,&y,&xmul,&ymul,&xoff,&yoff,WIN_FONT);
   getrealxy(&xend,&yend,&xmul,&ymul,&xoff,&yoff,WIN_FONT);

	if(xend<x)
	{
		save=x;
		x=xend+1;
		xend=save+1;
	}
	if(yend<y)
	{
		save=y;
		y=yend+1;
		yend=save+1;
	}

	width=xend-x;
	height=yend-y;

	width*=xmul;
	y*=ymul;
	x*=xmul;
	y+=yoff;
	x+=xoff;
	height*=ymul;
	pOut=screen+x+(y*ScreenOrient.xpixel);
	for(n=0;n<height;n++)
	{
		memset(pOut,color,width);
		pOut+=ScreenOrient.xpixel;
	}
}

void setbackdrop()
{
	bGotBack=getbackdrop();
	if(bGotBack)
	{
		memset(screen,0,(size_t)ScreenOrient.memsize);
		flipscreen(FALSE);
		makepcxpal();
	}
}

void melt()
{
   char  *pTemp;
   pBYTE   pWork;
   char  *pIn;

   int nolines;
	int	n,off;
	int	perc[640];
	int	x,y,error;
	int	nslap=0;
	int	maxoff;


	for(n=0;n<ScreenOrient.xpixel;n++)
		perc[n]=100;

    switch (ScreenOrient.Orientation)
    {
        case ORIENT_ROTATED_LEFT:
        case ORIENT_ROTATED_RIGHT:
            nolines=ScreenOrient.ypixel;
            maxoff=ScreenOrient.xpixel;
            break;
        default:
            maxoff=ScreenOrient.ypixel;
            nolines=ScreenOrient.xpixel;
            break;

	}

	pTemp=myalloc(ScreenOrient.memsize);
	if(!pTemp)
	{
		return;
	}

	memcpy(pTemp,screen,ScreenOrient.memsize);
	memset(screen,0,ScreenOrient.memsize);


	n=0;
	while(TRUE)
	{
		fastback();
		if(nslap==nolines)
			break;

		switch(ScreenOrient.Orientation)
		{
			case	ORIENT_ROTATED_LEFT:
			case	ORIENT_ROTATED_RIGHT:
				for(y=0;y<ScreenOrient.ypixel;y++)
				{
					if(ScreenOrient.Orientation==ORIENT_ROTATED_LEFT)
						off=(ScreenOrient.xpixel-((ScreenOrient.xpixel*perc[y])/100));
					else
						off=0;
					if(off<maxoff)
					{
						pWork=screen+off+(y*ScreenOrient.xpixel);
						error=0;
						pIn=pTemp+(y*ScreenOrient.xpixel);

						for(x=0;x<ScreenOrient.xpixel;x++)
						{
							error+=perc[y];
							if(error>100)
							{
								error-=100;
								*pWork=*pIn;
								pWork++;
							}
							pIn++;

						}
					}

					if(perc[y])
					{
                        perc[y]-=1+random()%4;
						if(perc[y]<=0)
						{
							nslap++;
							perc[y]=0;
						}
					}
				}

				break;
            case ORIENT_NORMAL:
				for(x=0;x<ScreenOrient.xpixel;x++)
				{

               off=(ScreenOrient.ypixel-(perc[x]<<1));

					if(off<maxoff)
					{
						pWork=screen+x+(off*ScreenOrient.xpixel);
						error=0;
						pIn=pTemp+x;

						for(y=0;y<ScreenOrient.ypixel;y++)
						{
							error+=perc[x];
							if(error>100)
							{
								error-=100;
									*pWork=*pIn;
								pWork+=ScreenOrient.xpixel;
							}
							pIn+=ScreenOrient.xpixel;

						}
					}
					if(perc[x])
					{
						perc[x]-=1+rand()%4;
						if(perc[x]<=0)
						{
							nslap++;
							perc[x]=0;
						}
					}
				}
		}
		if(++n>(ScreenOrient.ypixel/4))
			break;

		flipscreen(FALSE);
	}

	myfree(pTemp);
}

int allocpcx()
{
	pcxback.image=myalloc(ScreenOrient.memsize);
	if(pcxback.image)
	{
		memset(pcxback.image,0,ScreenOrient.memsize);
		return TRUE;
	}
	return FALSE;
}


void freepcx()
{
	if(pcxback.image)
		myfree(pcxback.image);
}

void testpatterns()
{
	int	x,y;
	switch(testpos)
	{
		case 0:	//red screen
			memset(screen,4,ScreenOrient.memsize);
			break;
		case 1:	//green screen
			memset(screen,2,ScreenOrient.memsize);
			break;
		case 2:	//blue screen
			memset(screen,1,ScreenOrient.memsize);
			break;
		case 3:	//rug pattern
			memset(screen,0,ScreenOrient.memsize);
			for(y=0;y<ScreenOrient.ypixel;y+=20)
				memset(screen+(ScreenOrient.xpixel*y),7,ScreenOrient.xpixel);
			for(x=0;x<ScreenOrient.xpixel;x+=20)
			{
				for(y=0;y<ScreenOrient.ypixel;y++)
					screen[x+(ScreenOrient.xpixel*y)]=7;
			}
			break;
	}

}

void resettest()
{
	testpos=3;
}

void nexttest()
{
	if(keys[K_B1])
	{
		testpos++;
		testpos &= 3;
	}
}


void allocsnow(void)
{
   int i,j;
   pSnow=myalloc(sizeof(SNOW)*SNOW_FLAKES);
   for(i=0;i<3;i++)
   {
      for(j=0;j<100;j++)
      {
         pSnow[(i*100)+j].x=random()%ScreenOrient.xpixel;
         pSnow[(i*100)+j].y=random()%ScreenOrient.ypixel;
         pSnow[(i*100)+j].speed=i+1+random()%4;
      }
   }
}

void drawsnow(void)
{
   pBYTE pWork;
   int i;
   for(i=0;i<SNOW_FLAKES;i++)
   {
      pWork=screen+pSnow[i].x+(pSnow[i].y*ScreenOrient.xpixel);
      *pWork=15;
      switch(ScreenOrient.Orientation)
      {
         case ORIENT_ROTATED_LEFT:
            pSnow[i].x+=pSnow[i].speed;
            if(pSnow[i].x>=ScreenOrient.xpixel)
            {
               pSnow[i].x=0;
               pSnow[i].y=random()%ScreenOrient.ypixel;
            }
            break;
         case ORIENT_ROTATED_RIGHT:
            pSnow[i].x-=pSnow[i].speed;
            if(pSnow[i].x<=0)
            {
               pSnow[i].x=0;
               pSnow[i].y=random()%ScreenOrient.ypixel;
            }
            break;
         default:
            pSnow[i].y+=pSnow[i].speed;
            if(pSnow[i].y>=ScreenOrient.ypixel)
            {
               pSnow[i].y=0;
               pSnow[i].x=random()%ScreenOrient.xpixel;
            }
      }
   }
}

void freesnow(void)
{
   myfree(pSnow);
}
