#include "main.h"
#include "keyasm.h"
#include "emu.h"
#include "launch.h"
#include "disp.h"

int	NoNonGameDirs;
//#define FILE_CHECK

static char	szRMBuffer[16384];
static int	nRMFile;

void openlogfile()
{
	char	szWork[64];

	strcpy(szWork,(nClearLog && !ReRun )?"wt":"at");
	fLogFile=fopen("ArcadeOS.LOG",szWork);

	if(ReRun)
	{
		if(nLogging<0)
			loginfo(-2,"F%s|%s",szReturnGame,getlogstamp(szWork));
		else
			loginfo(0,">>Stop  Game<< %s ::%s",szReturnGame,getlogstamp(szWork));
	} else if(nLogging<0)
		loginfo(-2,"s|%s",getlogstamp(szWork));
	else
		loginfo(0,"--- ArcadeOS Log File Start : %s ---",getlogstamp(szWork));
}

void closelogfile()
{
	char	szWork[64];

	if(!RunningGame)
	{
	      if(nLogging<0)
			loginfo(-2,"f|%s",getlogstamp(szWork));
		else
			loginfo(0,"--- ArcadeOS Log File End : %s ---",getlogstamp(szWork));
		fclose(fLogFile);
	}
}


char *getlogstamp(char *szOut)
{
	struct date	d;
	struct time	t;
	char	cTemp;

	gettime(&t);
	getdate(&d);

	if(nLogDate)
	{
		cTemp=d.da_day;
		d.da_day=d.da_mon;
		d.da_mon=cTemp;
	}
	if(nLogging<0)
		sprintf(szOut,"%04d%02d%02d%02d%02d%02d",
			d.da_year,d.da_mon,d.da_day,t.ti_hour, t.ti_min, t.ti_sec);
	else
		sprintf(szOut,"%02d/%02d/%d : %02d:%02d:%02d",
			d.da_mon,d.da_day,d.da_year,t.ti_hour, t.ti_min, t.ti_sec);
	return szOut;
}

void makefullpath(char *szIn,char *szOut,int nEmu)
{
	checkpath(szIn);
//check for root
	if(*szIn=='.')
		*szIn=0;

//is it a relative path ??
	if(szIn[0]=='\\' || szIn[1]==':')
//nope, it's absolute
		strcpy(szOut,szIn);
	else
//relative path
		sprintf(szOut,"%s%s",Emulators[nEmu].szPath,szIn);
}

void checkrmsfiles()
{
	char	szHeader[RMS_HEAD_SIZE];
	pGETFILE	pRMSFiles;

	char	szName[16];
	int	noFiles=0;
	int	n;
	FILE	*fIn;

	pRMSFiles=myalloc(sizeof(GETFILE)*64);
	if(!pRMSFiles)
		return;

	getallfiles(pRMSFiles,&noFiles,"*.rms",FA_ARCH,GAME_TYPE_FILE,0,64);
	if(noFiles)
	{
		for(n=0;n<noFiles;n++)
		{
			sprintf(szName,"%s.rms",pRMSFiles[n].FileName);
			fIn=fopen(szName,"rb");
			if(fIn)
			{
				fread(szHeader,1,RMS_HEAD_SIZE,fIn);
				fclose(fIn);

				if(memcmp(szHeader,RMSFORMAT,RMS_HEAD_SIZE))
					convertrmsfile(szName,szHeader);
			}
		}
	}
	myfree(pRMSFiles);
	return;
}

void convertrmsfile(char *szName,char *szHeader)
{
	FILE	*fIn;
	FILE	*fOut;
//	int	nReIndex[39]={0,1,2,3,4,5,6,7,8,9,10,
//				11,12,13,14,16,18,20,22,23,24,
//				25,26,27,28,29,30,31,32,33,34,
//				35,36,37,38,39,40,41,42};
	char	buffer[1024];
	int	n;

//slow but we only do it once.
	MAMEGAME	mamegame;
	OLDMAMEGAME	oldmamegame;


	printf("converting RMS File '%s'\n",szName);
	fIn=fopen(szName,"rb");
	if(!fIn)
		return;
	if(memcmp(szHeader,RMSFORMAT1,RMS_HEAD_SIZE)!=0)
	{
//format is too old - so just delete it
		fclose(fIn);
		unlink(szName);
		return;

	}
	fOut=fopen("a$.rms","wb");
	if(!fOut)
	{
		fclose(fIn);
		return;
	}
	fread(buffer,1,RMS_HEAD_SIZE,fIn);
//header info
	fwrite(RMSFORMAT,1,RMS_HEAD_SIZE,fOut);

	while(TRUE)
	{
		memset(&mamegame,0,sizeof(MAMEGAME));
		if(fread(&oldmamegame,sizeof(OLDMAMEGAME),1,fIn)<=0)
			break;
		fgetpos(fOut,&mamegame.fFilePos);
//copy across the easy stuff
		strcpy(mamegame.GameName,oldmamegame.GameName);
		strcpy(mamegame.szDispName,oldmamegame.szDispName);
//		*mamegame.szExtension=0;					// LasVegas - No longer initialized
//		*mamegame.szParent=0;						// LasVegas - No longer initialized
		strcpy(mamegame.szExtension,oldmamegame.szExtension);	// LasVegas - Now just copied
		strcpy(mamegame.szParent,oldmamegame.szParent);		// LasVegas - Now just copied
		mamegame.Orientation=oldmamegame.Orientation;
		mamegame.SaveOrient=oldmamegame.SaveOrient;
		mamegame.nGameType=oldmamegame.nGameType;
		mamegame.bRomFolder=1;						// LasVegas - New Addition
		mamegame.bLocalConfig=oldmamegame.bLocalConfig;
/*now check for a local config                             LasVegas - Secton Removed.
		if(!strcmpi(szName,"MAME.RMS"))
		{
// write in the new 'on by default' values
			mamegame.nConfigs[15]=1;
			mamegame.nConfigs[17]=1;
			mamegame.nConfigs[19]=1;
			mamegame.nConfigs[21]=1;

			if(oldmamegame.bLocalConfig)
// reindex the offsets
				for(n=0;n<39;n++)
					mamegame.nConfigs[nReIndex[n]]=oldmamegame.nConfigs[n];
		} else
		{
non MAME, so just copy it across                           LasVegas - End of Removal */
			memcpy(mamegame.nConfigs,oldmamegame.nConfigs,sizeof(int)*MAX_CFGS);
//		}
		fwrite(&mamegame,sizeof(MAMEGAME),1,fOut);

	}
	fclose(fIn);
	fclose(fOut);
	unlink(szName);
	rename("a$.rms",szName);
}

//just makes a massive list of unique game file names
//dirs,zips and file patterns
int makegamelist(pGETFILE pfGameFiles,int *pNoGames,int MaxGames)
{
	char	szWork[256];
	char	szWork2[256];
	char	buffer[1024];
	char	*pWork;
	int	m,n,nodirs,nopats;


	*pNoGames=0;

//read in the games

//check for the simple single game
	if(*Emulators[CurEmu].szSingle && CurEmu!=EMU_MAME)
	{
		*pNoGames=1;
		loginfo(1,"Getting single game %s, Path # 1.",Emulators[CurEmu].szSingle);
		strcpy(pfGameFiles->FileName,Emulators[CurEmu].szSingle);
		return 1;
	}

//is it just a file pattern ?
	if(*Emulators[CurEmu].szPattern && CurEmu!=EMU_MAME)
	{
		nopats=getitemcount(Emulators[CurEmu].szPattern,';');
		loginfo(1,"Total Number of ROM patterns=%d", nopats);
		for(n=0;n<nopats;n++)
		{
			getitem(szWork2,Emulators[CurEmu].szPattern,n,255,';');
			sprintf(buffer,"%s%s",Emulators[CurEmu].szPath,szWork2);
			loginfo(1,"Getting ROMs of pattern %s, Path # %d.",buffer,n+1);
			getallfiles(pfGameFiles,pNoGames,buffer,FA_ARCH,GAME_TYPE_FILE,n+1,MaxGames);
		}
	}
//are we doing directories ?
	if(Emulators[CurEmu].bDirectories && CurEmu!=EMU_MAME)
	{
		sprintf(buffer,"%s*.",Emulators[CurEmu].szPath);
		loginfo(1,"Getting ROM folders from %s, Path # 1.",buffer);
		getallfiles(pfGameFiles,pNoGames,buffer,FA_DIREC,GAME_TYPE_DIR,1,MaxGames);
	}
//and zip files ?
	if(Emulators[CurEmu].bZipFiles)
	{
//		loginfo(1,"Getting ZIP files from %s, Path # 1.",buffer);
//		getallfiles(pfGameFiles,pNoGames,buffer,FA_ARCH,GAME_TYPE_ZIP,1,MaxGames);
		if(*Emulators[CurEmu].szZipPath)
		{
			strcpy(szWork,Emulators[CurEmu].szZipPath);
			checkpath(szWork);
		} else
			*szWork=0;

		sprintf(buffer,"%s*.zip",szWork);

		loginfo(1,"Getting ZIP files from %s, Path # 1.",buffer);
		getallfiles(pfGameFiles,pNoGames,buffer,FA_ARCH,GAME_TYPE_ZIP,1,MaxGames);
	}
//did we get a ROMS directory ?
	if(*Emulators[CurEmu].szRomsDir)
	{
		if(Emulators[CurEmu].szRomsDir[strlen(Emulators[CurEmu].szRomsDir)-1]==';')
			Emulators[CurEmu].szRomsDir[strlen(Emulators[CurEmu].szRomsDir)-1]=0;
		nodirs=getitemcount(Emulators[CurEmu].szRomsDir,';');
		loginfo(1,"Total Number of ROM Paths=%d", nodirs);
		for(n=0;n<nodirs;n++)
		{
//get the directory
			pWork=getitem(szWork2,Emulators[CurEmu].szRomsDir,n,255,';');

			strcpy(szWork,pWork);
			checkpath(szWork);
			if(Emulators[CurEmu].bDirectories)
			{
				sprintf(buffer,"%s*.",szWork);
//read in directories hanging off it
				loginfo(1,"Getting ROM folders from %s, Path # %d.",buffer,n+1);
				getallfiles(pfGameFiles,pNoGames,buffer,FA_DIREC,GAME_TYPE_DIR,n+1,MaxGames);
			}
			if(Emulators[CurEmu].bZipFiles)
			{
				sprintf(buffer,"%s*.zip",szWork);
				loginfo(1,"Getting ROM zips from %s, Path # %d.",buffer,n+1);
				getallfiles(pfGameFiles,pNoGames,buffer,FA_ARCH,GAME_TYPE_ZIP,n+1,MaxGames);
			}
			if(*Emulators[CurEmu].szPattern)
			{
				nopats=getitemcount(Emulators[CurEmu].szPattern,';');
				for(m=0;m<nopats;m++)
				{
					getitem(szWork2,Emulators[CurEmu].szPattern,m,255,';');
					sprintf(buffer,"%s%s",Emulators[CurEmu].szPath,szWork2);
					loginfo(1,"Getting ROM patterns from %s, Path # %d.",buffer,n+1);
					getallfiles(pfGameFiles,pNoGames,buffer,FA_ARCH,GAME_TYPE_FILE,n+1,MaxGames);
				}
			}
		}
	}
	return *pNoGames;
}

void safecopy(char *dest,char *src,int nlen)
{
	strncpy(dest,src,nlen);
	dest[nlen-1]=0;
}

int safenum(char *in)
{
	char	szWork[32];

	safecopy(szWork,in,32);
	szWork[31]=0;
	return atoi(szWork);
}

void changeslash(char *path)
{
	while(path&&*path)
	{
		if(*path=='/')
			*path='\\';
		path++;
	}
}

void checkpath(char *path)
{
	changeslash(path);

	if(path && *path && path[strlen(path)-1]!='\\')
		strcat(path,"\\");
}

int setconfigfile(int bEmuIni,int nEmu,char *out)
{
	char	*pWork;
	int	nWriteTo;

	*out=0;
	nWriteTo=bEmuIni?WTINI_EMULATOR:Emulators[nEmu].nWriteToIni;

	switch(nWriteTo)
	{
		case	WTINI_EMULATOR:	//emulators ini file
			sprintf(out,"%s%s",Emulators[nEmu].szPath,Emulators[nEmu].szIni);
			break;
		case	WTINI_LOCAL:	//local ini file
//make a local name
			strcpy(out,Emulators[nEmu].szExe);
//find the .
			pWork=strstr(out,".");
			if(pWork)
				*pWork=0;
//and put in our extension
			strcat(out,".mnu");
			break;
		default:		//no ini file
			return FALSE;
	}
	return TRUE;
}

void writeemucfg(int bVirtual,int startstop)
{
	FILE	*ftemp=0;
	FILE	*menucfg;
	FILE	*fMame;
	int	n,bComment,nValsLeft,nValue;
	static char	szCFGFile[1024];
	static char	szTFile[512];
	static char	buffer[1024];
	static char	szTemp[512];
	int	quot,rem,bSection;

	if(startstop)
		clearsoundinterface();

//check for a local only copy
//i.e. ArcadeOS writes options as args, but we want to save default values
	if(!Emulators[CurEmu].nWriteToIni)
	{
//virtual makes no sense when there's no INI file
		if(bVirtual && startstop)
		{
			initsoundinterface();
			return;
		}
	} else
	{
		if(bVirtual)
	      {
			fopenRM(SET_CONFIG);
			*szTFile=0;
		}
		else
		{
			strcpy(szTFile,Emulators[CurEmu].szPath);	//LasVegas - put in emu dir.
			strcat(szTFile,"a$$tmp.cfg");
			if((ftemp=fopen(szTFile,"wt"))==NULL)
			{
				printf("Failed to open temp file :%s for writing\n",szTFile);
				if(startstop)
				initsoundinterface();
				return;
			}
		}
		if(!setconfigfile(FALSE,CurEmu,buffer))
		{
			if(!bVirtual)
				fclose(ftemp);
			if(startstop)
				initsoundinterface();
			return;
		}
		strcpy(szCFGFile,buffer);

		menucfg=fopen(buffer,"rt");
		nValsLeft=NoCfgValues;

		for(n=0;n<NoCfgValues;n++)		// Ignore "EXE" Setting.
		{
			if(!strcmpi(cfgDefValues[n].szIdent,"exe"))
			{
				cfgDefValues[n].bWritten=TRUE;
				--nValsLeft;
			} else
				cfgDefValues[n].bWritten=FALSE;
		}

// do we have an existing file ?
		if(menucfg)
		{
			bSection=FALSE;
			while(fgets(buffer,1024,menucfg)!=NULL)	// Read config file line
			{
				strlwr(buffer);		// convert to lower case
// check for a comment
				bComment=FALSE;
// Is there a comment char?
				if(*Emulators[CurEmu].szCommentChar && strstr(buffer,Emulators[CurEmu].szCommentChar)) // Comment line?
					bComment=TRUE;

//				if(CurEmu==EMU_MAME)
				if(strstr(Emulators[CurEmu].szIni,"mame.cfg"))	// LasVegas - More Specific
				{
// Currenly in config section & is config here?
					if(!bSection && strstr(buffer,"[config]"))
						bSection=TRUE;
				} else
					bSection=TRUE;

				if(!bComment&&bSection&&nValsLeft>0)     // Do we have more to do?
				{
					for(n=0;n<NoCfgValues;n++)  // Let's go through the list
					{
						if(!cfgDefValues[n].bWritten)        // LasVegas - Don't do it if already done
						{
//is this our line ?
							if(Emulators[CurEmu].bIniUsesMinus) // Do we use "-" delimiter?
								sprintf(szTemp,"-%s",cfgDefValues[n].szIdent);
							else
								strcpy(szTemp,cfgDefValues[n].szIdent);

							strcat(szTemp," ");	// LasVegas - add space delimiter
							if(strstr(buffer,szTemp)!=NULL)
							{
//yep, so replace the value
//build up the stem
//do we need - ?
								*szTemp=0;
								if(Emulators[CurEmu].bIniUsesMinus)
									strcpy(szTemp,"-");
//put in the value
								strcat(szTemp,cfgDefValues[n].szIdent);
//do we need =?
								strcat(szTemp,Emulators[CurEmu].bIniUsesEqual?" = ":" ");
//now the type of value
								nValue=cfgDefValues[n].nValue;
								switch(cfgDefValues[n].nType)
								{
									case CFG_TYPE_TEXT:
										sprintf(buffer,"%s%s\n",szTemp,pszTextValues[nValue]);
										break;
									case CFG_TYPE_REAL:
										sprintf(buffer,"%s%d.000000\n",szTemp,nValue);
										break;
									case CFG_TYPE_SPECIAL:
										sprintf(buffer,"%s%s\n",szTemp,cfgDefValues[n].szCommands);
										break;
									case CFG_TYPE_FLOAT:
										quot=nValue/100;
										rem=(nValue-(quot*100));
										sprintf(buffer,"%s%d.%02d00\n",szTemp,quot,rem);
										break;
									case CFG_TYPE_MIXED:
										nValue-=cfgDefValues[n].min;
									default:
										sprintf(buffer,"%s%d\n",szTemp,nValue);
								}
								cfgDefValues[n].bWritten=TRUE;
								nValsLeft--;
								break;
							}
						}
					}
				}
//write out the string
				strlwr(buffer);
				if(bVirtual)
					fprintfRM(buffer);
				else
					fprintf(ftemp,buffer);
			}
			fclose(menucfg);
			if(bVirtual)
				fcloseRM();
			else
			{
				fclose(ftemp);
				strcpy(szTemp,Emulators[CurEmu].szPath);
				strcat(szTemp,"backup.cfg");
				unlink(szTemp);
				rename(szCFGFile,szTemp);
				rename(szTFile,szCFGFile);
			}
		}
	}
//get rid of our temp file
	if(!bVirtual)
		unlink(szTFile);
	if(startstop)
		initsoundinterface();
}

int gotconfig(char *line,char *ident)
{
	char 	*pWork;
	char	*pUpLine;
	char	*pUpIdent;

	if(*Emulators[CurEmu].szCommentChar && strstr(line,Emulators[CurEmu].szCommentChar))
		return FALSE;

	pUpLine=strlwr(line);
	pUpIdent=strlwr(ident);
	pWork=strstr(pUpLine,pUpIdent);

	if(pWork)
	{
		if(pWork==pUpLine)
			return TRUE;

		pWork--;
		if(isspace(*pWork) || *pWork=='-')
			return TRUE;
	}
	return FALSE;
}

int readinival(char *szIdent,char *out,int nBSize,int nEmu)
{
	FILE	*fMame;
	char	*pWork1;
	char	*pWork2;
	int	nRet=FALSE;
	static char	szTemp[128];
	static char	buffer[1024];


	*out=0;
	if(!szIdent || !*szIdent)
		return nRet;

//check for a '@', it's a real value, not an ini value
	if(*szIdent=='@')
	{
		szIdent++;
		safecopy(out,szIdent,nBSize);
		return TRUE;
	}
	if(!setconfigfile(TRUE,nEmu,buffer))
		return nRet;

	fMame=fopen(buffer,"rt");

	if(fMame)
	{
		pWork1=strupr(szIdent);
		while(tidyget(buffer,1023,fMame)!=NULL)
		{
			pWork2=strupr(buffer);
			while(isspace(*pWork2)&&*pWork2)
				pWork2++;

			if((strstr(pWork2,"#")!=pWork2)&&strstr(pWork2,pWork1))
			{
				getemuvalue(buffer,szTemp,1024,nEmu);

				safecopy(out,szTemp,nBSize);

				nRet=TRUE;
				break;
			}
		}
		fclose(fMame);
	}
	return nRet;
}

void setupexe(int xindex)
{
	char	szExe[256];
	char	*pWork;
	int	n,found;

//setup what we know
	cfgDefValues[xindex].nDefault=3;
	cfgDefValues[xindex].min=3;
	cfgDefValues[xindex].max=7;
	cfgDefValues[xindex].bFound=TRUE;
	cfgDefValues[xindex].nOffSet=0;
//and save the index
	ExeIndex=xindex;
//get the exe name from the config file
	strcpy(szExe,Emulators[EMU_MAME].szExe);

//knock of the .exe
	pWork=strstr(szExe,".");
	if(pWork)
		*pWork=0;

//one of the defaults ?
	found=FALSE;
	for(n=3;n<8;n++)
	{
		if(!strcmpi(pszTextValues[n],szExe))
		{
			found=TRUE;
			cfgDefValues[xindex].nValue=n;
			break;
		}
	}
	if(!found)
	{
//not a default value, so copy it in and set in
		safecopy(pszTextValues[3],szExe,11);
		cfgDefValues[xindex].nValue=3;
	}
	nCfgValues[xindex]=cfgDefValues[xindex].nValue;
}

void localinifile(char *buffer)
{
	char	*pWork;

	sprintf(buffer,"%s%s",szStartDir,Emulators[CurEmu].szExe);
	pWork=strstr(buffer,".");
	if(pWork)
		*pWork=0;
	strcat(buffer,".lfg");
}

int readcfgvals(void)
{
	int	n,i;
	FILE	*fMame;
	char	szWork2[16];
	static char	szSave[256];
	static char	buffer[1024];
	static char	szWork[256];

	char	*pWork;
	int	nWork;

	ExeIndex=-1;
//set to defaults
	for(n=0;n<NoCfgValues;n++)
	{
		cfgDefValues[n].nValue=cfgDefValues[n].nDefault;
		nCfgValues[n]=cfgDefValues[n].nDefault;
		cfgDefValues[n].bFound=FALSE;
		if(!strcmpi(cfgDefValues[n].szIdent,"exe"))
			setupexe(n);
	}

//check for a local copy
//i.e. ArcadeOS writes options as args, but we want to save default values
	if(Emulators[CurEmu].nWriteToIni)
	{
//normal write to INI setup
		if(!setconfigfile(FALSE,CurEmu,buffer))
		return TRUE;

		fMame=fopen(buffer,"rt");
		if(fMame)
		{
			while(tidyget(buffer,1023,fMame)!=NULL)
			{
				strcpy(szSave,buffer);
				for(n=0;n<NoCfgValues;n++)
				{
					if(!cfgDefValues[n].bFound&&gotconfig(buffer,cfgDefValues[n].szIdent))
					{
						cfgDefValues[n].bFound=TRUE;
						getemuvalue(buffer,szWork2,16,CurEmu);
						switch (cfgDefValues[n].nType)
						{
							case	CFG_TYPE_TEXT:
								cfgDefValues[n].nValue=0;
								for(i=cfgDefValues[n].min;i<=cfgDefValues[n].max;i++)
								{
									if(!strcmpi(pszTextValues[i],szWork2))
									{
										cfgDefValues[n].nValue=i;
										break;
									}
								}
								break;
							case CFG_TYPE_FLOAT:
								pWork=strstr(szWork2,".");
								if(pWork)
								{
									*pWork=0;
									nWork=atoi(szWork2)*100;
									pWork++;
									pWork[2]=0;
									nWork+=atoi(pWork);
								} else
									nWork=atoi(szWork2)*100;

								cfgDefValues[n].nValue=nWork;
								break;
							default:
								cfgDefValues[n].nValue=atoi(szWork2);
								if(cfgDefValues[n].nType==CFG_TYPE_MIXED)
									cfgDefValues[n].nValue+=cfgDefValues[n].min;
						}
						if(cfgDefValues[n].nValue<cfgDefValues[n].min)
							cfgDefValues[n].nValue=cfgDefValues[n].min;
						if(cfgDefValues[n].nValue>cfgDefValues[n].max)
							cfgDefValues[n].nValue=cfgDefValues[n].max;
						nCfgValues[n]=cfgDefValues[n].nValue;
					}
				}
			}
			fclose(fMame);
		}
	} else
//just read the local copy
		readlocalcfg();
	writelocalcfg();

	return TRUE;
}

int readlocalcfg(void)
{
	static char	buffer[128];
	static char	szSave[128];
	static char	szWork[256];
	char	*pWork;
	FILE	*fMame;
	int	n;

	for(n=0;n<NoCfgValues;n++)
	{
		cfgDefValues[n].nValue=cfgDefValues[n].nDefault;
		nCfgValues[n]=cfgDefValues[n].nDefault;
		cfgDefValues[n].bFound=FALSE;
		if(!strcmpi(cfgDefValues[n].szIdent,"exe"))
			setupexe(n);
	}

	localinifile(buffer);
	fMame=fopen(buffer,"rt");
	if(!fMame)
		return FALSE;
	while(tidyget(buffer,1023,fMame)!=NULL)
	{
	      for(n=0;n<NoCfgValues;n++)
		{
			sprintf(szSave,"%s=",cfgDefValues[n].szIdent);
			if(!cfgDefValues[n].bFound&&strstr(buffer,szSave))
			{
				cfgDefValues[n].bFound=TRUE;
				pWork=getitem(szWork,buffer,1,255,'=');
				cfgDefValues[n].nValue=atoi(pWork);
			}
		}
	}
	fclose(fMame);
	return TRUE;
}

void writelocalcfg(void)
{
	static char	buffer[128];
	FILE	*fMame;
	int	n;

	if(NoCfgValues<=0)
		return;
//write our our simplified local INI structure
	localinifile(buffer);
	fMame=fopen(buffer,"wt");
	if(!fMame)
		return;
	for(n=0;n<NoCfgValues;n++)
		fprintf(fMame,"%s=%d\n",cfgDefValues[n].szIdent,cfgDefValues[n].nValue);
	fclose(fMame);
	return;
}

void getemuvalue(char *buffer,char *out,int bufsize,int nEmu)
{
	char	*pWork;
	char	*pWork2;

	*out=0;

	if(Emulators[nEmu].bIniUsesEqual)
		pWork=strstr(buffer,"=");
	else
	{
		pWork2=buffer+3;
		pWork=strstr(pWork2," ");
	}

	if(pWork)
	{
		pWork++;
		pWork=trimspaces(pWork);
		if(strlen(pWork)>=bufsize)
		{
			strncpy(out,pWork,bufsize-1);
			out[bufsize-1]=0;
		} else
			strcpy(out,pWork);
	}
}

char *trimspaces(char *in)
{
	char	*out;
	char	*pWork;

	out=in;
//remove space from start
	while(isspace(*out))
		out++;
//and from the end
	if(strlen(out))
	{
		pWork=out+strlen(out)-1;
		while(isspace(*pWork)&&pWork>in)
			pWork--;
		pWork++;
		*pWork=0;
	}
	return out;
}

int getdefcfgvals(void)
{
	FILE	*fCfg;
	int	n,NoItems;
	char	workbuff[64];
	char	buffer[1024];

//reset our totals
	NoCfgValues=0;
	nNoTextVals=0;

	critclear();

//is the file there ?
	fCfg=fopen(Emulators[CurEmu].szConfigFile,"rt");
//nope, doesn't matter too much
	if(fCfg==NULL||readcrit())
		return 0;

//read in the file
	while(tidyget(buffer,1023,fCfg)!=NULL)
	{
		if(!strstr(buffer,"#"))
		{
//is this our text values ?
			if(strstr(buffer,"@textval"))
			{
//yep, get the item count
				NoItems=getitemcount(buffer,',');
//then the values
				for(n=0;n<NoItems-1;n++,nNoTextVals+=1)
					getitem(pszTextValues[nNoTextVals],buffer,n+1,10,',');
//a config value
//check it's valid
			} else if(getitemcount(buffer,',')==7)                               // LasVegas - Added 1 item
			{
				getitem(cfgDefValues[NoCfgValues].szMenu,buffer,0,32,',');   // - Added Menu Item
				getitem(cfgDefValues[NoCfgValues].szIdent,buffer,1,32,',');
				if(strlen(cfgDefValues[NoCfgValues].szIdent)==0)             // - Correct empty string
					strcpy(cfgDefValues[NoCfgValues].szIdent,cfgDefValues[NoCfgValues].szMenu);
				cfgDefValues[NoCfgValues].nValue=-1;
				cfgDefValues[NoCfgValues].bWritten=FALSE;
				getitem(workbuff,buffer,2,32,',');
				cfgDefValues[NoCfgValues].nType=atoi(workbuff);
				getitem(workbuff,buffer,3,32,',');
				cfgDefValues[NoCfgValues].min=atoi(workbuff);
				getitem(workbuff,buffer,4,32,',');
				cfgDefValues[NoCfgValues].max=atoi(workbuff);
				getitem(workbuff,buffer,5,32,',');
				cfgDefValues[NoCfgValues].nDefault=atoi(workbuff);
				cfgDefValues[NoCfgValues].nOffSet=0;
				getitem(cfgDefValues[NoCfgValues].szCommands,buffer,6,128,',');
				NoCfgValues++;
				if(NoCfgValues>=MAX_CFGS)
					break;
			}
		}
	}
	fclose(fCfg);

// LasVegas - Don't sort. Use new intended order.
//	qsort((void *)cfgDefValues,NoCfgValues,sizeof(CFGVALUE),sort_function2);

#ifdef FILE_CHECK

	fCfg=fopen("opts.txt","wt");
	for(n=0;n<NoCfgValues;n++)
		fprintf(fCfg,"%s (%d)\n",cfgDefValues[n].szIdent,n);
	fclose(fCfg);
#endif
	return 1;
}

#include "itemfunc.x"

char *getquickitem(char *in,int nindex,char sep,int *pLen)
{
	int	n;
	char	*pWork;
	char	*pRet;
	char	szSep[2];

	szSep[0]=sep;
	szSep[1]=0;

	pRet=in;
	pWork=in;
	*pLen=0;

	for(n=0;n<nindex;n++)
	{
		pWork=strstr(pWork,szSep);
		if(pWork)
			pWork++;
	}
	if(pWork)
	{
		pRet=pWork;
		pWork=strstr(pRet,szSep);
		if(pWork)
			*pLen=(int)(pWork-pRet);
	}
	return pRet;
}

int checkfile(char *szfile)
{
	FILE	*fchk;

	critclear();
	fchk=fopen(szfile,"rb");
	if(!fchk)
		return FALSE;
	fclose(fchk);

	return (!readcrit());
}

void writecfgfile(int NoValues)
{
	FILE	*ftemp;
	FILE	*menucfg;
	static char	buffer[1024];
	static char	szFile[512];

	int	n;

	sprintf(szFile,"%sarcadeos.cfg",szStartDir);
	unlink("c:\\y.tmp");

	sprintf(buffer,"copy %s c:\\y.tmp > c:\\mm.tmp",szFile);
	system(buffer);
	unlink("c:\\mm.tmp");
	menucfg=fopen("c:\\y.tmp","rt");
	if(!menucfg)
		return;

	for(n=0;n<NoValues;n++)
		cfgDefValues[n].bWritten=FALSE;

//yep, so it's tricky
 	if((ftemp=fopen(szFile,"wt"))==NULL)
 	{
		printf("Failed to Open ArcadeOS.CFG file :%s for writing\n",szFile);
 		fclose(menucfg);
 		return;
 	}

//read through the existing file
 	while(fgets(buffer,1023,menucfg)!=NULL)
 	{
 		for(n=0;n<NoValues;n++)
 		{
//is this our line ?
 			if(!cfgDefValues[n].bWritten&&strstr(buffer,cfgDefValues[n].szIdent)&&!strstr(buffer,"#"))
			{
//yep, so replace the value
				if(cfgDefValues[n].nType==CFG_TYPE_TEXT)
					sprintf(buffer,"%s=%s\n",cfgDefValues[n].szIdent,cfgDefValues[n].szCommands);
				else
					sprintf(buffer,"%s=%d\n",cfgDefValues[n].szIdent,cfgDefValues[n].nValue);
				cfgDefValues[n].bWritten=TRUE;
				break;
			}
		}
//write out the string
		fputs(buffer,ftemp);
	}
	fclose(ftemp);
	fclose(menucfg);

	unlink("c:\\y.tmp");
}

int getallfiles(pGETFILE pGetFiles,int *pNoGames,char *szPattern,int attrib,int nGameType,int romdir,int maxfiles)
{
	int	bFinished,i;
	struct ffblk	ffblk;
	struct ffblk	ffblklong;
	char	*pChar;
	char	szWork[512];
	char	szExt[8];
	char	*pExt;
	int	nThisTot=0;
	int	saveflags=_crt0_startup_flags;

	SOUND_UPDATE_INIT

	if(*pNoGames>=maxfiles)
		return FALSE;

	*szExt=0;

	if(LongNames)
	{
		findfirst(szPattern,&ffblklong,attrib);
		_crt0_startup_flags=_CRT0_FLAG_NO_LFN;
	}

	bFinished = findfirst(szPattern,&ffblk,attrib);

	loginfo(1,"Searching for files, pat. :%s",szPattern);

	while (!bFinished)
	{
		pExt=szExt;

		if(ffblk.ff_name[0]!='.')
		{
//check for duplicates
			pGetFiles[*pNoGames].bType=nGameType;
			strcpy(szWork,ffblk.ff_name);

			if(!noUseCRC&&nGameType!=GAME_TYPE_DIR)
				getcrc32(szWork,pGetFiles[*pNoGames].CRC32);

			pChar=strstr(szWork,".");
			if(pChar)
			{
				*pChar=0;
				pExt=pChar+1;
			}
			strupr(szWork);
			safecopy(pGetFiles[*pNoGames].FileName,szWork,63);
			if(LongNames)
				safecopy(pGetFiles[*pNoGames].szLongName,ffblklong.ff_name,63);
			else
				strcpy(pGetFiles[*pNoGames].szLongName,pGetFiles[*pNoGames].FileName);

			pChar=strstr(pGetFiles[*pNoGames].szLongName,".");
			if(pChar)
				*pChar=0;

			safecopy(pGetFiles[*pNoGames].szExtension,pExt,4);

// LasVegas - Record ROM directory info.
			if(romdir)
			{
//				loginfo(1,"Setting path for %s, Path # %d.",
//						pGetFiles[*pNoGames].FileName,romdir);
				pGetFiles[*pNoGames].bRomFolder=romdir;
			}
			if(strcmpi(pGetFiles[*pNoGames].FileName,NEOGEO))
			{
				pGetFiles[*pNoGames].bType=nGameType;
				if(!dupfile(pGetFiles[*pNoGames].FileName,pGetFiles,*pNoGames))
				{
					nThisTot++;
					*pNoGames+=1;
					if(*pNoGames>=maxfiles)
						break;
				}
			}
		}
		if(LongNames)
		{
			_crt0_startup_flags=saveflags;
			findnext(&ffblklong);
			_crt0_startup_flags=_CRT0_FLAG_NO_LFN;
		}

		bFinished=findnext(&ffblk);
		SOUND_UPDATE_TRIP(10)
	}
	loginfo(1,"Found %d new files with pat. :%s",nThisTot,szPattern);

	if(LongNames)
		_crt0_startup_flags=saveflags;

	return TRUE;
}

int dupfile(char *szName,pGETFILE pGetFiles,int ngames)
{
	int	n;

	for(n=0;n<ngames;n++,pGetFiles++)
	{
		if(!strcmpi(szName,pGetFiles->FileName))
			return TRUE;
	}
	return FALSE;
}

int dupfilesort(char *szName,pGETFILE pGetFiles)
{
	int n;
	strupr(szName);

	for(n=0;n<NoGames;n++,pGetFiles++)
	{
		if(!strcmpi(szName,pGetFiles->FileName))
			return TRUE;
		if(CurEmu==EMU_MAME && *pGetFiles->FileName>*szName)
			break;
	}
	return FALSE;
}

int sort_function(const void *a, const void *b)
{
	pGETFILE pa;
	pGETFILE pb;
	pa=(pGETFILE)a;
	pb=(pGETFILE)b;
   return(strcmpi(pa->FileName,pb->FileName));
}

int sort_function2( const void *a, const void *b)
{
	pCFGVALUE pa;
	pCFGVALUE pb;
	pa=(pCFGVALUE)a;
	pb=(pCFGVALUE)b;
	return(strcmp(pa->szIdent,pb->szIdent));
}

void getrmsfile(char *in)
{
	sprintf(in,"%s%s.rms",szStartDir,Emulators[CurEmu].szEmuName);
}

void addexecfg(int *pNoCfgValues)
{
	static char	szTemp[128];
	if(ExeIndex!=-1)
	{
		sprintf(szTemp,"%s.exe",pszTextValues[cfgDefValues[ExeIndex].nValue]);
		addtextcfg("mameexe",szTemp,pNoCfgValues);
	}
}

void addtextcfg(char *szIdent,char *szValue,int *pNoCfgValues)
{
	if(*pNoCfgValues<MAX_CFGS)
	{
		safecopy(cfgDefValues[*pNoCfgValues].szIdent,szIdent,15);
		safecopy(cfgDefValues[*pNoCfgValues].szCommands,szValue,127);
		cfgDefValues[*pNoCfgValues].nType=CFG_TYPE_TEXT;
		*pNoCfgValues+=1;
	}
}

char *tidyget(char *inbuff,int len,FILE *f)
{

	char *ret;
	*inbuff=0;

	ret=NULL;
	if(f)
	{
		ret=fgets(inbuff,len,f);
		if(ret)
		{
			inbuff[len]=0;
			if(strlen(inbuff) && inbuff[strlen(inbuff)-1]<32)
				inbuff[strlen(inbuff)-1]=0;
		}
	}
	return ret;
}

char *stripget(char *inbuff,int len,FILE *f)
{
	char 	*ret;
	char	*pWork;
	int	n;

	*inbuff=0;
	ret=NULL;

	if(f!=NULL) // File?
	{
		ret=fgets(inbuff,len,f); //get len chars from f
		if(!ret)             // return if nothing
			return ret;
		ret[len-1]=0;        //end string

		if(ret[strlen(ret)-1]<32)//end of string less than space?
			ret[strlen(ret)-1]=0;   //make it the end.

		if((pWork=strstr(ret,FPS_TEXT))!=NULL) // Looking for "Average FPS:"
		{
			ret=pWork;
		} else if(strstr(ret,"loading"))
		{
			n=strlen(ret)-1;
			while(TRUE)
			{
				if(n<0)
					break;
				if(inbuff[n]=='.')
				{
					n+=4;
					while(isspace(inbuff[n])&&n<strlen(inbuff))
						n++;
					ret=&inbuff[n];
					break;
				}
				n--;
			}
		}
	}
	return ret;
}

void fopenRM(int RMfileno)
{
   *szRMBuffer=0;
   nRMFile=RMfileno;
}

void fprintfRM(char *buffer,...)
{
   char locbuf[1024];
   va_list args;

   va_start(args,buffer);
   vsprintf(locbuf,buffer,args);
   va_end(args);

   if((strlen(szRMBuffer)+strlen(locbuf))<16384)
      strcat(szRMBuffer,locbuf);
}

void loginfo(int level,char *buffer,...)
{
   if(nLogging>level)
   {
      va_list args;
      va_start(args,buffer);
      vfprintf(fLogFile,buffer,args);
      va_end(args);
      fputs("\n",fLogFile);
   }
}

void fcloseRM(void)
{
   writebuffertoRM(szRMBuffer,nRMFile);
}

//CRC32 code - very heavy derived from MAME source
static unsigned int crc_table[256] = {
	0x00000000L, 0x77073096L, 0xee0e612cL, 0x990951baL, 0x076dc419L,
	0x706af48fL, 0xe963a535L, 0x9e6495a3L, 0x0edb8832L, 0x79dcb8a4L,
	0xe0d5e91eL, 0x97d2d988L, 0x09b64c2bL, 0x7eb17cbdL, 0xe7b82d07L,
	0x90bf1d91L, 0x1db71064L, 0x6ab020f2L, 0xf3b97148L, 0x84be41deL,
	0x1adad47dL, 0x6ddde4ebL, 0xf4d4b551L, 0x83d385c7L, 0x136c9856L,
	0x646ba8c0L, 0xfd62f97aL, 0x8a65c9ecL, 0x14015c4fL, 0x63066cd9L,
	0xfa0f3d63L, 0x8d080df5L, 0x3b6e20c8L, 0x4c69105eL, 0xd56041e4L,
	0xa2677172L, 0x3c03e4d1L, 0x4b04d447L, 0xd20d85fdL, 0xa50ab56bL,
	0x35b5a8faL, 0x42b2986cL, 0xdbbbc9d6L, 0xacbcf940L, 0x32d86ce3L,
	0x45df5c75L, 0xdcd60dcfL, 0xabd13d59L, 0x26d930acL, 0x51de003aL,
	0xc8d75180L, 0xbfd06116L, 0x21b4f4b5L, 0x56b3c423L, 0xcfba9599L,
	0xb8bda50fL, 0x2802b89eL, 0x5f058808L, 0xc60cd9b2L, 0xb10be924L,
	0x2f6f7c87L, 0x58684c11L, 0xc1611dabL, 0xb6662d3dL, 0x76dc4190L,
	0x01db7106L, 0x98d220bcL, 0xefd5102aL, 0x71b18589L, 0x06b6b51fL,
	0x9fbfe4a5L, 0xe8b8d433L, 0x7807c9a2L, 0x0f00f934L, 0x9609a88eL,
	0xe10e9818L, 0x7f6a0dbbL, 0x086d3d2dL, 0x91646c97L, 0xe6635c01L,
	0x6b6b51f4L, 0x1c6c6162L, 0x856530d8L, 0xf262004eL, 0x6c0695edL,
	0x1b01a57bL, 0x8208f4c1L, 0xf50fc457L, 0x65b0d9c6L, 0x12b7e950L,
	0x8bbeb8eaL, 0xfcb9887cL, 0x62dd1ddfL, 0x15da2d49L, 0x8cd37cf3L,
	0xfbd44c65L, 0x4db26158L, 0x3ab551ceL, 0xa3bc0074L, 0xd4bb30e2L,
	0x4adfa541L, 0x3dd895d7L, 0xa4d1c46dL, 0xd3d6f4fbL, 0x4369e96aL,
	0x346ed9fcL, 0xad678846L, 0xda60b8d0L, 0x44042d73L, 0x33031de5L,
	0xaa0a4c5fL, 0xdd0d7cc9L, 0x5005713cL, 0x270241aaL, 0xbe0b1010L,
	0xc90c2086L, 0x5768b525L, 0x206f85b3L, 0xb966d409L, 0xce61e49fL,
	0x5edef90eL, 0x29d9c998L, 0xb0d09822L, 0xc7d7a8b4L, 0x59b33d17L,
	0x2eb40d81L, 0xb7bd5c3bL, 0xc0ba6cadL, 0xedb88320L, 0x9abfb3b6L,
	0x03b6e20cL, 0x74b1d29aL, 0xead54739L, 0x9dd277afL, 0x04db2615L,
	0x73dc1683L, 0xe3630b12L, 0x94643b84L, 0x0d6d6a3eL, 0x7a6a5aa8L,
	0xe40ecf0bL, 0x9309ff9dL, 0x0a00ae27L, 0x7d079eb1L, 0xf00f9344L,
	0x8708a3d2L, 0x1e01f268L, 0x6906c2feL, 0xf762575dL, 0x806567cbL,
	0x196c3671L, 0x6e6b06e7L, 0xfed41b76L, 0x89d32be0L, 0x10da7a5aL,
	0x67dd4accL, 0xf9b9df6fL, 0x8ebeeff9L, 0x17b7be43L, 0x60b08ed5L,
	0xd6d6a3e8L, 0xa1d1937eL, 0x38d8c2c4L, 0x4fdff252L, 0xd1bb67f1L,
	0xa6bc5767L, 0x3fb506ddL, 0x48b2364bL, 0xd80d2bdaL, 0xaf0a1b4cL,
	0x36034af6L, 0x41047a60L, 0xdf60efc3L, 0xa867df55L, 0x316e8eefL,
	0x4669be79L, 0xcb61b38cL, 0xbc66831aL, 0x256fd2a0L, 0x5268e236L,
	0xcc0c7795L, 0xbb0b4703L, 0x220216b9L, 0x5505262fL, 0xc5ba3bbeL,
	0xb2bd0b28L, 0x2bb45a92L, 0x5cb36a04L, 0xc2d7ffa7L, 0xb5d0cf31L,
	0x2cd99e8bL, 0x5bdeae1dL, 0x9b64c2b0L, 0xec63f226L, 0x756aa39cL,
	0x026d930aL, 0x9c0906a9L, 0xeb0e363fL, 0x72076785L, 0x05005713L,
	0x95bf4a82L, 0xe2b87a14L, 0x7bb12baeL, 0x0cb61b38L, 0x92d28e9bL,
	0xe5d5be0dL, 0x7cdcefb7L, 0x0bdbdf21L, 0x86d3d2d4L, 0xf1d4e242L,
	0x68ddb3f8L, 0x1fda836eL, 0x81be16cdL, 0xf6b9265bL, 0x6fb077e1L,
	0x18b74777L, 0x88085ae6L, 0xff0f6a70L, 0x66063bcaL, 0x11010b5cL,
	0x8f659effL, 0xf862ae69L, 0x616bffd3L, 0x166ccf45L, 0xa00ae278L,
	0xd70dd2eeL, 0x4e048354L, 0x3903b3c2L, 0xa7672661L, 0xd06016f7L,
	0x4969474dL, 0x3e6e77dbL, 0xaed16a4aL, 0xd9d65adcL, 0x40df0b66L,
	0x37d83bf0L, 0xa9bcae53L, 0xdebb9ec5L, 0x47b2cf7fL, 0x30b5ffe9L,
	0xbdbdf21cL, 0xcabac28aL, 0x53b39330L, 0x24b4a3a6L, 0xbad03605L,
	0xcdd70693L, 0x54de5729L, 0x23d967bfL, 0xb3667a2eL, 0xc4614ab8L,
	0x5d681b02L, 0x2a6f2b94L, 0xb40bbe37L, 0xc30c8ea1L, 0x5a05df1bL,
	0x2d02ef8dL
};

#define DO1(buf) crc = crc_table[((int)crc ^ (*buf++)) & 0xff] ^ (crc >> 8);
#define DO2(buf)  DO1(buf); DO1(buf);
#define DO4(buf)  DO2(buf); DO2(buf);
#define DO8(buf)  DO4(buf); DO4(buf);

void getcrc32(char *fname,char *crc)
{
	int	handle;
	long	flen;
	pBYTE	buf;
	unsigned int	ret=0;

	handle=open(fname,O_RDONLY|O_BINARY);
	if(handle>=0)
	{
		flen=filelength(handle);

		buf=myalloc(flen);
		if(buf)
		{
			read(handle,buf,flen);
			ret=aoscrc32(ret,buf,flen);
			myfree(buf);
		}
		close(handle);
		loginfo(1,"len of %s = %d, CRC32=0x%x",fname,(int)flen,(int)crc);
	}
	sprintf(crc,"%x",ret);

	strupr(crc);
}

unsigned int aoscrc32(unsigned int crc,pBYTE buf,unsigned int len)
{
	if(buf==0)
		return 0L;
	crc=crc^0xffffffffL;
	while(len>=8)
	{
		DO8(buf);
		len-=8;
	}
	if (len) do
	{
		DO1(buf);
	} while(--len);
	return crc^0xffffffffL;
}

char getfiledrive(void)
{
	return 65+(nFileDrive-FILE_OFFSET);
}

void progress(void)
{
	static int	spinpos=0;
	static char	spin[]="|/-|\\-";

	printf("%c\b",spin[spinpos]);
	fflush(stdout);
	spinpos++;
	if(spinpos==6)
		spinpos=0;
}
