#include "main.h"
#include "gpadpro.h"

int checkgpp(void)
{
   loginfo(1,"Gamepad Pro selected");

   if(readgpp(0)==1)
   {
      loginfo(1,"NO Gamepad Pro Found");
      return 0;
   }

   if(readgpp(1)==1)
   {
      loginfo(1,"1 Gamepad Pro Found");
      return 1;
   }
   else
   {
      loginfo(1,"2 Gamepad Pros Found");
      return 2;
   }
}

//Note: taken from Allegro's Gamepad Pro driver
int readgpp(int pad_num)
{
   int samples[50];
   int clock_mask,data_mask,data,old_data;
   int num_samples,timeout1,timeout2,sample_pos,c;

   if(pad_num==0)
   {
      clock_mask=0x10;
      data_mask=0x20;
   }
   else
   {
      clock_mask=0x40;
      data_mask=0x80;
   }

   num_samples=0;
   timeout1=0;

   __asm volatile ("cli");

   old_data=inportb(0x201);
   data=0;

   while(num_samples<50)
   {
      for (timeout2=0;timeout2<255;timeout2++)
      {
         data=inportb(0x201);
         if(data!=old_data)
            break;
      }

      if(timeout2==255)
      {
         __asm volatile ("sti");
         return 1;
      }

      if((old_data&clock_mask)&&(!(data&clock_mask)))
      {
         samples[num_samples]=(data & data_mask) ? 1 : 0;
         num_samples++;
      }

      old_data = data;

      if(timeout1++==200)
         break;
   }

   __asm volatile ("sti");

   c=0;

   for(sample_pos=1;sample_pos<num_samples;sample_pos++)
   {
      if(samples[sample_pos])
         c++;
      else
         c = 0;

      if(c==5)
         break;
   }

   if (c!=5)
      return 1;

   sample_pos++;
   data=0;

   for(c=0;c<14;c++)
   {
      if((c&3)==0)
         sample_pos++;
      data|=samples[sample_pos];
      data<<=1;
      sample_pos++;
   }

   return data;
}

