#include "main.h"
#include "disp.h"
#include "keyasm.h"
#include "info.h"
#include "scrasm.h"
#include "help.h"

static char *text=NULL;

static	int	nolines=0;
static	int noReadLines=0;
static	int nReadOffset=0;
static	WINSTRUCT	winstruct;

void clearhelp(void)
{
	if(text)
		myfree(text);
}

void cleartext(void)
{
	if(text)
	{
		*text=0;
	}
}

int disphelp(int state,int bFirstHelp,char *szVersion)
{
	FILE	*fhlp;
	int	bFound;
	int	n;
	static int laststate=-1;
	char	buffer[1024];
	char	szCommand[512];

	char *pwork;
	int	smaxx;

	smaxx=ScreenOrient.maxx;
	if(smaxx>49)
		smaxx=49;



	if(!text||laststate!=state||!*text)
	{
		if(text==NULL)
		{
			text=myalloc(64000);
			memset(text,0,64000);
		}

		nolines=0;
		if(!text)
			return FALSE;
		fhlp=fopen("arcadeOS.hlp","rt");
		if(!fhlp)
		{
			myfree(text);
			return FALSE;
		}

		sprintf(szCommand,"@%d",state);
		bFound=FALSE;
		while(TRUE)
		{
			if(!tidyget(buffer,smaxx-1,fhlp))
				break;
			if(strstr(buffer,szCommand))
			{
				bFound=TRUE;
				break;
			}
		}
		if(!bFound)
		{
			fclose(fhlp);
			myfree(text);
			return FALSE;
		}

		pwork=text;
		while(TRUE)
		{
			if(!tidyget(buffer,smaxx-1,fhlp))
				break;
			if(buffer[0]=='@')
				break;
         	strcpy(pwork,buffer);
       		pwork+=strlen(buffer)+1;
			nolines++;
			if(nolines>=ScreenOrient.maxy-6)
				break;
		}
		fclose(fhlp);
		laststate=state;
	}

	if(!nolines||!text)
	{
		if(text)
			myfree(text);
		return FALSE;
	}
	pwork=text;
   createwin(&winstruct,0,0,smaxx,ScreenOrient.maxy-1,0,0);
	winstruct.winproc=stdproc;
	winstruct.bHasScrollBar=FALSE;

	pStdPos=NULL;
	pStdMax=NULL;



   showgames();
	sprintf(buffer,"%s Help",szVersion);
	registerwindow(&winstruct);

	drawwindow(&winstruct,1,TRUE,bFirstHelp,buffer);

	for(n=0;n<nolines;n++)
	{
		switch(*pwork)
		{
			case '+':
				dispcentre(n+2,&pwork[1],ExtraColour,1,smaxx-1,TRUE,0,4,DISP_FONT);
				break;
			case '%':
				dispstring(1,n+2,&pwork[1],15,TRUE,0,4,DISP_FONT);
				break;
			default:
				dispstring(1,n+2,pwork,7,FALSE,0,4,DISP_FONT);
		}
		pwork+=strlen(pwork)+1;
	}

	dispcentre(ScreenOrient.maxy-3,"Start 2 to Close",15,1,smaxx-1,TRUE,0,0,DISP_FONT);
	return TRUE;
}

int dispreadme(int bFirstReadme)
{
	FILE	*fReadMe;
	int	bFound;
	int	n;
	char	buffer[1024];
	char	szCommand[512];
	char *pwork;
	int	smaxx;
   static int lastreadme=0;

	smaxx=ScreenOrient.maxx-2;


   if(!text||!*text||bFirstReadme||lastreadme!=State)
	{
      if(!text)
		{
			text=myalloc(64000);
			memset(text,0,64000);
		}


		if(!text)
			return FALSE;
      if(State==MENU_STATE_AOS_README)
         strcpy(buffer,"arcadeos.doc");
      else
         sprintf(buffer,"%s%s",Emulators[CurEmu].szPath,Emulators[CurEmu].szReadMe);
      lastreadme=State;
		fReadMe=fopen(buffer,"rt");

		if(!fReadMe)
		{
			myfree(text);
			return FALSE;
		}


		pwork=text;
		noReadLines=0;
		while(TRUE)
		{
			if(!fgets(buffer,1023,fReadMe))
				break;
			stripcontrolchars(buffer);
			strcat(buffer,"^");
			strcpy(pwork,buffer);
			pwork+=strlen(buffer);
			noReadLines++;
		}
		fclose(fReadMe);

		noReadLines=displong(text,2,smaxx-3,ScreenOrient.maxy-6,1,0,TRUE,FALSE);
		nReadOffset=0;
	}

	if(!noReadLines||!text)
	{
		if(text)
			myfree(text);
		return FALSE;
	}
	pwork=text;


   createwin(&winstruct,0,0,smaxx,ScreenOrient.maxy-1,0,0);
	winstruct.winproc=readmeproc;
	if(noReadLines>ScreenOrient.maxy-6)
		winstruct.bHasScrollBar=TRUE;
	else
		winstruct.bHasScrollBar=FALSE;

	pStdPos=NULL;
	pStdMax=NULL;



	sprintf(buffer,"%s Info",Emulators[CurEmu].szEmuName);
	registerwindow(&winstruct);
	drawwindow(&winstruct,1,TRUE,bFirstReadme,buffer);

	displong(pwork,2,smaxx-3,ScreenOrient.maxy-6,1,nReadOffset,FALSE,!Hires);
	if(winstruct.bHasScrollBar)
        winstruct.scrollpos=drawscrollbar(&winstruct,&nReadOffset,(noReadLines-(ScreenOrient.maxy-6)),winstruct.control);

   dispcentre(ScreenOrient.maxy-3,"Start 2 to Close",ExtraColour,1,smaxx-1,TRUE,0,0,DISP_FONT);


	return TRUE;
}



void movereadmecursor(void)
{
	int	nReal;

	nReal=noReadLines-(ScreenOrient.maxy-6);

   movement(&nReadOffset,(ScreenOrient.maxy-6));

	if(nReadOffset<0)
		nReadOffset=0;
	if(nReal>0)
	{
		if(nReadOffset>nReal)
			nReadOffset=nReal;
	}
}

void readmeproc(int Message,int Data1,int Data2,void *pData)
{
	pWINSTRUCT	pWinStruct;
	int	nsel,nfarright,nbotright;
	winstruct.control=0;

	if(nMouseType!=STANDARD_MOUSE)
		return;

	pWinStruct=(pWINSTRUCT)pData;


   switch(ScreenOrient.Orientation)
	{
		case 1:
		case 2:
			nfarright=pWinStruct->yoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->xoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);
			break;
		default:
			nfarright=pWinStruct->xoff+(pWinStruct->xbotright*pWinStruct->xmul);
			nbotright=(pWinStruct->yoff+(pWinStruct->ybotright*pWinStruct->ymul)-pWinStruct->clienty);
   }

	nsel=Data2-pWinStruct->clienty;
	winstruct.clienty=pWinStruct->clienty;

	switch(Message)
	{
		case WM_LUP:
			if(upokay())
			{
//see if it's on our exit box
				if(pWinStruct->onclose)
					keys[K_START2]=1;
			}
		case WM_LDOWN:
			handlescroll(Data1,nfarright,nbotright,&winstruct,nsel,8,Message);
			break;
	}
}

