#include "main.h"
#include "disp.h"
#include "keyasm.h"
#include "info.h"
#include "scrasm.h"


static MAMEDESC mamedesc;
static int bGotSS;
static int infowidth;
static char *pInfo=NULL;

static GAMEINFO GameInfo[]=
{
    {"Playable     ",GT_BOOL,&mamedesc.nOkay,NULL},
    {"Year         ",GT_STRING,NULL,mamedesc.szYear},
    {"Man.         ",GT_STRING,NULL,mamedesc.szMan},
    {"Resolution   ",GT_STRING,NULL,mamedesc.szResolution},
    {"Horizontal   ",GT_BOOL,&mamedesc.nHorizontal,NULL},
    {"Players      ",GT_INT,&mamedesc.nPlayers,NULL},
    {"Controls     ",GT_STRING,NULL,mamedesc.szControl},
    {"Buttons      ",GT_INT,&mamedesc.nButtons,NULL},
//    {"Colours      ",GT_INT,&mamedesc.nColors,NULL},
//    {"Colour Depth ",GT_INT,&mamedesc.nColorDepth,NULL},
    {"Frequency    ",GT_INT,&mamedesc.nFreq,NULL},
    {"Coin Slots   ",GT_INT,&mamedesc.nCoins,NULL},
    {"File Name    ",GT_STRING,NULL,mamedesc.szFileName},
};

static WINSTRUCT winstruct;
static int bFound;
static int nInfoIndex;

int setupgameinfo(void)
{
   int handle;
   unsigned long flen;
   cleargameinfo();
   handle=open("mameinfo.lst",O_RDONLY|O_BINARY);
   if(handle>=0)
   {
      flen=filelength(handle);

      pInfo=myalloc(flen);
      if(!pInfo)
      {
         close(handle);
         return FALSE;
      }

      read(handle,pInfo,flen);
      close(handle);
      return TRUE;
   }
   return FALSE;
}

void cleargameinfo(void)
{
   if(pInfo)
      myfree(pInfo);
   pInfo=NULL;
}

void dispinfo(int nCurrGame,int nFirst)
{

   nInfoIndex=nCurrGame;
   if(!getgameinfo(nInfoIndex,nFirst))
   {
      createwin(&emuwin,1,1,22,9,0,0);
		winstruct.winproc=stdproc;
		winstruct.bHasScrollBar=FALSE;
		pStdPos=NULL;
		pStdMax=NULL;
		registerwindow(&winstruct);
		drawwindow(&winstruct,1,TRUE,nFirst,"No Info");
      dispcentre(4,"No Info Found For:",ExtraColour,2,infowidth-2,TRUE,0,0,DISP_FONT);
      dispcentre(6,pMameGames[nCurrGame].GameName,ForeColour,2,infowidth-2,TRUE,0,0,DISP_FONT);
      dispcentre(8,"Start 2 to Close",ExtraColour,2,infowidth-2,TRUE,0,0,DISP_FONT);
   }
}

int fillinfo(char *pName,pMAMEDESC pMameDesc)
{
   char *pWork;
   char *pWork2;
   static char szWork[128];
   char cwork;

   memset(pMameDesc,0,sizeof(MAMEDESC));
   strcpy(pMameDesc->szFileName,pName);

//find the game
   sprintf(szWork,"^%s{",pName);
   pWork=strstr(pInfo,szWork);



   if(pWork)
   {
      loginfo(1,"Found start of info for %s",pMameDesc->szFileName);

//get the bit stuff
      pWork2=strstr(pWork,"@");
      if(!pWork2)
      {
         loginfo(1,"UNABLE TO FIND info for %s",pMameDesc->szFileName);
         return FALSE;
      }
      loginfo(1,"Found info for %s",pMameDesc->szFileName);

      pWork2++;
      cwork=*pWork2;
      pMameDesc->nOkay=cwork&1;
      pMameDesc->nVector=cwork&2;
      pMameDesc->nHorizontal=(cwork>>2)&1;
      pMameDesc->nButtons=(cwork>>3)&15;
      pWork2++;
      pMameDesc->nFreq=(int)*pWork2;
      pWork2++;
      pMameDesc->nPlayers=(int)*pWork2;
      pWork2++;
      pMameDesc->nCoins=(int)*pWork2;
      pWork2++;
      pMameDesc->nColorDepth=(int)*pWork2;
      pWork2+=2;
      getitem(szWork,pWork2,0,127,'{');
      pMameDesc->nColors=atoi(szWork);
      pWork2=strstr(pWork2,"{");
      if(pWork2)
      {
         pWork2++;

         getitem(pMameDesc->szResolution,pWork2,0,15,'{');
         getitem(pMameDesc->szControl,pWork2,1,255,'{');
         getitem(pMameDesc->szYear,pWork2,2,7,'{');
         getitem(pMameDesc->szMan,pWork2,3,255,'{');
      }
      else
         loginfo(1,"UNABLE TO FIND EXTRA INFO for %s",pName);

      return TRUE;
   }
   loginfo(1,"UNABLE TO FIND start of info for %s",pName);
   return FALSE;
}

int getgameinfo(int nIIndex,int nFirst)
{
//check if the info's there
   if(!pInfo)
      return FALSE;

//fist time round or not
	if(nFirst)
	{
      bGotSS=getscreenshot(nIIndex,TRUE,TRUE,SSInfo); // EEA Changed from !noAltSSInfo
      if(fillinfo(pMameGames[nIIndex].GameName,&mamedesc))
         bFound=TRUE;
		else
		{
         bFound=FALSE;
         return bFound;
		}
	}

   return showinfo(nFirst);
}

int showinfo(int nFirst)
{
    int n,ndetails,col;
	static	char	szWork[128];
	if(!bFound)
		return FALSE;
	if(nFirst)
		clearscreen();

	ndetails=sizeof(GameInfo)/sizeof(GAMEINFO);
	if(bGotSS)
		col=-1;
	else
		col=1;

   infowidth=ScreenOrient.maxx-4;
   if(infowidth>40)
      infowidth=40;

   createwin(&winstruct,1,0,infowidth,ndetails+7,0,0);
	winstruct.winproc=stdproc;
	winstruct.bHasScrollBar=FALSE;

	pStdPos=NULL;
	pStdMax=NULL;

	registerwindow(&winstruct);

	drawwindow(&winstruct,col,TRUE,nFirst,"Game Info");
	strcpy(szWork,pMameGames[nInfoIndex].szDispName);
   szWork[infowidth-2]=0;
   dispcentre(2,szWork,ExtraColour,2,infowidth-2,TRUE,0,4,DISP_FONT);

	for(n=0;n<ndetails;n++)
		dispinfoline(n);

   dispcentre(ndetails+5,"Start 2 to Close",ExtraColour,2,infowidth-2,TRUE,0,0,DISP_FONT);

	return TRUE;
}
void dispinfoline(int nindex)
{
	static char	szWork[128];
   int nOffSet;
	dispstring(3,nindex+4,GameInfo[nindex].szInfoName,ForeColour,TRUE,0,0,DISP_FONT);
   nOffSet=16;

	*szWork=0;
	switch(GameInfo[nindex].nType)
	{
      case GT_BOOL:
         if(*GameInfo[nindex].val)
				strcpy(szWork,"Yes");
			else
				strcpy(szWork,"No");
			break;
		case GT_INT:
			sprintf(szWork,"%d",*GameInfo[nindex].val);
			break;
		case GT_STRING:
			strcpy(szWork,GameInfo[nindex].szVal);
			if(!strcmp(szWork,"0x0"))
            strcpy(szWork,"(Vector)");
         szWork[infowidth-2]=0;
      break;
	}
   szWork[infowidth-nOffSet]=0;
	dispstring(nOffSet,nindex+4,szWork,ExtraColour,TRUE,0,0,DISP_FONT);
}


int displong(char *szClone,int ypos,int width,int height,int xpos,int offset,int bCount,int trim)
{
	int	nlen;
	char	szWork[128];
	char	*pWork;
	char	*pBreak;
	int	county;


	county=0;

	while(TRUE)
	{
		if(trim)
		{
         while(*szClone&&(isspace(*szClone)||*szClone=='^'))
            szClone++;
		}
		else
		{
			while(*szClone=='^')
				szClone++;
		}

		if(!*szClone)
			break;
		safecopy(szWork,szClone,width+1);

		pBreak=strstr(szWork,"^");
		if(pBreak)
			*pBreak=0;


		nlen=strlen(szWork);
		if(nlen<strlen(szClone)&&!pBreak)
		{
//truncated string - so try and make it look nice
			pWork=&szWork[nlen-1];
			while(TRUE)
			{
				if(isspace(*pWork))
				{
					*pWork=0;
					break;
				}
				pWork--;
				if(pWork==szWork)
					break;
			}
			nlen=strlen(szWork);
		}
		if(offset)
			offset--;
		else
		{
			county++;
			if(!bCount)
				dispstring(xpos,ypos++,szWork,ForeColour,TRUE,0,0,DISP_FONT);
		}


		if(nlen>=strlen(szClone))
			break;
		if(!bCount&&county>=height)
			break;


		szClone+=nlen;
	}
	return county++;

}

