#include<stdio.h>
#include<stdlib.h>
#include<dos.h>
#include<ctype.h>
#include<string.h>
#include<math.h>

// AOS include files
#include "main.h"
#include "lcdlib.h"

// Apparently you can get the com port addresses from the following locations...
// COM1 = 0x00000400
// COM2 = 0x00000402
// COM3 = 0x00000404
// COM4 = 0x00000406
// I am told it is POSSIBLE that the addresses be different (IBM PS/2)
// The hard-coding is ok for 99.999% of machines.

/* COM Port Addresses (COM1-COM4) (A dummy value for COM0) */
//int	tot_cols,
//   	tot_lines,
//	line_cols[4],
//   	cur_col=0,
//   	cur_line=1,
//   	usr_cmd=FALSE;
int	COM[5]={0x0000,0x03F8,0x02F8,0x03E8,0x02E8};

void ReadyPORT(int num)
{
	if(num<5)
	{
//		int SpeedDiv=(1843200/(16*nLCDMode));	// Simplified below
		int SpeedDiv=(115200/nLCDMode);
		outp(COM[num] + 3, inp(COM[num] + 3) | 0x080);
		outp(COM[num],  SpeedDiv & 0x0FF);
		outp(COM[num] + 1, SpeedDiv >> 8);
		outp(COM[num] + 3, inp(COM[num] + 3) & 0x07F);
		outp(COM[num] + 4, inp(COM[num] + 4) | 0x003);

	} else         // Initialize Parallel Port Display
		ReadyLPT(num-5);
}

void ReadyLPT(int num)
{
	lcd_info.tot_cols=(nLCDMode % 100)-1;	// & 0x1F;
	if(lcd_info.tot_cols>63) lcd_info.tot_cols=63;
	lcd_info.tot_lines = nLCDMode / 100;		// >> 5;
	lcd_info.line_cols[0]=0;
	switch(lcd_info.tot_lines)
	{
		case	2:
			lcd_info.line_cols[1]=(lcd_info.tot_cols>31)?64:32;
			break;
		case	4:
			lcd_info.line_cols[2]=32;
			lcd_info.line_cols[1]=64;
			lcd_info.line_cols[3]=96;
			break;
	}

	if(lcd_info.do_once)
	{
		loginfo(1,"initializing LPT port %d",num);
		loginfo(1,"sending %.2x to port %d , 2 times",CMD_FN + CMD_FN_8BIT+CMD_FN_2LINE,num);
		_bios_printer(_PRINTER_INIT,num,0);      // 1,0,0);
		loginfo(1,"%d lines, %d columns",lcd_info.tot_cols,lcd_info.tot_lines);

// Initialize display
		WriteLPT(num,0,0,CMD_FN + CMD_FN_8BIT+CMD_FN_2LINE);
		WriteLPT(num,0,0,CMD_FN + CMD_FN_8BIT+CMD_FN_2LINE);

		if(PrintHardware && !num)	// Set to 4 bit mode
		{
			WriteLPT(num,0,0,CMD_FN + CMD_FN_4BIT);
			WriteLPT(num,1,0,CMD_FN + CMD_FN_4BIT + 
				(lcd_info.tot_lines-1 ? CMD_FN_2LINE+CMD_FN_5X7 : CMD_FN_1LINE+CMD_FN_5X10) );
		} else				// Set to 8 bit mode
			WriteLPT(num,0,0,CMD_FN + CMD_FN_8BIT + 
					(lcd_info.tot_lines-1 ? CMD_FN_2LINE+CMD_FN_5X7 : CMD_FN_1LINE+CMD_FN_5X10) );
		WriteLPT(num,PrintHardware,0,CMD_ENTRY + CMD_ENTRY_INC);

		WriteLPT(num,PrintHardware,0,CMD_ONOFF + CMD_ONOFF_DSP_ON +
					CMD_ONOFF_CRS_OFF + CMD_ONOFF_BNK_OFF);

		lcd_info.do_once=FALSE;
	}

}

void WriteLPT (int port, int lower, int isData, unsigned char data)
{
	int	rs,		// Register Select
		hidata,
		lodata,
		portadr;

	rs=isData?4:0;
	hidata=data&0xF0;
	lodata=(data&0x0F)<<4;
	portadr=port?LPT2:LPT1;

	outp(portadr+LCD_CONTROL,rs+0x03);				// R/W=0, E=0

	if (!port && PrintHardware)
		outp(portadr+LCD_DATA,hidata);			// 4bit High Nibble
	else
		outp(portadr+LCD_DATA,data);				// 8bit Byte

	outp(portadr+LCD_CONTROL,rs+0x02);				// R/W=0, E=1
	outp(portadr+LCD_CONTROL,rs+0x03);				// R/W=0, E=0

	if(!port && lower)
	{
		mssleep(1);							// delay
		outp(portadr+LCD_DATA,lodata);			// 4bit Low Nibble
		outp(portadr+LCD_CONTROL,rs+0x02);			// R/W=0, E=1
		outp(portadr+LCD_CONTROL,rs+0x03);			// R/W=0, E=0
		mssleep(1);							// delay
	}
	outp(portadr+LCD_CONTROL,rs+0x01);	// R/W=1, E=0

	mssleep(isData?1:10);			// delay
}

void WriteChar(int num,char ch)
{
	if(num<5)
	{
		outp(COM[num],ch);
		while ((inp(COM[num] + 5) & 0x020) == 0);
	} else if(nLCDMode)
	{
		if(lcd_info.usr_cmd)
		{
			WriteLPT(num-5,PrintHardware,0,ch);
			lcd_info.usr_cmd=FALSE;
		} else if(ch<' ' && ch>'\x7')
		{
			switch(ch)
			{
				case	'\x1B':		// ESC Send next char as command
					lcd_info.usr_cmd=TRUE;
					break;
				case	'\xe':	// Clear Screen
					WriteLPT(num-5,PrintHardware,0,CMD_CLR);
					lcd_info.cur_line=lcd_info.cur_col=0;
					break;
				case	'\v':	// Home Screen
					WriteLPT(num-5,PrintHardware,0,CMD_HOME);
					lcd_info.cur_line=lcd_info.cur_col=0;
					break;
				case	'\n':		// New Line - Move to next line
					if(++lcd_info.cur_line==lcd_info.tot_lines)
						lcd_info.cur_line=0;
					WriteLPT(num-5,PrintHardware,0,CMD_DDR_ADR+
						lcd_info.line_cols[lcd_info.cur_line]+
						lcd_info.cur_col);
					break;
				case	'\r':		// Return - Set Cursor to first of current line
					lcd_info.cur_col=0;
					WriteLPT(num-5,PrintHardware,0,CMD_DDR_ADR+
						lcd_info.line_cols[lcd_info.cur_line]);
					break;
				case	'\b':		// Backspace - Move back 1 position unless at 0.
					if(lcd_info.cur_col==0)
					{
						if(lcd_info.cur_line)
						{
							lcd_info.cur_col=lcd_info.tot_cols;
							lcd_info.cur_line--;
							WriteLPT(num-5,PrintHardware,0,CMD_DDR_ADR+
								lcd_info.line_cols[lcd_info.cur_line]);
						}
					} else
					{
						lcd_info.cur_col--;
						WriteLPT(num-5,PrintHardware,0,CMD_DDR_ADR+
							lcd_info.line_cols[lcd_info.cur_line]+
							lcd_info.cur_col);
					}
					break;
				default:	// pass other control codes for now...
					WriteLPT(num-5,PrintHardware,1,ch);
			}
		} else
		{
			WriteLPT(num-5,PrintHardware,1,ch);	// Write Character
			if(++lcd_info.cur_col>lcd_info.tot_cols)	// Check position - End of line?
			{
				lcd_info.cur_col=0;
				if(++lcd_info.cur_line==lcd_info.tot_lines)
					lcd_info.cur_line=0;
//Move to next line.
				if(lcd_info.tot_cols<63)
					WriteLPT(num-5,PrintHardware,0,CMD_DDR_ADR+
						lcd_info.line_cols[lcd_info.cur_line]);
			}
		}
	} else
	{
		if(lcd_info.usr_cmd)
		{
			WriteLPT(num-5,PrintHardware,0,ch);	// Write Command Character
			lcd_info.usr_cmd=FALSE;
		} else if(ch == '\x7f')
			lcd_info.usr_cmd=TRUE;
		else
			WriteLPT(num-5,PrintHardware,1,ch);	// Write Character
	}
}

void mssleep(int ms)
{
   struct time t;
   long int starttime;

   gettime(&t);
   starttime=
     t.ti_hour *10000000
     +t.ti_min *100000
     +t.ti_sec *1000
     +t.ti_hund*10
     ;

   do
     gettime(&t);
   while(
     (t.ti_hour*10000000
     +t.ti_min *100000
     +t.ti_sec *1000
     +t.ti_hund*10)
     -starttime<ms
   );
}

void WriteCOM(int num,char *str)
{
	char *ptr;
	char u,m,l;

	for(ptr=str;*ptr!='\0';ptr++)
	{
		if(*ptr=='\\')
		{
			ptr++;
				// if the next char is the same...just add one!
			if(*ptr=='\\')
				WriteChar(num,'\\'); // We want an actual '/' char
		/* Decode escape sequence... */
			else if(tolower(*ptr)=='h')    // LasVegas - support Hex
			{
				u=toupper(*(ptr+1))-'0';
				l=toupper(*(ptr+2))-'0';
				WriteChar(num,((u>15?u-7:u)*16)+(l>15?l-7:l));
				ptr+=2;
			}else if(isdigit(*ptr)) // Support Oct
			{
				u=(*ptr & 0x33)-'0';
				m=(*(ptr+1)&0x3F)-'0';
				l=(*(ptr+2)&0x3F)-'0';
				WriteChar(num,(u*64)+(m*8)+l);
				ptr+=2;
			} else if(tolower(*ptr)=='a')	// Alert (Bell)
				WriteChar(num,'\a');
			else if(tolower(*ptr)=='b')	// Backspace
				WriteChar(num,'\b');
			else if(tolower(*ptr)=='t')	// Tab
				WriteChar(num,'\t');
			else if(tolower(*ptr)=='n')	// Newline
				WriteChar(num,'\n');
			else if(tolower(*ptr)=='v')	// Vert Tab
				WriteChar(num,'\v');
			else if(tolower(*ptr)=='r')	// Return
				WriteChar(num,'\r');
			else if(tolower(*ptr)=='c')	// CLS
				WriteChar(num,'\xe');
			else if(tolower(*ptr)=='e')	// ESC
				WriteChar(num,'\x1B');
			else if(tolower(*ptr)=='p')	// Special Pause
			{
				if (atoi(ptr+1))
				{
					mssleep(atoi(ptr+1));
					while(isdigit(*(ptr+1))) ptr++;
				}else
					mssleep(500);
			}else					// anything else is decimal
			{
				WriteChar(num,atoi(ptr+1)&0xFF);
				while(isdigit(*(ptr+1))) ptr++;
			}
		}else	if(!iscntrl(*ptr))	// plain character to output.
			WriteChar(num,*ptr);

	}
}
////////////////////////////////////////////////
// Below this line, specifically for ArcadeOS //
////////////////////////////////////////////////

void displayLCDLogo(void)
{
  FILE *fp;
  char buf[4096];


  if((!bLCDScreen)||(!nLCDPort)||(!Emulators[CurEmu].szLCDLogo))
    return;

  fp=fopen(Emulators[CurEmu].szLCDLogo,"r");
  if(!fp)
    fp=fopen(Emulators[EMU_MAME].szLCDLogo,"r");
  if(!fp)
    fp=fopen("aos.lcd","r");

  if(fp)
    {
      ReadyPORT(nLCDPort);
      while(fgets(buf,4096,fp))
        {
          if(strchr(buf,'\r'))
            *strchr(buf,'\r')='\0';
          if(strchr(buf,'\n'))
            *strchr(buf,'\n')='\0';
          if(strlen(buf)>0)
            WriteCOM(nLCDPort,buf);
        }
      fclose(fp);
    }
}

void displayLCDGameInfo(char *GameName)
{
	FILE	*fp;
	int	n,NoItems,done=0;
	char	buf[4096],
		item[512],
		header[1024],
		footer[1024];

	if((!bLCDScreen)||(!nLCDPort)||(!Emulators[CurEmu].szLCDList))
		return;

	fp=fopen(Emulators[CurEmu].szLCDList,"r");
	if(!fp)
		fp=fopen(Emulators[EMU_MAME].szLCDList,"r");
	if(!fp)
		fp=fopen("list.lcd","r");
	if(fp)
	{
		ReadyPORT(nLCDPort);
		loginfo(1,"Displaying LCD message for \"%s\".",GameName);
		if(fgets(buf,4095,fp)!=NULL)
		{
			getitem(header,buf,0,1023,',');
			getitem(footer,buf,1,1023,',');

			while(fgets(buf,4095,fp)!=NULL)
			{
				NoItems=getitemcount(buf,',');
				for(n=0;n<NoItems;n+=2)
				{
					getitem(item,buf,n,511,',');
					if(strstr(item,GameName)||strstr(item,"default"))
					{
						if(strstr(item,"default"))
							done=1;
						if(*header)
							WriteCOM(nLCDPort,header);
						getitem(item,buf,n+1,511,',');
						if(*item)
							WriteCOM(nLCDPort,item);
						if(done)
							WriteCOM(nLCDPort,GameName);
						if(fgets(buf,4095,fp)!=NULL)
							WriteCOM(nLCDPort,buf);
						if(*footer)
							WriteCOM(nLCDPort,footer);
						done=1;
					}
					if(done) break;
				}
				if(done) break;
				if(fgets(buf,4095,fp)==NULL) break;
			}
		}
		fclose(fp);
	} else
		loginfo(1,"Could not open LCD file \"%s\".",Emulators[CurEmu].szLCDList);
}

void displayLCDShutdown(void)
{
  FILE *fp;
  char buf[4096];

  if((!bLCDScreen)||(!nLCDPort)||(!szLCDShutdown))
    return;

  fp=fopen(szLCDShutdown,"r");
  if(fp)
    {
      ReadyPORT(nLCDPort);
      loginfo(1,"Displaying LCD shutdown file.");
      while(fgets(buf,4096,fp))
        {
          if(strchr(buf,'\r'))
            *strchr(buf,'\r')='\0';
          if(strchr(buf,'\n'))
            *strchr(buf,'\n')='\0';
          if(strlen(buf)>0)
            WriteCOM(nLCDPort,buf);
        }
      fclose(fp);
    }
}



