#include	<stdlib.h>
#include	<stdio.h>
#include	<ctype.h>
#include	<string.h>
#include	<dos.h>
#include	<io.h>

#include "main.h"
#include "glist.h"
#include "lst.h"



int makelists()
{
	FILE	*fin;
	FILE  *fMame;
	FILE	*fClone;
	FILE	*fNeo;
	FILE	*fInfo;
   FILE  *fChk;
	char	*pWork;
	char	szWork[1024];
	char	buffer[1024];
   int   firstline=TRUE;
   int   trip=0;
   int   first=TRUE;
   int state=0;
	MAMEDESC	mamedesc;
   struct dfree freespace;
   unsigned long totfree;
   static int FailedAlready=FALSE;

   if(FailedAlready)
      return FALSE;
//check available space

   printf("\n---------------------------------\n");
   printf("Generating MAME information lists\n");
   printf("---------------------------------\n");

   if(!noSkipSizeCheck)
   {
      getdfree(3+TempDrive, &freespace);
      totfree=(unsigned long)((unsigned long)freespace.df_avail*
                              (unsigned long)freespace.df_bsec*
                              (unsigned long)freespace.df_sclus);

      if(totfree<(unsigned long)8500000L)
      {
         printf("There is not enough space on your %c drive to store MAME's game list output\n",TEMPDRIVE);

         printf("(approx) Space required - 8,500,000 bytes\n");
         printf("Space available - %lu bytes\n",totfree);
         printf("Please free up some space on your %c drive\n",TEMPDRIVE);
         printf("Or change the 'tempdrive' setting in arcadeos.cfg to use a different drive\n");
         printf("NOTE: This space is only used for temprorary file storage\n");
         FailedAlready=TRUE;
         return FALSE;

      }
   }

//get the MAME.EXE
	sprintf(buffer,"%s%s",Emulators[CurEmu].szPath,Emulators[CurEmu].szInfoExe);
	if(!checkfile(buffer))
		return FALSE;
//run -listinfo
   printf(".Getting information list from MAME\n");
   if (!MameLegacy)
	   sprintf(szWork," -listinfo >%c:\\xl$.tmp",TEMPDRIVE);
   else 
	   sprintf(szWork," -listxml | xml2info >%c:\\xl$.tmp",TEMPDRIVE);

   printf("%s\n",szWork);

   strcat(buffer,szWork);
   tablecom(buffer);
   sprintf(buffer,"%c:\\xl$.tmp",TEMPDRIVE);
   fin=fopen(buffer,"rt");
	if(!fin)
		return FALSE;

	fMame=fopen("mame.lst","wt");
	fClone=fopen("clone.lst","wt");
	fNeo=fopen("neogeo.lst","wt");
	fInfo=fopen("mameinfo.lst","wt");



//date stamp the lists
	sprintf(buffer,"%s%s",Emulators[CurEmu].szPath,Emulators[CurEmu].szInfoExe);
	getexeinfo(buffer,szWork);
	sprintf(buffer,"%c%s",INFO_IDENT_CHAR,szWork);
	fputs(buffer,fMame);
	fputs(buffer,fClone);
	fputs(buffer,fNeo);
   fputs(buffer,fInfo);
   printf(".Proccessing List\n");
//build up the lists
	while(TRUE)
	{
		if(!fgets(buffer,1023,fin))
			break;
      trip++;
      if(trip==4000)
      {
         trip=0;
         printf(".");
         fflush(stdout);
      }
//if the command failed,we'll get the MAME message
//so check for that
      if(firstline)
      {
         if(strstr(buffer,"M.A.M.E"))
         {
            fclose(fin);
            fclose(fMame);
            fclose(fClone);
            fclose(fNeo);
            fclose(fInfo);
            return FALSE;
         }
         firstline=FALSE;
      }

		pWork=buffer;

		while(*pWork&&isspace(*pWork))
			pWork++;
      if(strstr(pWork,"game (")==pWork)
      {

         state=0;
         if(!first)
         {

            strupr(mamedesc.szFileName);
            strupr(mamedesc.szCloneOf);
//write out details to the MAME list
//^PACMAN{Pac Man (Midway){@nnn
            sprintf(buffer,"^%s{%s{%s{@%c",mamedesc.szFileName,mamedesc.szDescription,mamedesc.szCloneOf,
                              (char)(32|mamedesc.nRotated|(mamedesc.nOkay<<1)|(mamedesc.nVector<<2)));
            fputs(buffer,fMame);
//check for a clone
            if(*mamedesc.szCloneOf)
            {
               if(strcmpi(mamedesc.szCloneOf,"NEOGEO"))
               {
//non-neogeo
//^PACMAN{PACMOD{
                  sprintf(buffer,"^%s{%s{",mamedesc.szCloneOf,mamedesc.szFileName);

                  fputs(buffer,fClone);
               }
               else
               {
//neogeo
//^RIDHERO{
                  sprintf(buffer,"^%s{",mamedesc.szFileName);
                  fputs(buffer,fNeo);
               }

            }
            sprintf(buffer,"^%s{@%c%c%c%c%c{%d{%s{%s{%s{%s{",mamedesc.szFileName,
                                 (char)(128|mamedesc.nOkay|(mamedesc.nVector<<1)|
                                 128|(mamedesc.nHorizontal<<2)|(mamedesc.nButtons<<3)),
                                 (char)mamedesc.nFreq,(char)mamedesc.nPlayers,
                                 (char)mamedesc.nCoins,(char)(128|mamedesc.nColorDepth),
                                 mamedesc.nColors,
                                 mamedesc.szResolution,mamedesc.szControl,
                                 mamedesc.szYear,mamedesc.szMan);

            fputs(buffer,fInfo);
         }
         first=FALSE;
         memset(&mamedesc,0,sizeof(MAMEDESC));
         mamedesc.nFreq=60;
         mamedesc.nPlayers=1;
         mamedesc.nCoins=1;
         mamedesc.nColorDepth=8;
         mamedesc.nColors=16;
         mamedesc.nHorizontal=1;
      }
      else
      {
//optional
         getdescgen(pWork,"romof",mamedesc.szCloneOf);

         switch(state)
         {
            case 0:
               state+=getdescgen(pWork,"name",mamedesc.szFileName);
               break;
            case 1:
               state+=getdescgen(pWork,"description",mamedesc.szDescription);
               break;
            case 2:
               state+=getdescgen(pWork,"year",mamedesc.szYear);
               break;
            case 3:
               state+=getdescgen(pWork,"manufacturer",mamedesc.szMan);
               break;
            case 4:
               if(getdescgen(pWork,"video",szWork))
               {
                  getdescorient(pWork,&mamedesc);
                  state++;
               }
               break;
            case 5:
               if(getdescgen(pWork,"input",szWork))
               {
                  getinputinfo(pWork,&mamedesc);
                  state++;
               }
               break;
            case 6:
               if(getdescgen(pWork,"driver",szWork))
               {
                  getdriverinfo(pWork,&mamedesc);
                  state++;
               }
         }
      }
	}

   if(*mamedesc.szFileName)
   {

      strupr(mamedesc.szFileName);
      strupr(mamedesc.szCloneOf);
//write out details to the MAME list
//^PACMAN{Pac Man (Midway){@nnn
      sprintf(buffer,"^%s{%s{%s{@%c",mamedesc.szFileName,mamedesc.szDescription,mamedesc.szCloneOf,
               (char)(32|mamedesc.nRotated|(mamedesc.nOkay<<1)|(mamedesc.nVector<<2)));
      fputs(buffer,fMame);
//check for a clone
      if(*mamedesc.szCloneOf)
      {
         if(strcmpi(mamedesc.szCloneOf,"NEOGEO"))
         {
//non-neogeo
//^PACMAN{PACMOD{
            sprintf(buffer,"^%s{%s{",mamedesc.szCloneOf,mamedesc.szFileName);
            fputs(buffer,fClone);
         }
         else
         {
//neogeo
//^RIDHERO{
            sprintf(buffer,"^%s{",mamedesc.szFileName);
            fputs(buffer,fNeo);
         }

      }
      sprintf(buffer,"^%s{@%c%c%c%c%c{%d{%s{%s{%s{%s{",mamedesc.szFileName,
                        (char)(128|mamedesc.nOkay|(mamedesc.nVector<<1)|
                        (mamedesc.nHorizontal<<2)|(mamedesc.nButtons<<3)),
                        (char)mamedesc.nFreq,(char)mamedesc.nPlayers,
                        (char)mamedesc.nCoins,(char)(128|mamedesc.nColorDepth),
                        mamedesc.nColors,
                        mamedesc.szResolution,mamedesc.szControl,
                        mamedesc.szYear,mamedesc.szMan);
      fputs(buffer,fInfo);
   }

	fclose(fin);
	fclose(fClone);
	fclose(fMame);
	fclose(fNeo);
	fclose(fInfo);
   unlink("c:\\xl$.tmp");
	return TRUE;

}

int getdescgen(char *in,char *szName,char *out)
{
	int ret=FALSE;

   if(strstr(in,szName)==in)
	{
		ret=TRUE;
		getentry(in,out);
	}
	return ret;
}


void getdescorient(char *in,pMAMEDESC pMameDesc)
{

	int x,y;
// video ( screen raster orientation vertical x 224 y 288 colors 16 freq 60 )
	if(strstr(in,"vertical"))
   {
		pMameDesc->nRotated=1;
      pMameDesc->nHorizontal=0;
   }
	else
   {
      pMameDesc->nHorizontal=1;
		pMameDesc->nRotated=0;
   }
   x=y=0;

	getintinfo(in,"x",&x);
	getintinfo(in,"y",&y);
	getintinfo(in,"colors",&pMameDesc->nColors);
	getintinfo(in,"freq",&pMameDesc->nFreq);

	sprintf(pMameDesc->szResolution,"%dx%d",x,y);

	if(strstr(in,"vector"))
		pMameDesc->nVector=1;
	else
		pMameDesc->nVector=0;

}


void getdriverinfo(char *in,pMAMEDESC pMameDesc)
{
	//driver ( status good color good hiscore good colordeep 8 credits "Allard van der Bas (original code)\nNicola Salmoria (MAME driver)" )
	getokinfo(in,"status",&pMameDesc->nOkay);
	getokinfo(in,"color",&pMameDesc->nColorOK);
	getintinfo(in,"colordeep",&pMameDesc->nColorDepth);
   if(!pMameDesc->nColorDepth)
      getintinfo(in,"palette_depth",&pMameDesc->nColorDepth);
}

void getinputinfo(char *in,pMAMEDESC pMameDesc)
{
	char	*pWork;
// input ( players 2 control joy4way buttons 4 coins 3 )
	getintinfo(in,"players",&pMameDesc->nPlayers);
	pWork=strstr(in,"control");
	if(pWork)
	{
		pWork+=8;
		getitem(pMameDesc->szControl,pWork,0,32,' ');
	}
	getintinfo(in,"coins",&pMameDesc->nCoins);
   getintinfo(in,"buttons",&pMameDesc->nButtons);
}



void getokinfo(char *in,char *szIdent,int *val)
{
	static char	szWork[512];
	static char	szTemp[128];
	char *pWork;
			int i;
			int b;


	*val=0;

	sprintf(szTemp,"%s ",szIdent);
	pWork=strstr(in,szTemp);

	

	if(pWork)
	{
		pWork+=strlen(szTemp);
		getitem(szWork,pWork,0,511,' ');


		if(strcmpi(szWork,"good"))
		{
			if (DisableImperfect)
			{
				if(strcmpi(szIdent,"status")==0)
				{
					if(strcmpi(szWork,"imperfect"))
						*val=0;
					else 
						*val=1;
				}
			}
			else 
				*val=0;
		}
		else
			*val=1;
	}
}

void getintinfo(char *in,char *szIdent,int *val)
{
	static char	szWork[512];
	static char	szTemp[128];
	char *pWork;

   *val=0;
	sprintf(szTemp,"%s ",szIdent);
	pWork=strstr(in,szTemp);
	if(pWork)
	{
		pWork+=strlen(szTemp);
		getitem(szWork,pWork,0,511,' ');
		*val=atoi(szWork);
	}
}
void getentry(char *in,char *out)
{
	char 	*pWork;
	pWork=in;

   *out=0;

	while(*pWork&&!isspace(*pWork))
		pWork++;
	if(*pWork)
		pWork++;
	if(*pWork=='"')
		pWork++;

   strncpy(out,pWork,255);
	out[255]=0;

	pWork=&out[strlen(out)-1];
	while(pWork>out&&(isspace(*pWork)||*pWork=='"'))
		pWork--;
	pWork++;
	*pWork=0;


}

/*
game (
	name pacman
	description "Pac Man (Midway)"
	year 1980
	manufacturer "[Namco] (Midway license)"
	rom ( name pacman.6e size 4096 crc c1e6ab10 )
	rom ( name pacman.6f size 4096 crc 1a6fb2d4 )
	rom ( name pacman.6h size 4096 crc bcdd1beb )
	rom ( name pacman.6j size 4096 crc 817d94e3 )
	rom ( name pacman.5e size 4096 crc 0c944964 )
	rom ( name pacman.5f size 4096 crc 958fedf9 )
	rom ( name 82s123.7f size 32 crc 2fc650bd )
	rom ( name 82s126.4a size 256 crc 3eb3a8e4 )
	rom ( name 82s126.1m size 256 crc a9cc86bf )
	rom ( name 82s126.3m size 256 crc 77245b66 )
	chip ( type cpu name Z80 clock 3072000 )
	chip ( type audio name Namco )
	video ( screen raster x 224 y 288 colors 16 freq 60 )
	input ( players 2 control joy4way coins 3 )
	driver ( status good color good hiscore good colordeep 8 credits "Allard van der Bas (original code)\nNicola Salmoria (MAME driver)" )
)
*/
