#ifndef _MAIN_H_
#define _MAIN_H_

#include <crt0.h>
#include <std.h>
#include <stdio.h>
#include <dos.h>
#include <bios.h>
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <math.h>
#include <mem.h>
#include <dir.h>
#include <string.h>
#include <process.h>
#include <time.h>
#include <sys/timeb.h>
#include <ctype.h>
#include <fcntl.h>
#include <io.h>
#include <dpmi.h>
#include <go32.h>
#include <sys/segments.h>
#include <sys/stat.h>
#include <sys/farptr.h>
#include <stdarg.h>
#include <audio.h>
#include "nkeys.h"
#include "mem.h"
#include "common.h"
#include "cab.h"
#include "key.h"
#include	"win.h"
#include "control.h"
#include "lst.h"

#define CLICK_DELAY	1

#define CONTROL_PLAYER1 0
#define CONTROL_PLAYER2 1

#define CFG_INT   0
#define CFG_BYTE  1

#define	IDFORECOLOUR	0
#define	IDBACKCOLOUR	1
#define	IDCLONECOLOUR	2
#define	IDEXTRACOLOUR	3
#define	IDCURSORCOLOUR	4
#define	IDSAVERTIME		5
#define	IDINCABINET		6
#define	IDCURREMU		7

#define	MAX_NEW_GAMES	100




//screen orientation
#define ORIENT_NORMAL         0
#define ORIENT_ROTATED_LEFT   1
#define ORIENT_ROTATED_RIGHT  2
#define ORIENT_MAX            2

//states for our main loop

#define MENU_STATE_GAMES         0
#define MENU_STATE_SET_LOAD      1
#define MENU_STATE_LOAD_ROMS     2
#define MENU_STATE_LOAD_MAME     3
#define MENU_STATE_RUN_UPDATE    4
#define MENU_STATE_CONFIG        5
#define MENU_STATE_HELP          6
#define MENU_STATE_ERROR         7
#define MENU_STATE_INFO          8
#define MENU_STATE_CONTROL       9
#define MENU_STATE_CHECK         10
#define MENU_STATE_EMULATOR      11
#define MENU_STATE_TEST          12
#define MENU_STATE_CUSTOM        13
#define MENU_STATE_CUSTOM_SET    14
#define MENU_STATE_UPDATE_GAMES  15
#define MENU_STATE_DOS_SHELL     16
#define MENU_STATE_CONVERGENCE   17
#define MENU_STATE_README        18
#define MENU_STATE_EDIT          19
#define MENU_STATE_AOS_CONFIG    20
#define MENU_STATE_AOS_README    21

// DANNY REGO
//#define MAX_CFGS           64
#define MAX_CFGS           65

#define CFG_TYPE_NUMBER    0
#define CFG_TYPE_TEXT      1
#define CFG_TYPE_REAL      2
#define CFG_TYPE_SPECIAL   3
#define CFG_TYPE_MIXED     4
#define CFG_TYPE_FLOAT     5
#define CFG_TYPE_CMD       6

#define EMU_MAME 0

#define MAX_EMUS 30

#define WTINI_NONE        0
#define WTINI_EMULATOR    1
#define WTINI_LOCAL       2

#define GAME_TYPE_FILE 0
#define GAME_TYPE_DIR   1
#define GAME_TYPE_ZIP   2

#define CFG_VAL_SIZE   (sizeof(int)*NO_DISP_CFGS)

#define BLANK_ORIENT   100

#define FPS_TEXT       "Average FPS:"
#define STANDARD_BACKDROP  "StandardBDrop"



#define  SHOW_CUSTOM_LIST     0
#define  CUSTOM_CHOOSE        1
#define	NO_CUSTOM_LISTS		8

#define CUSTOM_LIST  CustomList[CurEmu]
#define ROTATION     DispRot[CurEmu]

//internal config values
#define CUSTOM_LIST_OFFSET 650
#define AUTO_ROTATE_OFFSET (CUSTOM_LIST_OFFSET+10)
#define MOUSE_OFFSET       (AUTO_ROTATE_OFFSET+10)
#define SAVER_OFFSET       (MOUSE_OFFSET+10)
#define SCREEN_OFFSET      (SAVER_OFFSET+20)
#define FONT_OFFSET        (SCREEN_OFFSET+10)
#define SCHEME_OFFSET      (FONT_OFFSET+10)
#define INFO_OFFSET        (SCHEME_OFFSET+10)
#define KEY_OFFSET         (INFO_OFFSET+10)
#define SHIFT_OFFSET       (KEY_OFFSET+90)
#define JOY_OFFSET         (SHIFT_OFFSET+10)
#define SSHOT_OFFSET       (JOY_OFFSET+90)
#define JOYNAME_OFFSET     (SSHOT_OFFSET+10)
#define RES_OFFSET         (JOYNAME_OFFSET+10)
#define FILE_OFFSET        (RES_OFFSET+10)
#define SSPOS_OFFSET       (FILE_OFFSET+30)
#define TINT_OFFSET        (SSPOS_OFFSET+10)
#define START_OFFSET       (TINT_OFFSET+5)
#define CAPITAL_OFFSET     (START_OFFSET+5)

#define CAPITAL_NONE       CAPITAL_OFFSET
#define CAPITAL_SHORT      (CAPITAL_NONE+1)
#define CAPITAL_LONG       (CAPITAL_NONE+2)
#define CAPITAL_ALL        (CAPITAL_NONE+3)


#define TINT_NORMAL        TINT_OFFSET
#define TINT_RED           (TINT_OFFSET+1)
#define TINT_GREEN         (TINT_OFFSET+2)
#define TINT_BLUE          (TINT_OFFSET+3)
#define TINT_GREY          (TINT_OFFSET+4)


#define NO_MOUSE           MOUSE_OFFSET
#define STANDARD_MOUSE     MOUSE_OFFSET+1
#define TRACKBALL_MOUSE    MOUSE_OFFSET+2
#define SPINNER_MOUSE      MOUSE_OFFSET+3

#define SAVER_LENS         SAVER_OFFSET
#define SAVER_PUZZLE       SAVER_OFFSET+1
#define SAVER_STARS        SAVER_OFFSET+2
#define SAVER_LENS_PUZZLE  SAVER_OFFSET+3
#define SAVER_SCREENS      SAVER_OFFSET+4
#define SAVER_SCREENS_3D   SAVER_OFFSET+5
#define SAVER_SCREENS_LENS SAVER_OFFSET+6
#define SAVER_SMEAR        SAVER_OFFSET+7
#define SAVER_EXPLODE      SAVER_OFFSET+8
#define SAVER_SLATS        SAVER_OFFSET+9
#define SAVER_BLANK        SAVER_OFFSET+10
#define SAVER_JUKEBOX      SAVER_OFFSET+11


#define SCREEN_FLYERS      SCREEN_OFFSET+1
#define SCREEN_CABINET     SCREEN_OFFSET+2

#define JUKEBOX_RETURN     24

#define ARCADE_MODE        1
#define PAL_MODE           2


#define SSHOT_STANDARD     SSHOT_OFFSET
#define SSHOT_CYCLE        SSHOT_OFFSET+1
#define SSHOT_RANDOM       SSHOT_OFFSET+2


typedef BYTE *	pBYTE;



//needed for MAME source
typedef BYTE UINT8;
typedef unsigned short int UINT16;
typedef unsigned long int UINT32;
typedef char INT8;
typedef short int INT16;
typedef long int INT32;

#define  INFO_IDENT_CHAR   121


#define	MM	8

typedef struct
{
	char	szIdent[16];
	int	nDefault;
} SCANCODE;

typedef SCANCODE * pSCANCODE;


typedef struct
{
   char  szEmuName[32];  //Name of emulator
	char	szPath[512];	//path of emulator
	char	szExe[128];		//exe
	char	szInfoExe[128];	//exe used to get game / clone list
	char	szIni[128];		//ini file
   int   nWriteToIni;    //write to ini file ?
   int   bIniUsesEqual;  //ini uses equals
   int   bIniUsesMinus;  //ini uses minus
   char  szSingle[128]; //Single game text
	char	szPattern[256];	//file pattern(s)
   int   bDirectories;   //check directories ?
   int   bZipFiles;      //check zip files ?
   int   bNeedZipExtension;      //use .zip when running zip files ?
   char  szRomsDir[256];   //rompath
   char  szInCabinetOpts[256];   //options for InCabinet
   char  szDefaultOpts[256];  //default options
   char  szConfigFile[16]; //name of our config file
   int   bOptionsAsArgs;
   int   bReprogramVGA;
   int   bNoRedirect;
   int   bScreenShots;
   int   bSuffixOW;
   char  szGamePrefix[32];
/* EEA 08/26/00 Added this definition */
   char  szRomPath[128];
   int   bExtension;
   char  szSinglePath[256];
   char  szZipPath[128];
   char  szPCXPath[128];
   char  szPNGPath[128];
   char  szFlyerPath[256];
   char  szCabPath[256];   // EEA
   char  szPCXSuffix[8];
   char  szCommentChar[4];
   char  szBackdrop[16];
   char  szTableName[16];
   int   nGameTotals[NO_CUSTOM_LISTS][4];
   char  szCustomList[NO_CUSTOM_LISTS][16];
   char  szUpdateExe[16];
   int   nModeXDelay;   //delay before ModeX mode is reset to arcade mode
   int   bLowerCase;    //flag - indicates if file name is to be passed to the emu in lower case
   char  szRemapList[512]; //list of scancodes to remap
   int   nRemapType;       //type of remap (real or protected mode)
   int   bVirtualEmu;
   int   bAllEmu;
   int   bBlockText;
   int   bLowLevelRedirect;
   char  szReadMe[32];
   int   cShiftChar[6];
   int   bNoRemap;
   int   nDelLen;
   char  szCloneFile[16];
   int   bSupportsMerged;
   int   bSupportsRotation;
   char  rotleft[16];
   char  rotright[16];
   char  norot[16];

// DANNY REGO
   char  szLCDLogo[16];
   char  szLCDList[128];

} EMULATOR;

typedef EMULATOR * pEMULATOR;


typedef struct
{
	char	GameName[12];
   char  szDispName[64];
   char  szParent[12];
	char	szExtension[8];
	BYTE 	Orientation;
	BYTE	SaveOrient;
	BYTE	nGameType;
	short int nConfigs[MAX_CFGS];
 BYTE bRomFolder;                 // LasVegas - Added
	BYTE	bLocalConfig;
	BYTE	bChanged;
	fpos_t	fFilePos;
   BYTE bRandomRun;
} MAMEGAME;
typedef MAMEGAME *pMAMEGAME;


typedef struct
{
	char	GameName[12];
	char	szDispName[64];
   char  szParent[12];
	char	szExtension[8];          // LasVegas - Added
	BYTE 	Orientation;
	BYTE	SaveOrient;
	BYTE	nGameType;
	short int	nConfigs[MAX_CFGS];
	BYTE	bLocalConfig;
	BYTE	bChanged;
	fpos_t	fFilePos;
   BYTE bRandomRun;
} OLDMAMEGAME;
typedef OLDMAMEGAME *pOLDMAMEGAME;

typedef struct
{
   char  FileName[64];
   char  szParent[64];
	char	szExtension[8];
	BYTE	bType;
   char  szLongName[64];
   char  CRC32[16];
	BYTE	bGotName;
	BYTE	bRomFolder;              // LasVegas - Added
	BYTE	bRotated;
	BYTE	bOkay;
	BYTE	bVector;
}	GETFILE;

typedef GETFILE *pGETFILE;

#define  FILESIZE(x) (sizeof(GETFILE)*(x))


typedef struct
{
   int   Orientation;
	int	NoOnScreen;
   int   DispWidth;
	int	maxx;
	int	maxy;
   int   xoff;
   int   yoff;
   int   xwinoff;
   int   ywinoff;
	int	xpixel;
   int   actxsize;
	int	ypixel;
	int	memsize;
	int	fx;
	int	fy;
	int	mx;
	int	fsize;
   long  fpos;
	int	xcalc;
	int	ycalc;
	int	xcalcwin;
   int   ycalcwin;
} ORIENT;
typedef ORIENT * pORIENT;

#define  WIN_FONT    0
#define	DISP_FONT	1


typedef struct
{
 char szMenu[32];             //LasVegas - Added
	char	szIdent[32];
	short int	nValue;
	int	bWritten;
	int	nType;
	int	nDefault;
	int	min;
	int	max;
	int	Emu;
	int	bFound;
	char	szCommands[128];
	int	*pArcValue;
   BYTE  *pbArcValue;
   int   nOffSet;
   int   CfgType;
} CFGVALUE;

typedef CFGVALUE * pCFGVALUE;


typedef struct schemeTAG
{
   int scheme[16];
   int trans;
   int win;
} SCHEME;

typedef struct
{
	int	tot_cols;
	int 	tot_lines;
	int	line_cols[4];
	int	cur_col;
	int	cur_line;
	int	usr_cmd;
	int	do_once;
} LCDINFO;				// LasVegas - Parallel LCD Support

// LasVegas
extern LCDINFO	lcd_info;

#define MAX_SCHEMES  4

#define	CFG_ALL_SIZE	(sizeof(CFGVALUE)*MAX_CFGS)

void cursorcheck(void);
void setscreenorient(void);
int movecursor(int *pNoGames,int *pDispRot);
void movefilecursor(int *CurPos,int *pNoValues,int *pOffSet);
int handlekeyjoy(int bStopRepeat);
int changemenuorient(void);
void generror(void);
void seterror(char *szLine1,char *szLine2);
void stripcontrolchars(char *szIn);
void disperror(void);
int handlemovement(int *CurPos,int *pNoGames,int *pOffSet,int NoInPage);
void movecfgcursor(int *pCfgPos,int *pNoCfgValues,int *pCfgOff,pCFGVALUE pcfgValues,int nIndex);
int getbackdrop(void);
void showgames(void);
int autorepeat(int nindex,pCFGVALUE pcfgValues);
int checkscrsave(clock_t tickcount);
pBYTE allocscreen(void);
void freescreen(void);
int controlmenu(int *bFirst,int Shadow,int Explode);
void movecontcursor(int *CurPos,int *pNoValues);
void setmenu(void);
void emumenu(void);
void moveemu(void);
void mousemove(int nKey);
void gamesproc(int Message,int Data1,int Data2,void *pData);
void stdproc(int Message,int Data1,int Data2,void *pData);
void emuproc(int Message,int Data1,int Data2,void *pData);
int stdselect(int my,pWINSTRUCT pWinStruct,int cpos,int max,int *nsel);
void handlescroll(int Data1,int nfarright,int nbotright,pWINSTRUCT pgamewin,int nsel,int botbutt,int message);
int allocpcx(void);
void freepcx(void);
int randomgame(void);
void showcustom(int nType);
void movecustom(int nType);
void cfgproc(int Message,int Data1,int Data2,void *pData);
void reloadgames(int bMessage);
void movecenter(void);
void movescreen(int xmove,int ymove);
void calibratetick(void);
void setinternalcfg(void);
void checkdpmi(void);
void nextcustomlist(void);
void fontchanged(void);
void schemechanged(void);
int isxmas(void);
void setuprandomlist(int nGames);
void exitaos(int nExit);
void setcfgidents(char *pIn,int offset);

#include "fil.h"
#include "pcx.h"
#include "config.h"
#include "sound.h"
#include "globals.h"


#endif
