#include "main.h"

//uncomment this for logging of allocs/frees
//#define MEM_LOGGING

void *myalloc(unsigned long lSize)
{
	void *ret;
	ret=malloc((size_t)lSize);
#ifdef MEM_LOGGING
   if(ret)
      loginfo(1,"Allocated %ld bytes Ptr=%u",lSize,(unsigned int)ret);
   else
      loginfo(1,"FAILED to Allocate %ld bytes",lSize);
#endif
	return ret;
}

void myfree(void *pf)
{
	if(pf)
		free(pf);
#ifdef MEM_LOGGING
   loginfo(1,"Freed memory, ptr=%u",(unsigned int)pf);
#endif
}


int strcmpi(char *s1,char *s2)
{
	char	small1[1024];
	char	small2[1024];

	char	*w1;
	char	*w2;
	int	ret;

	if(strlen(s1)<1024)
		w1=small1;
	else
		w1=myalloc(strlen(s1)+1);

	if(strlen(s2)<1024)
		w2=small2;
	else
		w2=myalloc(strlen(s2)+1);

	strcpy(w1,s1);
	strcpy(w2,s2);
	strupr(w1);
	strupr(w2);
	ret=strcmp(w1,w2);

	if(w1!=small1)
		myfree(w1);
	if(w2!=small2)
		myfree(w2);
	return ret;
}


