#include "main.h"
#include "mouse.h"
#include "disp.h"

static int m_maxx=-1;
static int m_maxy=-1;

static	__dpmi_regs mouse_regs;

int CheckMouse(void)
{
   int retval;

	mousefunc(0x00);
	retval=(int)mouse_regs.x.ax;

	if(retval)
	{
//we've got a mouse
      setmousesens();
      loginfo(1,"Found Mouse");
      loginfo(1,"Mouse Max - x:%d  y:%d",m_maxx,m_maxy);
      if(MouseDrivX<0||MouseDrivX>m_maxx)
         MouseDrivX=m_maxx>>1;
      if(MouseDrivY<0||MouseDrivY>m_maxy)
         MouseDrivY=m_maxy>>1;
//set mouse position
      mouse_regs.x.cx=MouseDrivX;
      mouse_regs.x.dx=MouseDrivY;
      mousefunc(0x04);
	}
	else
      loginfo(1,"No Mouse Found");

	return retval;
}

void ReadMouse(short int *but,short int *x,short int *y)
{
   short int work;
   mousefunc(0x03);
//get the buttons
   if(!noSwapMouse)
   {
//swap the mouse buttons
      work=(short int)mouse_regs.x.bx;
      *but=(((work&1)<<1)|((work&2)>>1)|(work&4));
   }
   else
      *but=(short int)mouse_regs.x.bx;

//and the relative motion
   mousefunc(0x0b);
   *x=(short int)mouse_regs.x.cx;
   *y=(short int)mouse_regs.x.dx;
}

void setmousesens(void)
{
   int oldmaxx,oldmaxy;
   int oldx,oldy;
   int adjx,adjy;

   mousefunc(0x03);
   oldx=mouse_regs.x.cx;
   oldy=mouse_regs.x.dx;

   oldmaxx=m_maxx;
   oldmaxy=m_maxy;

   m_maxx=(int)(640.0F*((1.0F/(float)MouseSensX)*100.0F));
   m_maxy=(int)(480.0F*((1.0F/(float)MouseSensY)*100.0F));
   mouse_regs.x.cx=0;
   mouse_regs.x.dx=m_maxx;
   mousefunc(0x07);
   mouse_regs.x.cx=0;
   mouse_regs.x.dx=m_maxy;
   mousefunc(0x08);

   loginfo(1,"setting mouse sensitivity xsens:%d ysens:%d",
                        MouseSensX,MouseSensY);
//rough adjust of cursor position
   if(oldmaxx!=-1&&(oldmaxx!=m_maxx||oldmaxy!=m_maxy))
   {
      adjx=(int)((float)((float)oldx/(float)oldmaxx)*((float)m_maxx));
      adjy=(int)((float)((float)oldy/(float)oldmaxy)*((float)m_maxy));
      mouse_regs.x.cx=adjx;
      mouse_regs.x.dx=adjy;
      mousefunc(0x04);
   }
}

void GetRealMousePos(void)
{
	int	sx,sy;
	int	mx,my,dummy;
	static int first=TRUE;

	mousefunc(0x03);

	MouseDrivX=mouse_regs.x.cx;
	MouseDrivY=mouse_regs.x.dx;

	sx=(int)mouse_regs.x.cx/(float)((float)m_maxx/(float)ScreenOrient.xpixel);
   sy=(int)mouse_regs.x.dx/(float)((float)m_maxy/(float)ScreenOrient.ypixel);


	switch(ScreenOrient.Orientation)
	{
		case ORIENT_ROTATED_RIGHT:
			my=(int)((float)sx*((float)ScreenOrient.xpixel/((float)ScreenOrient.ypixel)));
			mx=(ScreenOrient.ypixel-sy)*((float)ScreenOrient.xpixel/((float)ScreenOrient.ypixel));
			break;
		case ORIENT_ROTATED_LEFT:
			my=(int)((float)(ScreenOrient.xpixel-sx)*((float)ScreenOrient.xpixel/(float)ScreenOrient.ypixel));
			mx=(int)((float)sy*((float)ScreenOrient.xpixel/(float)ScreenOrient.ypixel));
			break;
		default:
			mx=sx;
			my=sy;
			break;
	}

	if((MouseX!=mx||MouseY!=my)&&!first)
	{
		if(mx>0&&mx<ScreenOrient.xpixel-8&&my>0&&my<ScreenOrient.ypixel-8)
			MouseEvent=TRUE;
	}

	first=FALSE;
	MouseX=mx;
	MouseY=my;
	if(MouseX>ScreenOrient.xpixel-9)
		MouseX=ScreenOrient.xpixel-9;
	if(MouseY>ScreenOrient.ypixel-9)
		MouseY=ScreenOrient.ypixel-9;
	if(MouseX<9)
		MouseX=9;
	if(MouseY<9)
		MouseY=9;
}

void mousefunc(int func)
{
	mouse_regs.x.ax=func;
	__dpmi_int(0x33, &mouse_regs);
}

void mousemove(int nKey)
{
   switch(nMouseType)
   {
      case TRACKBALL_MOUSE:
         if(nKey!=K_LEFT&&nKey!=K_RIGHT)
            keys[nKey]=1;
         break;
      case SPINNER_MOUSE:
         if(nKey==K_LEFT)
            keys[K_UP]=1;
         if(nKey==K_RIGHT)
            keys[K_DOWN]=1;
         break;
   }
}

