#include "main.h"
#include "scrasm.h"



BYTE	DimPalette[256];


int loadpcx(char *filename,PPCXSTRUCT pcx)
{
	int infile;
   int pcxtype=-1;


	if(!filename||!*filename)
		return FALSE;
	if((infile=open(filename,O_BINARY))==NULL)
		return FALSE;


//Read header from PCX file:
	read(infile,&(pcx->header),sizeof(PCXHEADER));

//see what type of PCX it is
	switch(pcx->header.bits_per_pixel)
	{
		case 1:
			switch(pcx->header.color_planes)
			{
				case 4:
//16 colours
					pcxtype=PCX_16;
					break;
				case 1:
//2 colours
					pcxtype=PCX_2;
					break;
			}
			break;
		case 8:
			if(pcx->header.color_planes==1)
//256 colours
				pcxtype=PCX_256;
	}

//unsupported PCX (probably true colour)
	if(pcxtype==-1)
	{
		close(infile);
		return FALSE;
	}

//Decompress bitmap and place in buffer,
	if(!loadimage(infile,pcx,pcxtype))
	{
		close(infile);
		return FALSE;
	}
//get the pallette
	loadpallette(infile,pcx,pcxtype);
//all done
	close(infile);
	return TRUE;
}


int loadimage(int pcxfile,PPCXSTRUCT pcx,int pcxtype)
{
	const int BYTEMODE=0, RUNMODE=1;
	pBYTE   pfInBuffer;
	pBYTE   pfImage;
   pBYTE   pfWork;
	int lsize;
	int	h,w;
	int	bufptr=0;
	int mode=BYTEMODE;
	int readlen;
	int	xcomp,ycomp,perc;
	int	xcnt,ycnt,xerror,yerror;
	int	saveout,outpos;
	int	nWork;
	int	bAlwaysX=FALSE;
	int	nobytes;
   int XSize,YSize;

	static BYTE outbyte;
	static BYTE bytecount;
	BYTE	outline[2048];
	int	ii;
	int	xx;
	BYTE	aval;
	BYTE	outval;
	int	gotline=FALSE;
   SOUND_UPDATE_INIT

	lsize=ScreenOrient.memsize;

   if(!noRotatePics)
   {
      switch(ScreenOrient.Orientation)
      {
         case ORIENT_NORMAL:
            XSize=ScreenOrient.xpixel;
            YSize=ScreenOrient.ypixel;
            break;
         default:
            XSize=ScreenOrient.ypixel;
            YSize=ScreenOrient.xpixel;
      }
   }
   else
   {
      XSize=ScreenOrient.xpixel;
      YSize=ScreenOrient.ypixel;
   }


   pfInBuffer=myalloc(ScreenOrient.memsize);
	if(!pfInBuffer)
		return FALSE;

	memset(outline,0,2048);

//get the dimensions
	h=(pcx->header.ymax-pcx->header.ymin)+1;
	w=(pcx->header.xmax-pcx->header.xmin)+1;
	nobytes=pcx->header.bytes_per_line;


//find the biggest dimension
	outpos=0;

   xcomp=w-XSize;
   ycomp=h-YSize;
	if(xcomp>0||ycomp>0)
	{
		if(xcomp>ycomp)
//scale x to fit
         perc=(int)((XSize*100)/(long)w);
		else
//scale y to fit
         perc=(int)((YSize*100)/(long)h);
//make them both fit
		while(TRUE)
		{
			xcomp=(int)((long)((long)perc*(long)w)/100L);
			ycomp=(int)((long)((long)perc*(long)h)/100L);
         if(xcomp>XSize||ycomp>YSize)
			{
				perc--;
				if(perc==0)
					break;
			}
			else
				break;
         SOUND_UPDATE_TRIP(200)
		}
	}
   else
   {
      if(!noScaleToFit)
      {
         if(xcomp<ycomp)
//scale x to fit
            perc=(int)((XSize*100)/(long)w);
         else
//scale y to fit
            perc=(int)((YSize*100)/(long)h);
//make them both fit
         while(TRUE)
         {
            xcomp=(int)((long)((long)perc*(long)w)/100L);
            ycomp=(int)((long)((long)perc*(long)h)/100L);
            if(xcomp>XSize||ycomp>YSize)
            {
               perc--;
               if(perc==0)
                  break;
            }
            else
               break;
            SOUND_UPDATE_TRIP(200)
         }
			if(perc<100)
				perc=100;
        }
        else
            perc=100;
    }


	readlen=0;

	outval=1;
	pfImage=pcx->image;
	memset(pfImage,0,ScreenOrient.memsize);
//Loop for entire length of bitmap buffer:
	xerror=yerror=0;
	xcnt=ycnt=0;
	if(perc==100)
	{
      outpos=((XSize-w)>>1)+(((YSize-h)>>1)*XSize);
      if(noScaleToFit)
      {
         switch(SSPosition)
         {
            case SSPOS_OFFSET+1:
               outpos=XSize-w;
               break;
            case SSPOS_OFFSET+2:
               outpos=XSize-w+((YSize-h)*XSize);
               break;
            case SSPOS_OFFSET+3:
               outpos=XSize-w+(((YSize-h)>>1)*XSize);
               break;
         }
      }
		saveout=outpos;
	}
	else
	{
      if(w>XSize||(w<XSize&&!noScaleToFit))
      {
         nWork=(int)(((long)w*(long)perc)/100L);
      }
      else
      {
         nWork=w;
         bAlwaysX=TRUE;
      }
      outpos=(XSize-nWork);
		outpos>>=1;
      nWork=(YSize-((int)(((long)h*(long)perc)/100L)))>>1;
      outpos+=(nWork*XSize);
		saveout=outpos;
	}

   updatesound();
	while(TRUE)
	{

      SOUND_UPDATE_TRIP(200)
      if(mode==BYTEMODE)
		{
			if(bufptr>=readlen)
			{
				bufptr=0;
				if((readlen=read(pcxfile,pfInBuffer,lsize))==0)
					break;
			}
			outbyte=pfInBuffer[bufptr++]; // Next byte of bitmap
			if (outbyte>0xbf)
			{
//Calculate number of bytes in run:
				bytecount=(int)(outbyte-192);

				if(bufptr>=readlen)
				{
					bufptr=0;
//Read more bytes from file into buffer;
//if no more bytes left, break out of loop

					if((readlen=read(pcxfile,pfInBuffer,lsize))==0)
						break;
				}
				outbyte=pfInBuffer[bufptr++];
//Switch to run-length mode:
				if(--bytecount>0)
					mode=RUNMODE;
			}
		}
		else
		{
			if(--bytecount==0)
				mode=BYTEMODE;
		}
//write the byte out to our line buffer
		switch(pcxtype)
		{
			case	PCX_256:
//easy, just byte for byte
				outline[xcnt++]=outbyte;
				if(xcnt>=nobytes)
				{
					xcnt=0;
					gotline=TRUE;
				}
				break;
			case	PCX_16:
//tricky,need to get 4 planes
				aval=128;
				for(ii=0;ii<8;ii++,aval>>=1)
				{
					if(outbyte&aval)
						outline[xcnt]|=(16+outval);

					xcnt++;
					if(xcnt>=(nobytes<<3))
					{
						outval<<=1;
						xcnt=0;
						if(outval==16)
						{
							outval=1;
							gotline=TRUE;
						}
					}
				}
				break;
			case	PCX_2:
//black and white
				aval=128;
				for(ii=0;ii<8;ii++,aval>>=1)
				{
					if(outbyte&aval)
						outline[xcnt]=15;
					xcnt++;
					if(xcnt>=(nobytes<<3))
					{
						xcnt=0;
						gotline=TRUE;
					}
				}
				break;


		}
//got a full scan line yet ?
		if(gotline)
		{
//yep, so write it out
			gotline=FALSE;
			if(perc==100)
			{
				for(xx=0;xx<w;xx++)
				{
					pfImage[outpos++]=outline[xx];
					outline[xx]=0;
				}
            outpos=saveout+XSize;
				saveout=outpos;
			}
			else
			{
				yerror+=perc;
                if(yerror>100)
                {
                    while(yerror>100)
                    {
                        if(bAlwaysX)
                        {
                            for(xx=0;xx<w;xx++)
                            {
                                pfImage[outpos++]=outline[xx];
                                outline[xx]=0;
                            }
                        }
                        else
                        {
                            xerror=0;
                            for(xx=0;xx<w;xx++)
                            {
                                xerror+=perc;
                                while(xerror>100)
                                {
                                    pfImage[outpos++]=outline[xx];
                                    xerror-=100;
                                }
                            }
                        }
                        outpos=saveout+XSize;
                        saveout=outpos;
                        yerror-=100;
                    }
                }
                else
                {
                    if(noScaleToFit)
                        memset(outline,0,w);
                }

			}
			xcnt=0;
			ycnt++;
			if(ycnt>=h)
				break;
		}
		if(outpos>=ScreenOrient.memsize)
			break;
	}

    if(!noRotatePics)
    {
        pfWork=myalloc(ScreenOrient.memsize);
        switch(ScreenOrient.Orientation)
        {
            case ORIENT_ROTATED_LEFT:
                for(h=0;h<ScreenOrient.ypixel;h++)
                    for(w=0;w<ScreenOrient.xpixel;w++)
                        pfWork[w+(((ScreenOrient.ypixel-1)-h)*ScreenOrient.xpixel)]=pfImage[(w*XSize)+h];
                memcpy(pfImage,pfWork,ScreenOrient.memsize);
                break;
            case ORIENT_ROTATED_RIGHT:
                for(h=0;h<ScreenOrient.ypixel;h++)
                    for(w=0;w<ScreenOrient.xpixel;w++)
                        pfWork[((ScreenOrient.xpixel-1)-w)+(h*ScreenOrient.xpixel)]=pfImage[(w*XSize)+h];
                memcpy(pfImage,pfWork,ScreenOrient.memsize);

        }

        myfree(pfWork);
    }
    myfree(pfInBuffer);
	return TRUE;
}


void loadpallette(int pcxfile,PPCXSTRUCT pcx,int pcxtype)
{
	int	i;
   int work;
	switch(pcxtype)
	{
		case	PCX_256:
//nice 256 colour palette
			lseek(pcxfile,-768L,SEEK_END);
			read(pcxfile,pcx->palette,768);
         for(i=0;i<768;i++)
            pcx->palette[i]>>=2;
			break;
		case	PCX_16:
//not so nice 16 colour palette
			memset(pcx->palette,0,768);
			memcpy(&pcx->palette[16*3],pcx->header.palette16,16*3);
			for(i=0;i<16*3;i++)
				pcx->palette[i+(16*3)]>>=2;
			break;
		case	PCX_2:
//black and white, use normal palette
			memset(pcx->palette,0,768);
			getpal(pcxback.palette,16);
			break;

	}

}


void makepcxpal()
{
	unsigned	int	n;
	static char	buffer[256];
	static	BYTE	stdpal[48];
	int	freecol;
	int	i;
	long	int   ri,gi,bi,val,lowval;
   SOUND_UPDATE_INIT

	BYTE	r,g,b,r2,g2,b2;
	BYTE	pixel;
	BYTE	newindex;
	BYTE	*ppal;
	int	remappal[16];
	int	NoUsedCols;


	memset(buffer,0,(sizeof(BYTE)*256));


	for(i=0;i<16;i++)
	{
		remappal[i]=i;
		buffer[i]=1;
	}

	NoUsedCols=16;

//get the existing palette
	getpal(stdpal,16);

//now remap colours in PCX file to leave
//the first 16 colours as is

//make sure we've got a backdrop
	if(bGotBack)
	{
		for(n=0;n<ScreenOrient.memsize;n++)
		{
			if(!buffer[pcxback.image[n]])
			{
				NoUsedCols++;
				buffer[pcxback.image[n]]=1;
			}
		}
		for(n=0;n<ScreenOrient.memsize;n++)
		{
         SOUND_UPDATE_TRIP(200)
         pixel=pcxback.image[n];
			newindex=pixel;

			if(pixel<16)
			{
//make sure we only do the calculation once
//per colour
				if(remappal[pixel]<16)
				{
//in the first 16, get the r,g,b value
					r=pcxback.palette[pixel*3];
					g=pcxback.palette[(pixel*3)+1];
					b=pcxback.palette[(pixel*3)+2];
//check for a free colour
					if(NoUsedCols<256)
					{
						for(freecol=16;freecol<256;freecol++)
						{
							if(!buffer[freecol])
							{
								remappal[pixel]=freecol;
								buffer[freecol]=1;
								pcxback.palette[freecol*3]=r;
								pcxback.palette[(freecol*3)+1]=g;
								pcxback.palette[(freecol*3)+2]=b;

								NoUsedCols++;
								break;
							}
						}
					}
					else
					{
//then find the nearest match
						lowval=ScreenOrient.memsize;
						ppal=&pcxback.palette[48];
						for(i=16;i<256;i++)
						{
							r2=*ppal++;
							g2=*ppal++;
							b2=*ppal++;
//fast approx of vector magnitude
//to get nearest colour.
//we don't need an accurate magnitude -
//just a comparison value
							ri=abs(r2-r);
							gi=abs(g2-g);
							bi=abs(b2-b);
							val=(ri+gi+bi);
							if(val<lowval)
							{
								lowval=val;
								newindex=i;
							}
						}
					  remappal[pixel]=newindex;
					}
				}
				pcxback.image[n]=remappal[pixel];
			}

			if(!buffer[pcxback.image[n]])
			{
				NoUsedCols++;
				buffer[pcxback.image[n]]=1;
			}
		}
	}
	else
	{
//no picture - use VGA palette
		getpal(pcxback.palette,256);
	}

	memcpy(pcxback.palette,stdpal,48);


//write fist degree dims into free colours
//this is for low colour count screen shots
	if(NoUsedCols<256)
	{
		n=0;
		while(TRUE)
		{
			if(NoUsedCols>=256)
				break;
			if(n>=256)
				break;
//find a used colour
			if(buffer[n]==1)
			{
				i=0;
				while(TRUE)
				{
					if(i>=256)
						break;
//find a free colour
					if(buffer[i]==0)
					{
//and put in a dimmed existing colour
						pcxback.palette[i*3]=(int)(((float)(100-Transparent)/100.0F)*(float)pcxback.palette[n*3]);
						pcxback.palette[(i*3)+1]=(int)(((float)(100-Transparent)/100.0F)*(float)pcxback.palette[(n*3)+1]);
						pcxback.palette[(i*3)+2]=(int)(((float)(100-Transparent)/100.0F)*(float)pcxback.palette[(n*3)+2]);
						buffer[i]=2;
						NoUsedCols++;
						break;
					}
					i++;
				}
			}
			n++;
		}
	}
//copy across the standard 16 colours
	memcpy(pcxback.palette,stdpal,48);
   if(bGotBack)
   {
      if(TintType!=TINT_NORMAL)
      {
         for(n=16;n<256;n++)
         {
            BYTE work=(BYTE)((float)(pcxback.palette[(n*3)]+pcxback.palette[(n*3)+1]+pcxback.palette[(n*3)+2])/3.0F);
            switch(TintType)
            {
               case TINT_GREY:
                     pcxback.palette[(n*3)]=work;
                     pcxback.palette[(n*3)+1]=work;
                     pcxback.palette[(n*3)+2]=work;
                     break;
               case TINT_RED:
                     pcxback.palette[(n*3)]=work;
                     pcxback.palette[(n*3)+1]=0;
                     pcxback.palette[(n*3)+2]=0;
                     break;
               case TINT_GREEN:
                     pcxback.palette[(n*3)]=0;
                     pcxback.palette[(n*3)+1]=work;
                     pcxback.palette[(n*3)+2]=0;
                     break;
               case TINT_BLUE:
                     pcxback.palette[(n*3)]=0;
                     pcxback.palette[(n*3)+1]=0;
                     pcxback.palette[(n*3)+2]=work;
                     break;

            }
         }
      }
   }

//now get 'dimmed' version of each color
//so we can do 'shadows'
	for(n=0;n<256;n++)
	{
		r=(int)(((float)(100-Transparent)/100.0F)*(float)pcxback.palette[n*3]);
		g=(int)(((float)(100-Transparent)/100.0F)*(float)pcxback.palette[(n*3)+1]);
		b=(int)(((float)(100-Transparent)/100.0F)*(float)pcxback.palette[(n*3)+2]);
//then find the nearest match
		lowval=ScreenOrient.memsize;
		ppal=pcxback.palette;
		newindex=0;
		for(i=0;i<256;i++)
		{
			r2=*ppal++;
			g2=*ppal++;
			b2=*ppal++;
//fast approx of vector magnitude
//to get nearest colour.
//we don't need an accurate magnitude -
//just a comparison value
			ri=abs(r2-r);
			gi=abs(g2-g);
			bi=abs(b2-b);
			val=(ri+gi+bi);
			if(val<=lowval)
			{
				lowval=val;
				newindex=i;
			}
		}
		DimPalette[n]=newindex;

	}
//then set the palette
	setpcxpal(pcxback.palette);
}

int compresspcx(PPCXSTRUCT pcx)
{
	pBYTE	scratch;
	pBYTE	pfout;
	pBYTE	pfwork;
	int	csize;
	int	ptr;
	int	pixrun;
	BYTE	pixval;
	int	runval;
   int   x,y;

	scratch=myalloc(ScreenOrient.memsize*2);

	csize=0;

	pixrun=0;
	pixval=0;
	runval=0;
	pfwork=pcx->image;
	pfout=scratch;

   for(y=0;y<ScreenOrient.ypixel;y++)
   {
      for(x=0;x<ScreenOrient.xpixel;x++)
      {
         pixval=*pfwork++;
         if(pixval&0xc0)
         {
            *pfout++=0xc1;
         }
         *pfout++=pixval;
      }
   }
/*
   for(ptr=0;ptr<ScreenOrient.memsize;ptr++)
	{
		pixval=*pfwork++;
		if((pixval&192))
		{
			if(pixrun)
			{
				if(pixrun==1)
				{
					*pfout++=runval;
				}
				else
				{
					*pfout++=192|pixrun;
					*pfout++=runval;
				}
			}
			*pfout++=193;
			*pfout++=pixval;
			pixrun=0;
		}
		else
		{
			if(pixrun==0)
			{
				runval=pixval;
				pixrun=1;
			}
			else
			{
				if(pixval==runval)
				{
					pixrun++;
					if(pixrun==63)
					{
						*pfout++=255;
						*pfout++=runval;
						pixrun=0;
					}
				}
				else
				{
					if(pixrun)
					{
						if(pixrun==1)
						{
							*pfout++=runval;

						}
						else
						{
							*pfout++=192|pixrun;
							*pfout++=runval;
						}
					}
					pixrun=1;
					runval=pixval;
				}
			}

		}
	}

	if(pixrun)
	{
		if(pixrun==1)
		{
			*pfout++=runval;

		}
		else
		{
			*pfout++=192|pixrun;
			*pfout++=runval;

		}
	}
*/
	csize=(int)(pfout-scratch);

//allocate space for the thing
	pcx->cimage=myalloc(csize);
//and copy it across
	memcpy(pcx->cimage,scratch,csize);
	pcx->clength=csize;
	myfree(scratch);

	return TRUE;
}

int savepcx(char *filename,PPCXSTRUCT pcx)
{
	int	outfile,n;
	BYTE	work;

	outfile=open(filename,O_CREAT|O_TRUNC|O_WRONLY|O_BINARY,S_IWRITE);
	if(outfile==-1)
	{
		printf("Unable to create PCX file %s\n",filename);
		return FALSE;
	}
//write out the header
	write(outfile,&pcx->header,sizeof(PCXHEADER));
	compresspcx(pcx);

//and the bitmap
	write(outfile,pcx->cimage,pcx->clength);
	work=12;
	write(outfile,&work,1);


//and the palette
	for(n=0;n<768;n++)
		pcx->palette[n]<<=2;
	write(outfile,&pcx->palette,768);
	for(n=0;n<768;n++)
		pcx->palette[n]>>=2;

	close(outfile);


	return	TRUE;
}

void savesshot(void)
{
	static char szName[32];
	int	n=0;
	PCXSTRUCT pcx;
	while(TRUE)
	{
		if(n)
			sprintf(szName,"arc%d.pcx",n);
		else
			strcpy(szName,"arc.pcx");
		if(!checkfile(szName))
			break;
		n++;
		if(n>999)
			break;
	}
	if(n==1000)
		return;

	memcpy(&pcx,&pcxback,sizeof(PCXSTRUCT));
	pcx.header.xmax=ScreenOrient.xpixel-1;
	pcx.header.ymax=ScreenOrient.ypixel-1;
	pcx.image=screen;
	pcx.header.bytes_per_line=(ScreenOrient.xpixel);
   loginfo(1,"Saving Screen Shot %s",szName);
	savepcx(szName,&pcx);
}


