#ifndef _PCX_H_
#define _PCX_H_

#define	PCX_256		0
#define  PCX_16      1
#define  PCX_2       2

typedef struct
{
	char manufacturer;    // Always set to 0
	char version;         // Always 5 for 256-color files
	char encoding;        // Always set to 1
	char bits_per_pixel;  // Should be 8 for 256-color files
	short int  xmin,ymin;       // Coordinates for top left corner
	short int  xmax,ymax;       // Width and height of image
	short int  hres;            // Horizontal resolution of image
	short int  vres;            // Vertical resolution of image
	char palette16[48];   // EGA palette; not used for 256-color files
	char reserved;        // Reserved for future use
	char color_planes;    // Color planes
	short int  bytes_per_line;  // Number of bytes in 1 line of pixels
	short int  palette_type;    // Should be 2 for color palette
	char filler[58];      // Nothing but junk
} PCXHEADER;


typedef struct
{
	PCXHEADER header;
   pBYTE image; // Pointer to a buffer holding bitmap
   BYTE *cimage; // Point to a buffer holding a compressed version of the PCX bitmap
   BYTE palette[768]; // Array holding the 768-byte palette
   int clength;  // Length of the compressed bitmap
} PCXSTRUCT;

typedef PCXSTRUCT * PPCXSTRUCT;

int loadpcx(char *,PPCXSTRUCT);
int loadimage(int,PPCXSTRUCT,int pcxtype);
void loadpallette(int,PPCXSTRUCT,int pcxtype);
void makepcxpal(void);
int savepcx(char *filename,PPCXSTRUCT pcx);
int compresspcx(PPCXSTRUCT pcx);
void savesshot(void);

#endif
