#include "pmwrap.h"
#include "common.h"
#include <dos.h>
#include <process.h>

//#define FILE_CHK

//Protected Mode Wrapper -
//lets us remap keyboard input for protected mode apps
// - the actually remapping is done in wrapasm.s


__dpmi_paddr old_key;
__dpmi_paddr rkaddr;


short CodeSeg;
short DOSSeg;
int JukeBox;
short int nStart12Esc;
unsigned char ShiftKey;
unsigned char OStart;
short int keyinp;
short int start1;
short int start2;
short int escsent;
short int setdel;
short int dellen;
short int test=0;
short int test2=0;
unsigned char coin1=4;
unsigned char altstate,escstate;

//our stack
unsigned char stackbucket[16384];
unsigned char *istack;
//our scancodes
unsigned char origcode[44];
unsigned char newcode[88];
//shift funtions
unsigned char shift[6];
unsigned char shiftsent[6];
unsigned char shiftkey[6];
//stuff for debug
unsigned char lkeys[128];
unsigned short lpos=0;

unsigned long RMseg;
unsigned int RMsel;
char *pFMem;

char *pCur;

//stuff for the real mode interrupt
static _go32_dpmi_seginfo rmint;
static _go32_dpmi_seginfo oldvect;
static __dpmi_regs rmregs;

int des;



int main(int argc,char **argv)
{
	int n;
   FILE *fout;
	char *pWork;
	static char szCom[1024];
	static char szRemap[1024];
   static char szShifts[1024];


	istack=stackbucket+8150;
   keyinp=0;
	CodeSeg=_my_cs();
   DOSSeg=_dos_ds;

//open up the virtual file
   rkaddr.selector = CodeSeg;
   rkaddr.offset32 = (long)_new_key;

//setup our real mode interrupt
   rminit();
//clear down everything
	start1=start2=escsent=setdel=0;
	altstate=escstate=(unsigned char)128;
	dellen=1;
	memset(origcode,0,44);
	memset(newcode,0,88);
   memset(shift,0,6);
   memset(shiftsent,0,6);
   memset(shiftkey,0,6);
//get our instructions from real mode AOS
   fopenRM();
   fgetsRM(szCom,1023);
   fgetsRM(szRemap,1023);
//check for juke box
   if(strstr(szRemap,COMMAND_JUKEBOX))
   {
      *szRemap=0;
      JukeBox=1;
      fgetsRM(szRemap,1023);
   }
//setup the key remaps
   addremaps(szRemap);
   fgetsRM(szShifts,1023);
//setup the shift functions
   if(!strstr(szShifts,NO_SHIFTS))
      addshifts(szShifts);
   fcloseRM();
//lock everything
   lockint();
//call the emu/app
   system(szCom);
//make sure we didn't leave alt pressed
	_clearalt();

#ifdef FILE_CHK
   fout=fopen("d:\\arc32\\k.txt","wt");

 	for(n=0;n<lpos;n++)
        fprintf(fout,"(%d)=%d:%d\n",(int)lkeys[n],(int)(lkeys[n]&127),(int)(lkeys[n]&128));
   fclose(fout);
#endif
//tidy up the real mode interrupt
   rmclose();
	exit(EXIT_SUCCESS);
}

void lockint()
{
//lock data/code used by the handlers
//This stops the DPMI Server from swapping our interrupt handler/data out to disk
//- which causes a page fault
//Generally , this would happen in pure DOS when loading a large game

//Data
   QUICK_LOCK(rmint);
   QUICK_LOCK(oldvect);
   QUICK_LOCK(rmregs);
   QUICK_LOCK(CodeSeg);
   QUICK_LOCK(DOSSeg);
   QUICK_LOCK(JukeBox);
   QUICK_LOCK(nStart12Esc);
   QUICK_LOCK(ShiftKey);
   QUICK_LOCK(OStart);
   QUICK_LOCK(keyinp);
   QUICK_LOCK(start1);
   QUICK_LOCK(start2);
   QUICK_LOCK(escsent);
   QUICK_LOCK(setdel);
   QUICK_LOCK(dellen);
   QUICK_LOCK(test);
   QUICK_LOCK(test2);
   QUICK_LOCK(altstate);
   QUICK_LOCK(escstate);
   QUICK_LOCK(istack);
   QUICK_LOCK(lpos);
   QUICK_LOCK(rkaddr);

   _go32_dpmi_lock_data(stackbucket, 16384);
   _go32_dpmi_lock_data(origcode,44);
   _go32_dpmi_lock_data(newcode,88);
   _go32_dpmi_lock_data(shift,6);
   _go32_dpmi_lock_data(shiftsent,6);
   _go32_dpmi_lock_data(shiftkey,6);
   _go32_dpmi_lock_data(lkeys,128);

//Code
//lock the new handler
	_go32_dpmi_lock_code((void *)_new_key,(long)_new_key_end-(long)_new_key);
//and the C function it calls
   _go32_dpmi_lock_code((void *)replacekey,(long)addremaps-(long)replacekey);
//then the DJGPP function that calls
   _go32_dpmi_lock_code((void *)__dpmi_set_protected_mode_interrupt_vector,1024);

}


void replacekey(void)
{
//let DJGPP handle some of the nasty stuff,
//as the keyboard is a reflected hardware interrupt
   __dpmi_set_protected_mode_interrupt_vector(KEY_INT,&rkaddr);
}


void addremaps(char *szIn)
{
   int ntot,n,idx,skey;
	char *pWork;
	char *pWork2;
	char *pCodes;
	static char szWork[32];
	static char szWork2[16];
	static char szWork3[512];

	pWork=getitem(szWork3,szIn,0,512,'}');
	nStart12Esc=atoi(pWork);
	pWork=getitem(szWork3,szIn,2,512,'}');
	dellen=atoi(pWork);
   pWork=getitem(szWork3,szIn,3,512,'}');
   skey=atoi(pWork);
//check which shift key it is
   if(skey==2)
   {
//start 2
      ShiftKey=3;
      OStart=2;
   }
   else
   {
//start 1
      ShiftKey=2;
      OStart=3;
   }

   pWork=getitem(szWork3,szIn,4,512,'}');
   coin1=(unsigned char)atoi(pWork);


   pCodes=getitem(szWork3,szIn,5,512,'}');
	if(!stricmp(pCodes,NO_REMAPS))
		return;
//get the number of remaps
	ntot=getitemcount(pCodes,',');
	if(!ntot||ntot>80)
		return;

	idx=0;
//no go through them
	for(n=0;n<ntot;n+=2)
	{
		pWork=getitem(szWork,pCodes,n,16,',');
		origcode[idx]=(unsigned char)atoi(pWork);
		pWork=getitem(szWork,pCodes,n+1,32,',');
		pWork2=getitem(szWork2,pWork,0,16,'|');
		newcode[idx]=(unsigned char)atoi(pWork2);

		if(getitemcount(pWork,'|')>1)
		{
			pWork=getitem(szWork2,pWork,1,16,'|');
			newcode[idx+44]=(unsigned char)atoi(pWork);
		}
		else
			newcode[idx+44]=0;
		idx++;

	}
}


void addshifts(char *szIn)
{
   int n;
	char *pWork;
   char *pWork2;
   char *pWork3;
   char *pWork4;
   static char szWork[32];
   static char szWork2[32];
   static char szWork3[32];
   static char szWork4[32];

   pWork=getitem(szWork,szIn,0,31,'}');
   pWork2=getitem(szWork2,szIn,1,31,'}');
   for(n=0;n<6;n++)
	{
      pWork3=getitem(szWork3,pWork,n,16,',');
      pWork4=getitem(szWork4,pWork2,n,16,',');
      if(atoi(pWork3)==0||atoi(pWork4)==0)
         break;
      shiftkey[n]=(unsigned char)atoi(pWork3);
      shift[n]=(unsigned char)atoi(pWork4);
   }
}

//open 'virtual' RM file
void fopenRM(void)
{
   __dpmi_regs r;
//allocate some space
   pFMem=malloc(16384);
   *pFMem=0;
   pCur=pFMem;
//get the existing data
   r.h.ah = AOS_BIOS_FLAG;
   r.h.al = GET_WRAP;
   __dpmi_int(0x10, &r);
//and copy it up to protected mode
   dosmemget(((r.x.bx << 4) & 0xfffff)+(r.x.dx&0xffff),r.x.cx,pFMem);
}

//close 'virtual' RM file
void fcloseRM(void)
{
   free(pFMem);
}

//read string from 'virtual' RM file
char *fgetsRM(char *buffer,int n)
{
	char *pWork;
	char *pWork2;

   pWork2=pCur;

	*buffer=0;

   if(!*pCur)
		return NULL;
   pWork=strstr(pCur,"\n");
	if(pWork)
	{
		*pWork=0;
		pWork++;
	}
	else
      pWork=pCur+strlen(pCur);


   pCur=pWork;
	strncpy(buffer,pWork2,n);
	return pWork2;
}

//setup the interrupt visible form real mode
//hijack BIOS BASIC - as it's a safe bet than an emu won't be using it
void rminit(void)
{
//setup the address
   memset(&rmint,0,sizeof(rmint));
   rmint.size=sizeof(rmint);
   rmint.pm_offset = (long)_rmint;
   rmint.pm_selector = _my_cs();
//lock the handler
   _go32_dpmi_lock_code((void *)_rmint,(long)_rmint-(long)_rmint_end);
//put it into real mode
   _go32_dpmi_allocate_real_mode_callback_iret(&rmint,&rmregs);
//get the old RM interrupt
   _go32_dpmi_get_real_mode_interrupt_vector(BASIC_INT,&oldvect);
//and set our new one
   _go32_dpmi_set_real_mode_interrupt_vector(BASIC_INT,&rmint);

}

//tidyup real mode interrupt
void rmclose(void)
{
//set the old interrupt back
   _go32_dpmi_set_real_mode_interrupt_vector(BASIC_INT,&oldvect);
//and get rid of our real mode code
   _go32_dpmi_free_real_mode_callback(&rmint);
}


#include "itemfunc.x"
