#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include "main.h"
#include "fil.h"
struct sPSXPAD
{
	unsigned long int dwPSXPAD[6];	/* Up to 6 PSXPAD's */
};

#define LPT1_BASE 0x378
#define LPT2_BASE 0x278
#define LPT3_BASE 0x3bc

#define LPT_D0  0x01
#define LPT_D1  0x02
#define LPT_D2  0x04
#define LPT_D3  0x08
#define LPT_D4  0x10
#define LPT_D5  0x20
#define LPT_D6  0x40
#define LPT_D7  0x80
#define LPT_AUT 0x08
#define LPT_SEL 0x10
#define LPT_PAP 0x20
#define LPT_ACK 0x40

#define	PSX_SELECT					0x00004000	/* Select Button */
#define	PSX_START					0x00002000	/* Start button */
#define	PSX_R2						0x00001000	/* R2 button */
#define	PSX_L2						0x00000800	/* L2button */
#define	PSX_R1						0x00000400	/* R1 Button */
#define	PSX_L1						0x00000200	/* L1 Button */
#define	PSX_CIRCLE					0x00000100	/* Circle Button */
#define	PSX_TRIANGLE				0x00000080	/* Triangle Button */
#define	PSX_SQUARE					0x00000040	/* Square Button */
#define	PSX_CROSS					0x00000020	/* Cross Button */
#define	PSX_LEFT					0x00000010	/* Left direction */
#define	PSX_RIGHT					0x00000008	/* Right direction */
#define	PSX_DOWN					0x00000004	/* Down direction */
#define	PSX_UP						0x00000002	/* Up direction */


#define PSX_MAX_DATA     33     /* maximum possible length of controller packet in bytes */
#define PSX_MAX_DETECT   8      /* maximum number of controllers to install */
#define PSX_DELAY        3

				/* JAP code  EUR code    Name */

#define PSX_MOUSE        1      /* SCPH-1030 SCPH-????   Mouse */
#define PSX_NEGCON       2      /* SLPH-0001 SLEH-0003   Namco neGcon
				   SLPH-0007             Nasca Pachinco Handle (!)
				   SLPH-0015             ? Volume Controller (!)
				   SLPH-???? SLEH-0006(?)MadKatz Steering Wheel */
#define PSX_KONAMIGUN    3      /* SLPH-???? SLPH-????   Konami Lightgun */
#define PSX_DIGITAL      4      /* SCPH-1010 SCPH 1080 E Controller
				   SCPH-1110 SCPH-????   Analog Joystick - Digital Mode
				   SCPH-1150 SCPH-1200 E Dual Shock Analog Controller - Digital Mode
				   SLPH-???? SLEH-0011   Ascii Resident Evil Pad
				   SLPH-???? SLEH-0004   Namco Arcade Stick */
#define PSX_ANALOG_GREEN 5      /* SCPH-1110 SCPH-????   Analog Joystick - Analog Mode
				   SCPH-1150 SCPH-1200 E Dual Shock Analog Controller - Analog Green Mode */
#define PSX_GUNCON       6      /* SLPH-???? SLEH-0007   Namco G-con45 */
#define PSX_ANALOG_RED   7      /* SCPH-1150 SCPH-1200 E Dual Shock Analog Controller - Analog Red Mode */
#define PSX_JOGCON       14     /* SLPH-???? SLEH-0020   Namco Jogcon */
/*      PSX_MULTITAP           SCPH-1070 SCPH-1070 E Multi tap */



/* driver functions */
int num_joysticks;
int psx_detect(int base, int conport, int tap);

/*static int psx1_init();
static int psx2_init();
static int psx3_init();
static void psx_exit(int base);
static void psx1_exit();
static void psx2_exit();
static void psx3_exit();
static int psx1_poll();
static int psx2_poll();
static int psx3_poll();
static int psx_detect();*/



/*JOYSTICK_DRIVER joystick_psx1 =
{
   JOY_TYPE_PSXPAD_LPT1,
   NULL,
   NULL,
   "PSXpad-LPT1",
   psx1_init,
   psx1_exit,
   psx1_poll,
   NULL, NULL,
   NULL, NULL
};



JOYSTICK_DRIVER joystick_psx2 =
{
   JOY_TYPE_PSXPAD_LPT2,
   NULL,
   NULL,
   "PSXpad-LPT2",
   psx2_init,
   psx2_exit,
   psx2_poll,
   NULL, NULL,
   NULL, NULL
};



JOYSTICK_DRIVER joystick_psx3 =
{
   JOY_TYPE_PSXPAD_LPT3,
   NULL,
   NULL,
   "PSXpad-LPT3",
   psx3_init,
   psx3_exit,
   psx3_poll,
   NULL, NULL,
   NULL, NULL
};
*/


static unsigned char psx_parallel_out = 0xff;

static int psx_first_poll = 1;

typedef struct {
   int conport;
   int tap;
   int type;
} PSX_INFO;

static PSX_INFO psx_detected[PSX_MAX_DETECT];



/* psx_init:
 *  Initialise joy[] for Allegro depending on what's detected.
 */
int psx_init(int base)
{
   int i, j, type;

   num_joysticks = 0;

   /* test for the presence of controllers on port base */
   for (i=0; i<6; i++)
   {
      for (j=1; j<5; j++)
      {
         type = psx_detect(base, i, j);

         if (type != -1)
         {
            psx_detected[num_joysticks].conport = i;
            psx_detected[num_joysticks].tap = j;
            psx_detected[num_joysticks].type = type;
            num_joysticks++;
         }

         if (num_joysticks == PSX_MAX_DETECT)
            i = 6;
      }
   }

   if(!num_joysticks)
   {
      return (0);
   }

   return (num_joysticks);
}



int psx1_init(void)
{
   return (psx_init(LPT1_BASE));
}



/*
 * powers down all parallel port driven conports on port base
 * disabled - otherwise prevents Sony Dual Shock controller crash protection
 */

 void psx1_exit(void)
{
   /*outportb(LPT1_BASE + 0, 0); */
}

/*
 * sets clock of any conport connected to parallel port base
 */
 void psx_clk(int base, int on)
{
   const int clk = LPT_D2;      /* bit 3 base + 0 (pin 4 parallel port) */

   if (on) {
      /* set controller clock high */
      psx_parallel_out |= clk;
   }
   else {
      /* set controller clock low */
      psx_parallel_out &= ~clk;
   }

   outportb(base+0, psx_parallel_out);
}



/*
 * sets att for conport connected to parallel port base
 */
 void psx_sel(int base, int conport, int on)
{
   /* bits 3-7 base + 0 (pins 5 to 9 parallel port) */
   const int power = LPT_D3 | LPT_D4 | LPT_D5 | LPT_D6 | LPT_D7;
   /* bits 1-6 base + 0 (pins 3, 5, 6, 7 and 8 parallel port) */
   static unsigned char att_array[] = {LPT_D1, LPT_D1, LPT_D3, LPT_D4, LPT_D5, LPT_D6};
   unsigned char att = att_array[conport];

   /* powers up all parallel port driven conports */
   psx_parallel_out |= power;

   if (on) {
      /* set controller att high */
      psx_parallel_out |= att;
   }
   else {
      /* set controller att low */
      psx_parallel_out &= ~att;
   }

   outportb(base+0, psx_parallel_out);
}



/*
 * sets command for any conport connected to parallel port base
 */
 void psx_cmd(int base, int on)
{
   const int cmd = LPT_D0;      /* bit 0 base + 0 (pin 2 parallel port) */

   if (on) {
      /* set controller cmd high */
      psx_parallel_out |= cmd;
   }
   else {
      /* set controller cmd low */
      psx_parallel_out &= ~cmd;
   }

   outportb(base+0, psx_parallel_out);
}



/*
 * tests data for conport connected to parallel port base, returns 1 if high
 */
 int psx_dat(int base, int conport)
{
   unsigned char data;

   if (conport == 1)
      data = LPT_SEL;
   else
      data = LPT_ACK;

   if (inportb(base + 1) & data)
      return 1;
   else
      return 0;
}



/*
 * tests ack for conport connected to parallel port base, returns 1 if high
 */
 int psx_ack(int base, int conport)
{
   unsigned char ack;

   if (conport == 1)
      ack = LPT_AUT;
   else
      ack = LPT_PAP;

   if (inportb(base + 1) & ack)
      return 1;
   else
      return 0;
}



/*
 * wait for PSX_DELAY * (outportb() execution time)
 */
 void psx_delay(int base)
{
   int i;

   for (i=0; i<PSX_DELAY; i++)
      outportb(base+0, psx_parallel_out);
}



/*
 * send byte as a command to conport connected to parallel port base
 * assumes clock high and the attention for conport
 */
 unsigned char psx_sendbyte(int base, int conport, unsigned char byte, int wait)
{
   int i;
   unsigned char data;

   data = 0;

   /* for each bit in byte */
   for (i=0; i<8; i++) {
      psx_delay(base);
      psx_cmd(base, byte & (1<<i));    /* send the (i+1)th bit of byte to any listening controller */
      psx_clk(base, 0);                /* clock low */
      psx_delay(base);
      data |= (psx_dat(base, conport) ? (1<<i) : 0);  /* read the (i+1)th bit of data from conport */
      psx_clk(base, 1);                /* clock high */
   }

   /* delay for 30 and wait for controller ack */
   for (i=0; wait && i < 30 && psx_ack(base, conport); i++)
      ;

   return data;
}



/*
 * sets clock high and gets the attention of conport, use before psx_sendbyte()
 */
 void psx_sendinit(int base, int conport)
{
   psx_sel(base, conport, 1);   /* set att on for conport */
   psx_clk(base, 1);            /* clock high */
   psx_cmd(base, 1);            /* set command on for conport */
   psx_delay(base);
   psx_delay(base);
   psx_delay(base);
   psx_delay(base);
   psx_delay(base);
   psx_sel(base, conport, 0);   /* set att off for conport */
   psx_delay(base);
   psx_delay(base);
   psx_delay(base);
   psx_delay(base);
}



/*
 * use after psx_sendbyte()
 */
 void psx_sendclose(int base, int conport)
{
   psx_delay(base);
   psx_delay(base);
   psx_sel(base, conport, 1);   /* set att on for conport */
   psx_cmd(base, 1);            /* set command on for conport */
   psx_clk(base, 1);            /* clock high */
   psx_delay(base);
}



/*
 * send string as a series of commands to conport connected to parallel port base
 */
 void psx_sendstring(int base, int conport, int string[])
{
   int i;

   psx_sendinit(base, conport);

   /* for each byte in string */
   for (i=0; string[i+1] != -1; i++) {
      /* send byte i and wait for conport ack */
      psx_sendbyte(base, conport, (unsigned char)string[i], 1);
   }

   /* send the last byte in string and don't wait for ack */
   psx_sendbyte(base, conport, (unsigned char)string[i], 0);

   psx_sendclose(base, conport);
}



/*
 * sends the dual shock command sequence to conport:tap on port base
 */
/*
 void psx_vibrate(int base, int conport, int tap, int shock, int rumble)
{
   static int dualshock_string[4][12] =
   {
      { -1, 0x43, 0x00, 0x01, 0x00, 0x01, -1 },
      { -1, 0x4d, 0x00, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0x01, -1 },
      { -1, 0x43, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, -1 },
      { -1, 0x42, 0x00, -1, -1, 0x01, -1 }
   };

   int i;

   dualshock_string[0][0] = tap;
   dualshock_string[1][0] = tap;
   dualshock_string[2][0] = tap;
   dualshock_string[3][0] = tap;

   dualshock_string[3][3] = shock;
   dualshock_string[3][4] = rumble;

   for (i=0; i<4; i++) {
      psx_delay(base);
      psx_delay(base);
      psx_delay(base);
      psx_sendstring(base, conport, dualshock_string[i]);
   }
}
*/



/*
 * sends force feedback/shock init command sequence to conport:tap on port base
 * (also initialises crash protection for some controllers)
 */
 void psx_vibrate_init(int base, int conport, int tap)
{
   static int jogcon_string[3][12] =
   {
      { -1, 0x43, 0x00, 0x01, 0x00, 0x01, -1 },
      { -1, 0x4d, 0x00, 0x00, 0x01, 0xff, 0xff, 0xff, 0xff, 0x01, -1 },
      { -1, 0x43, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, -1 },
   };

   int i;

   jogcon_string[0][0] = tap;
   jogcon_string[1][0] = tap;
   jogcon_string[2][0] = tap;

   for (i=0; i<3; i++) {
      psx_delay(base);
      psx_delay(base);
      psx_delay(base);
      psx_sendstring(base, conport, jogcon_string[i]);
   }
}



/*
 * tests for the presence of a controller on conport:tap connected to base
 * returns the type if present, otherwise -1
 *
 */
 int psx_detect(int base, int conport, int tap)
{
   unsigned char data[PSX_MAX_DATA];
   int psx_type, packet_length;

   psx_sendinit(base, conport);

   data[0] = psx_sendbyte(base, conport, tap, 1);
   data[1] = psx_sendbyte(base, conport, 0x42, 1);

   psx_sendclose(base, conport);

   psx_type = (data[1] & 0xf0) >> 4;

   packet_length = 3 + (2 * (data[1] & 0x0f));

   /* if the packet is of a legal length */
   if (packet_length < PSX_MAX_DATA)
      /* return the controller type */
      return psx_type;
   else
      return -1;
}



/*
 * retrieves controller data for conport:tap connected to base
 */
 void psx_poll(int base, int conport, int tap, int type, int joynum,struct sPSXPAD *tt)
{
   unsigned char data[PSX_MAX_DATA];
   int i, psx_type, packet_length;

   psx_sendinit(base, conport);

   data[0] = psx_sendbyte(base, conport, tap, 1);
   data[1] = psx_sendbyte(base, conport, 0x42, 1);

   psx_type = (data[1] & 0xf0) >> 4;

   packet_length = 3 + (2 * (data[1] & 0x0f));

   /* if the packet is of a legal length */
   if (packet_length < PSX_MAX_DATA) {
      /* read the remaining packet */
      for (i=2; i<packet_length; i++)
	 data[i] = psx_sendbyte(base, conport, 0x00, 1);
   }

	tt->dwPSXPAD[joynum]=0;
   /* direction pad left */
	if (!(data[3] & 0x80))
		tt->dwPSXPAD[joynum]|=PSX_LEFT;

	 /* direction pad down */
	if (!(data[3] & 0x40))
		tt->dwPSXPAD[joynum]|=PSX_DOWN;

	 /* direction pad right */
	if (!(data[3] & 0x20))
		tt->dwPSXPAD[joynum]|=PSX_RIGHT;

	 /* direction pad up */
	if (!(data[3] & 0x10))
		tt->dwPSXPAD[joynum]|=PSX_UP;

	 /* cross */
	if (!(data[4] & 0x40))
		tt->dwPSXPAD[joynum]|=PSX_CROSS;

	 /* circle */
	if (!(data[4] & 0x20))
		tt->dwPSXPAD[joynum]|=PSX_CIRCLE;

	 /* square */
	if (!(data[4] & 0x80))
		tt->dwPSXPAD[joynum]|=PSX_SQUARE;

	 /* triangle */
	if (!(data[4] & 0x10))
		tt->dwPSXPAD[joynum]|=PSX_TRIANGLE;

	 /* L1 */
	if (!(data[4] & 0x04))
		tt->dwPSXPAD[joynum]|=PSX_L1;

	 /* R1 */
	if (!(data[4] & 0x08))
		tt->dwPSXPAD[joynum]|=PSX_R1;

	 /* L2 */
	if (!(data[4] & 0x01))
		tt->dwPSXPAD[joynum]|=PSX_L2;

	 /* R2 */
	if (!(data[4] & 0x02))
		tt->dwPSXPAD[joynum]|=PSX_R2;

	 /* select */
	if (!(data[3] & 0x01))
		tt->dwPSXPAD[joynum]|=PSX_SELECT;

	 /* start */
	if (!(data[3] & 0x08))
		tt->dwPSXPAD[joynum]|=PSX_START;

}



int psx1_poll(struct sPSXPAD *tt)
{
   int joynum;

   /* send Jogcon init to all controllers */
   if (psx_first_poll)
   {
      for (joynum=0; joynum<num_joysticks; joynum++)
      {
         psx_sendinit(LPT1_BASE, psx_detected[joynum].conport);
         psx_vibrate_init(LPT1_BASE, psx_detected[joynum].conport, psx_detected[joynum].tap);
         psx_sendclose(LPT1_BASE, psx_detected[joynum].conport);
      }

      psx_first_poll = 0;
   }

   for (joynum=0; joynum<num_joysticks; joynum++)
   {
      psx_poll(LPT1_BASE, psx_detected[joynum].conport, psx_detected[joynum].tap, psx_detected[joynum].type, joynum,tt);
   }


   return num_joysticks;
}



