#ifndef _SBFM_H_
#define _SBFM_H_

typedef struct sbInstTAG
{
	char fileId[4];              // Always 'SBI'
	char instName[19];             // 18 characters for null-termed name
	BYTE modParams;                // Set of parameter bits for modulator
	BYTE carParams;                // Set of parameter bits for carrier
	BYTE modScalOut;               // Modulator scaling/output level
	BYTE carScalOut;               // Carrier scaling/output level
	BYTE modAttkDec;               // Modulator attack/decay
	BYTE carAttkDec;               // Carrier attack/decay
	BYTE modSustRel;               // Modulator sustain/release
	BYTE carSustRel;               // Carrier sustain/release
	BYTE modWaveSel;               // Modulator wave select
	BYTE carWaveSel;               // Carrier wave select
	BYTE feedBkConn;               // Feedback/Connection
	BYTE unused[5];              // Reserved
} sbInst;

int DetectFM(void);                 // returns true if FM chip present
void ResetFM(void);                  // resets FM chip to defaults
void SetMusicMode(void);             // sets FM chip to 9-voice music mode
void ProgramChange(BYTE theChannel,sbInst *theInstTable);
void SetFreq(BYTE theChannel,int theFNum);
void SetOct(BYTE theChannel,BYTE theOctave);
void KeyOn(BYTE theChannel);
void KeyOff(BYTE theChannel);
void SetReg(BYTE theReg,BYTE theValue);

#endif
