#include "main.h"
#include "scrn.h"
#include "keyasm.h"
#include "disp.h"
#include "mouse.h"
#include "info.h"
#include "launch.h"
#include "fixed.h"
#include "3d.h"
#include "sound.h"

static int boxlen;
static clock_t tickstart=0;

extern int FirstJukeBox;

int screensaver(int type)
{
   pBYTE savscrn;
//save what's on screen
	savscrn=myalloc(ScreenOrient.memsize);
	if(!savscrn)
		return FALSE;
	memcpy(savscrn,screen,ScreenOrient.memsize);
	initkey();

   if(type==SAVER_JUKEBOX)
   {
//only play tune for first JB game
      if(FirstJukeBox)
         soundinterface(SOUND_SAVER);
   }
   else
      soundinterface(SOUND_SAVER);

	switch(type)
	{
      case SAVER_LENS:
         lenssaver();
			break;
      case SAVER_PUZZLE:
			slidepuzzle(FALSE);
			break;
      case SAVER_STARS:
			starfield();
			break;
      case SAVER_LENS_PUZZLE:
			slidepuzzle(TRUE);
			break;
      case SAVER_SCREENS:
         sshots(FALSE,FALSE,FALSE,FALSE);
			break;
      case SAVER_SCREENS_3D:
			shots3d();
			break;
      case SAVER_SCREENS_LENS:
         sshots(TRUE,FALSE,FALSE,FALSE);
         break;
      case SAVER_SMEAR:
         sshots(FALSE,TRUE,FALSE,FALSE);
         break;
      case SAVER_EXPLODE:
         sshots(FALSE,FALSE,TRUE,FALSE);
         break;
      case SAVER_SLATS :
         sshots(FALSE,FALSE,FALSE,TRUE);
         break;
      case SAVER_BLANK:
         blankscreen();
         break;
		case SAVER_JUKEBOX:
			if(CurEmu==EMU_MAME)
				return jukebox();
			else
            sshots(FALSE,FALSE,FALSE,FALSE);
			break;
	}

//get the screen back
	memcpy(screen,savscrn,ScreenOrient.memsize);
//free up our temp save area
	myfree(savscrn);
	return TRUE;
}

int jukebox(void)
{
	if(keyorbutpres())
	{
		SaverCount=JukeBoxSave;
		return TRUE;
	}

   CurPos=randomgame();
   nLastGame[CurEmu]=CurPos;
	callAOSBios(JUKE_DELAY,JukeDelay,0);
   launchgame(CurPos,Emulators[CurEmu].nGameTotals[CUSTOM_LIST][ROTATION],TRUE);
	if(keyorbutpres())
	{
		SaverCount=JukeBoxSave;
		return TRUE;
	}

	return JUKEBOX_RETURN;
}


void sshots(int pluslens,int smear,int xxexplode,int drawslats)
{
   int pickgame,breakloop,offset,ypos;
   int gotshot,lastgood,n,banpos;
	int bp=0;
   int sstype;
	char szGameName[256];
   int bNewFlip=FALSE;
	LENSDATA    lens[2];

	lens[0].x=0;
	lens[0].y=0;
	lens[1].x=ScreenOrient.xpixel/2;
	lens[1].y=ScreenOrient.ypixel/2;

	lens[0].xdir=1;
	lens[0].ydir=1;
	lens[1].xdir=-1;
	lens[1].ydir=1;
	if(pluslens)
	{
		lens[0].scratch=myalloc(100*100);
		lens[0].morph=myalloc(100*100);
		lens[1].scratch=myalloc(100*100);
		lens[1].morph=myalloc(100*100);

		lens[0].lensdata=myalloc(100*200);
		lens[1].lensdata=lens[0].lensdata;
		getlensdata(lens[0].lensdata);
	}

	*szGameName=0;
	lastgood=pickgame=CurPos;


    banpos=1;

	while(TRUE)
	{
		if(keyorbutpres()||bp)
			break;
      if(checkpicchange())
		{
			breakloop=0;
			while(1)
			{
            pickgame=randomgame();
            //get the screen shot type
            sstype=getsstype();
            //and then the scren shot
            gotshot=getscreenshot(pickgame,FALSE,TRUE,sstype);
				strcpy(szGameName,pMameGames[pickgame].szDispName);
				szGameName[ScreenOrient.maxx-1]=0;
				if(gotshot)
					break;
				breakloop++;
				if(breakloop>100)
					break;
			}
			if(gotshot)
			{
            int x,y,smdraw;

            bNewFlip=TRUE;
				bGotBack=TRUE;
				lastgood=pickgame;
				clearscreen();
				smdraw=1;
            if(smear)
            {
               if(!pluslens)
               {
                  memset(screen,0,ScreenOrient.memsize);
                  for(x=ScreenOrient.xpixel-1;x>=0;x--)
                  {
                     for(y=0;y<ScreenOrient.ypixel;y++)
                     {
                        if(banpos)
                        {
                           memset(&screen[(y*ScreenOrient.xpixel)],
                           pcxback.image[(y*ScreenOrient.xpixel)+x],x+1);
                        }
                        else
                           memset(&screen[(y*ScreenOrient.xpixel)+((ScreenOrient.xpixel-1)-x)],
                        pcxback.image[(y*ScreenOrient.xpixel)+((ScreenOrient.xpixel-1)-x)],x+1);

                     }
                     if(keyorbutpres())
                     {
                        bp=1;
                        break;
                     }
                     if(smdraw)
                     {
                        if(xxexplode)
                           tofromdot(3);
                        else
                           if(drawslats)
                              slats();
                           else
                              flipscreen(FALSE);
                     }
                     smdraw=!smdraw;
                  }
               }
            }
            offset=(ScreenOrient.maxx-strlen(szGameName))/2;
            if(offset<0)
               offset=0;
            if(banpos)
               ypos=ScreenOrient.maxy;
            else
               ypos=2;
            for(n=0;n<strlen(szGameName);n++)
               shadowchar(n+offset,ypos,WIN_FONT);
            dispcentre(ypos,szGameName,ForeColour,0,ScreenOrient.maxx,TRUE,0,0,DISP_FONT);
            banpos=!banpos;
         }
		}

		if(pluslens)
			dolens(lens,2);
		else
      {
         if(xxexplode)
         {
            if(bNewFlip)
            {
               tofromdot(3);
               bNewFlip=FALSE;
            }
            else
               flipscreen(FALSE);
         }
         else
         {
            if(bNewFlip)
            {
               bNewFlip=FALSE;
               if(drawslats)
                  slats();
               else
                  flipscreen(FALSE);
            }
            else
               flipscreen(FALSE);
         }
      }
	}
	if(pluslens)
	{
		myfree(lens[0].scratch);
		myfree(lens[0].lensdata);
		myfree(lens[0].morph);
		myfree(lens[1].scratch);
		myfree(lens[1].morph);
	}

	CurPos=lastgood;
	cursorcheck();

}

int getsstype(void)
{
   static int last=FALSE;
   int ret=FALSE;
   int xx;
   switch(SaverSSType)
   {
      case SSHOT_CYCLE:
         switch(last)
         {
            case FALSE:
               ret=SCREEN_FLYERS;
               break;
            case SCREEN_FLYERS:
               ret=SCREEN_CABINET;
               break;
            case SCREEN_CABINET:
               ret=FALSE;
               break;
         }
         break;
      case SSHOT_RANDOM:
         xx=random()%3;
         switch(xx)
         {
            case 0:
               ret=FALSE;
               break;
            case 1:
               ret=SCREEN_FLYERS;
               break;
            case 2:
               ret=SCREEN_CABINET;
               break;
         }
         break;
   }
   last=ret;
   return ret;
}

void lenssaver()
{
	LENSDATA lens;
	pBYTE   scratch;
	pBYTE   morph;

	lens.scratch=myalloc(100*100);
	lens.morph=myalloc(100*100);
	lens.lensdata=myalloc(100*200);

	getlensdata(lens.lensdata);
	lens.x=lens.y=0;
	lens.xdir=lens.ydir=1;

	while(TRUE)
	{
		if(keyorbutpres())
			break;
        dolens(&lens,1);
	}
    myfree(lens.scratch);
    myfree(lens.morph);
    myfree(lens.lensdata);
}

int getlensdata(short int *lensdata)
{
	FILE	*fin;

	int	n;

	fin=fopen("arcadeos.fnt","rb");
	if(!fin)
		return FALSE;

	for(n=0;n<10000;n++,lensdata++)
		fread(lensdata,sizeof(short int),1,fin);

	fclose(fin);
	return TRUE;

}

void underlens(int x,int y,pBYTE scratch,int ldir)
{
	pBYTE pWork;
	pBYTE pFrom;
	pBYTE pScreen;

	int	w,h,acx,acy,i,j,istrt,jstrt;
	acx=x-50;
	acy=y-50;
	istrt=jstrt=0;
	w=h=100;

	if(x<50)
	{
		istrt=50-x;
		acx=0;
	}
	if(y<50)
	{
		jstrt=50-y;
		acy=0;
	}
	if(acx+w>ScreenOrient.xpixel-1)
	{
		w=ScreenOrient.xpixel-acx;
	}
	if(acy+h>ScreenOrient.ypixel-1)
	{
		h=ScreenOrient.ypixel-acy;
	}
	pScreen=screen+acx;
	scratch+=istrt;
	w-=istrt;

	if(ldir)
	{
		for(j=jstrt;j<h;j++,acy++)
		{
			pWork=scratch+(100*j);
			pFrom=pScreen+(acy*ScreenOrient.xpixel);

			for(i=0;i<w;i++)
				*pWork++=*pFrom++;
		}
	}
	else
	{
		for(j=jstrt;j<h;j++,acy++)
		{
			pWork=scratch+(100*j);
			pFrom=pScreen+(acy*ScreenOrient.xpixel);
			for(i=0;i<w;i++)
				*pFrom++=*pWork++;
		}

	}
}

void morphlens(pBYTE scratch,pBYTE morph,short int *lensdata)
{
	int	n;
	pBYTE	pIn;
	for(n=0;n<10000;n++,morph++)
	{
		pIn=scratch+lensdata[n];
		*morph=*pIn;
	}
}

void dolens(pLENSDATA plens,int nolens)
{
    int n;
    for(n=0;n<nolens;n++)
    {
//get what's under the lens
        underlens(plens[n].x,plens[n].y,plens[n].scratch,1);
//morph it
        morphlens(plens[n].scratch,plens[n].morph,plens[n].lensdata);
//draw it
        underlens(plens[n].x,plens[n].y,plens[n].morph,0);
    }
//show it
    flipscreen(FALSE);
//restore it
    for(n=nolens-1;n>=0;n--)
    {
        underlens(plens[n].x,plens[n].y,plens[n].scratch,0);
//move the lens
        plens[n].x+=plens[n].xdir;
        plens[n].y+=plens[n].ydir;
        if(plens[n].x<=0||plens[n].x>ScreenOrient.xpixel-2)
            plens[n].xdir=-plens[n].xdir;
        if(plens[n].y<=0||plens[n].y>ScreenOrient.ypixel-2)
            plens[n].ydir=-plens[n].ydir;
    }
}




void slidepuzzle(int pluslens)
{
   int   x,y,xdir,ydir;
   LENSDATA    lens;
   pBYTE   scratch;
   int maxbx,maxby;
	int	freex,freey;
	int	movx,movy;
	int	dirx,diry;
	int	state,direct,blegal;
	int	lastmove=PUZZ_NONE;

   lens.x=lens.y=movx=movy=dirx=diry=direct=0;
   lens.xdir=lens.ydir=1;

	if(Hires)
		boxlen=BOX_LEN*2;
	else
		boxlen=BOX_LEN;

	maxbx=ScreenOrient.xpixel-boxlen;
	maxby=ScreenOrient.ypixel-boxlen;


   scratch=myalloc(boxlen*boxlen);
	if(pluslens)
	{
        lens.scratch=myalloc(100*100);
        lens.morph=myalloc(100*100);
        lens.lensdata=myalloc(100*200);
        getlensdata(lens.lensdata);
	}

	freex=maxbx;
	freey=maxby;

	state=PUZZ_CHOOSE;

//clear one square
	clearsquare(freex,freey);

	while(TRUE)
	{
		if(keyorbutpres())
			break;

		switch(state)
		{
			case PUZZ_CHOOSE:
				blegal=FALSE;
				while(!blegal)
				{
					direct=rand()&3;

					switch(direct)
					{
						case PUZZ_UP:
							movy=freey+boxlen;
							movx=freex;
							dirx=0;
							diry=-1;
							if(movy<ScreenOrient.ypixel&&lastmove!=PUZZ_DOWN)
								blegal=TRUE;
							break;
						case PUZZ_DOWN:
							movy=(freey-boxlen);
							movx=freex;
							dirx=0;
							diry=1;
							if(movy>=0&&lastmove!=PUZZ_UP)
								blegal=TRUE;
							break;
						case PUZZ_LEFT:
							movy=freey;
							movx=freex+boxlen;
							dirx=-1;
							diry=0;
							if(movx<ScreenOrient.xpixel&&lastmove!=PUZZ_RIGHT)
								blegal=TRUE;
							break;
						case PUZZ_RIGHT:
							movy=freey;
							movx=freex-boxlen;
							dirx=1;
							diry=0;
							if(movx>=0&&lastmove!=PUZZ_LEFT)
								blegal=TRUE;
							break;


					}
				}
				freey=movy;
				freex=movx;

				state=PUZZ_MOVE;
				break;
			case PUZZ_MOVE:
//copy the square
				copysquare(movx,movy,scratch);
//clear it
				clearsquare(movx,movy);
//move it
				movy+=diry;
				movx+=dirx;
//draw it
				drawsquare(movx,movy,scratch);
//see if it's finished
				if((movy%boxlen)==0&&(movx%boxlen)==0)
				{
					state=PUZZ_CHOOSE;
					lastmove=direct;
				}
				break;
		}
		if(pluslens)
            dolens(&lens,1);
		else
			flipscreen(FALSE);

	}
	myfree(scratch);
	if(pluslens)
	{
        myfree(lens.scratch);
        myfree(lens.lensdata);
        myfree(lens.morph);
	}
}

void clearsquare(int x,int y)
{
	int	n;
  pBYTE dest;

	dest=screen+x+(y*ScreenOrient.xpixel);
	for(n=0;n<boxlen;n++,dest+=ScreenOrient.xpixel)
		memset(dest,0,boxlen);

}

void copysquare(int x,int y,pBYTE dest)
{

	int	n;
   pBYTE src;

	src=screen+(x)+(y*ScreenOrient.xpixel);
	for(n=0;n<boxlen;n++,src+=ScreenOrient.xpixel,dest+=boxlen)
		memcpy(dest,src,boxlen);

}

void drawsquare(int x,int y,pBYTE src)
{

	int	n;
   pBYTE   dest;

	dest=screen+(x)+(y*ScreenOrient.xpixel);
	for(n=0;n<boxlen;n++,src+=boxlen,dest+=ScreenOrient.xpixel)
		memcpy(dest,src,boxlen);

}


void starfield(void)
{
	int	n;
	pSTAR	stars;
	pSTAR	pWork;


	stars=myalloc(sizeof(STAR)*NO_OF_STARS);

	pWork=stars;
	for(n=0;n<NO_OF_STARS;n++,pWork++)
	{
		pWork->x=(random()%ScreenOrient.xpixel)-(ScreenOrient.xpixel/2);
		pWork->y=(random()%ScreenOrient.ypixel)-(ScreenOrient.ypixel/2);
		pWork->z=300+(rand()%300);
	}

	while(TRUE)
	{
		if(keyorbutpres())
			break;

		memset(screen,0,ScreenOrient.memsize);
		pWork=stars;
		for(n=0;n<NO_OF_STARS;n++,pWork++)
			drawstar(pWork,n);
		flipscreen(FALSE);
	}
	myfree(stars);


}

void drawstar(pSTAR pstar,int nindex)
{
	int	x,y;
   pBYTE   dest;

	x=100*pstar->x/pstar->z;
	y=100*pstar->y/pstar->z;
	x+=ScreenOrient.xpixel>>1;
	y+=ScreenOrient.ypixel>>1;
	if(x>=0&&x<ScreenOrient.xpixel&&y>=0&&y<ScreenOrient.ypixel)
	{
		dest=screen+x+(y*ScreenOrient.xpixel);
		*dest=(nindex%255);

	}
	pstar->z-=(2+(nindex%10));


   if(pstar->z<1)
      pstar->z=1000;

}

void shots3d()
{
   matrix4x3 mat;
   point quad[4], tquad[4], pquad[4];
   int i, j;
   int key = -1;
   int xa = 0, xda = 0;
   int ya = 0, yda = 0;
   int za = 0, zda = 0;
   fp14 s = fpOne;
   int x, y, c;
   int type = 0;
	int rott=0;
   int pickgame,breakloop,offset,ypos;
   int gotshot,lastgood,n,banpos,sstype;
	char szGameName[256];

	int savex,savey,savemem;

   quad[0].x = int2fp(0);
   quad[0].y = int2fp(0);
   quad[0].z = int2fp(0);

   quad[1].x = int2fp(0);
   quad[1].y = int2fp(1);
   quad[1].z = int2fp(0);

   quad[2].x = int2fp(1);
   quad[2].y = int2fp(1);
   quad[2].z = int2fp(0);

   quad[3].x = int2fp(1);
   quad[3].y = int2fp(0);
   quad[3].z = int2fp(0);


	*szGameName=0;
	lastgood=pickgame=CurPos;


   banpos=1;
	if(Hires)
      s += float2fp(0.4);
	else
		s += float2fp(0.7);
	zda=6;
	xda=0;
	yda=0;


	gotshot=FALSE;
	while(TRUE)
	{
      if(checkpicchange())
		{
			breakloop=0;
			while(TRUE)
			{
				savex=ScreenOrient.xpixel;
				savey=ScreenOrient.ypixel;
				savemem=ScreenOrient.memsize;
            pickgame=randomgame();
            //get the screen shot type
            sstype=getsstype();
            //and then the scren shot
				ScreenOrient.xpixel=256;
				ScreenOrient.ypixel=256;
				ScreenOrient.memsize=256*256;

            gotshot=getscreenshot(pickgame,FALSE,TRUE,sstype);
				strcpy(szGameName,pMameGames[pickgame].szDispName);
				szGameName[ScreenOrient.maxx-1]=0;
				ScreenOrient.xpixel=savex;
				ScreenOrient.ypixel=savey;
				ScreenOrient.memsize=savemem;
				if(gotshot)
					break;
				breakloop++;
				if(breakloop>100)
					break;
			}
			banpos=!banpos;
			rott++;
			switch(rott)
			{
				case 3:
				case 0:
					zda=6;
					yda=2;
					rott=0;
					break;
				case 1:
					zda=1;
					yda=4;
					break;
				case 2:
					zda=2;
					yda=2;
					break;
			}
		}
      if(gotshot)
      {
         int smdraw;
         bGotBack=TRUE;
         lastgood=pickgame;
         memset(screen,0,ScreenOrient.memsize);
         smdraw=1;
         offset=(ScreenOrient.maxx-strlen(szGameName))/2;
         if(offset<0)
            offset=0;
         if(banpos)
            ypos=ScreenOrient.maxy;
         else
            ypos=2;

         identity(&mat);
         translate(&mat, -fpHalf, -fpHalf, fpZero);

         xa = 0x3ff & (xa + xda);
         ya = 0x3ff & (ya + yda);
         za = 0x3ff & (za + zda);

         updatesound();
         rotatex(&mat, xa);
         rotatey(&mat, ya);
         rotatez(&mat, za);

         scale(&mat, s, s, s);

         translate(&mat, fpZero, fpZero, fpZero);

         view(&mat,int2fp(ScreenOrient.xpixel), int2fp(ScreenOrient.ypixel),float2fp(2), float2fp(-2),float2fp(1.5), float2fp(-1.5),int2fp(1));
         for (j = 0; j < 4; j++)
         {
            transform(mat, tquad[j], quad[j]);
            project(pquad[j], tquad[j]);
         }
         tpoly(type, 4, pquad, tquad);
         updatesound();
         for(n=0;n<strlen(szGameName);n++)
            shadowchar(n+offset,ypos,DISP_FONT);
         dispcentre(ypos,szGameName,ForeColour,0,ScreenOrient.maxx,TRUE,0,0,DISP_FONT);
      }

		flipscreen(FALSE);

		if(keyorbutpres())
			break;

   }
	CurPos=lastgood;
	cursorcheck();
}

int keyorbutpres()
{
	int	ky;


	ky=readkey();	//read keys
	ky|=handlekeyjoy(TRUE);	//and joystick/pad

	if(bHasMouse&&nMouseType)
	{
		GetRealMousePos();	// and mouse
		ky|=MouseEvent;
	}

	if(ky)
		return TRUE;

	return FALSE;
}

static float ox, oy, oz;
static float hx, hy, hz;
static float vx, vy, vz;


#define step (15)

void lspan(int ix, fp14 pt1, fp14 pt2)
{
    int idy, iy1, iy2;

    float x, y, z;
    float u1, u2, du;
    float v1, v2, dv;
    float u, v;
    int iu, iv;
    int len, count;
	fp14 temp;

    unsigned char *col;
	unsigned char out;

    if (pt2 < pt1)
    {
		temp=pt1;
		pt1=pt2;
		pt2=temp;
    }

    iy1 = adjust(pt1);
    iy2 = adjust(pt2);

    if ((iy1 < 0) && (iy2 < 0))
    {
        return;
    }

    if ((iy1 >= ScreenOrient.ypixel) && (iy2 >= ScreenOrient.ypixel))
    {
        return;
    }

    iy1 = max(0, iy1);
    iy2 = min(ScreenOrient.ypixel, iy2);

    idy = iy2 - iy1;

    if (idy == 0)
    {
        return;
    }

    x = ox +
        (hx * (ix - fp2float(sXCenter))) +
        (vx * (iy1 - fp2float(sYCenter)));

    y = oy +
        (hy * (ix - fp2float(sXCenter))) +
        (vy * (iy1 - fp2float(sYCenter)));

    z = oz +
        (hz * (ix - fp2float(sXCenter))) +
        (vz * (iy1 - fp2float(sYCenter)));

    if (z == 0.0)
    {
        return;
    }

    u2 = (x / z);
    v2 = (y / z);


    col = screen+( (ScreenOrient.xpixel* iy1) + ix);

    len = iy2 - iy1;

    while (len > 0)
    {
        count = min(step, len);
        len -= step;

        x += (vx * count);
        y += (vy * count);
        z += (vz * count);

        if (z == 0.0)
        {
            return;
        }

        u = u1 = u2;
        v = v1 = v2;

        u2 = x / z;
        v2 = y / z;

        du = (u2 - u1) / count;
        dv = (v2 - v1) / count;

        u *= 256;
        du *= 256;

        v *= 256;
        dv *= 256;

        do
        {
            iu = ((long)u);
            iv = ((long)v);

            if(iu==(iu&0xff)&&iv==(iv&0xff))
			{
				out=pcxback.image[(iv<<8)+iu];
				if(out)
            		*col = out;
			}
            u += du;
            v += dv;

            col += ScreenOrient.xpixel;

        } while (--count);
    }
}


void tedge(fp14 *ptable, point *pt1, point *pt2)
{
   fp14 y, dy;
   fp14 fdx;
   int idx, ix1, ix2;

   if (pt2->x < pt1->x)
   {
      exchange(point *, pt1, pt2)
   }

   ix1 = adjust(pt1->x);
   ix2 = adjust(pt2->x);
   idx = ix2 - ix1;

   if (idx == 0)
   {
      return;
   }

   if (ix1 < 0 && ix2 < 0)
   {
      return;
   }

   if (ix1 >= ScreenOrient.xpixel && ix2 >= ScreenOrient.xpixel)
   {
      return;
   }

   idx = max(2, idx - 1);
   fdx = int2fp(idx);

   y = pt1->y;
   dy = fpDiv((pt2->y - pt1->y), fdx);

   do
   {
      if (ix1 >= 0 && ix1 < ScreenOrient.xpixel)
      {
         ptable[ix1] = y;
      }

      y += dy;
      ix1++;
   } while(ix1 < ix2);
}

fp14 table1[640];
fp14 table2[640];

void tpoly(int type, int n, point *ppnts, point *tpnts)
{
   fp14 maxx, minx;
   int imaxx, iminx;
   int ix1, ix2;

   int pnt1, pnt2;
   int i;

   float px, py, pz;
   float mx, my, mz;
   float nx, ny, nz;

   if (n < 3)
      return;


   //
   // find the the basis vectors for the polygon.
   // use the first point, the second point, and
   // the last point in the polygon definition
   // to determine the vectors.
   //

   px = fp2float(tpnts[0].x);
   py = fp2float(tpnts[0].y);
   pz = fp2float(tpnts[0].z);

   mx = fp2float(tpnts[1].x) - px;
   my = fp2float(tpnts[1].y) - py;
   mz = fp2float(tpnts[1].z) - pz;

   nx = px - fp2float(tpnts[n - 1].x);
   ny = py - fp2float(tpnts[n - 1].y);
   nz = pz - fp2float(tpnts[n - 1].z);

   hx = (py * mz) - (pz * my);
   vx = (pz * mx) - (px * mz);
   ox = (px * my) - (py * mx);

   hy = (py * nz) - (pz * ny);
   vy = (pz * nx) - (px * nz);
   oy = (px * ny) - (py * nx);

   hz = (ny * mz) - (nz * my);
   vz = (nz * mx) - (nx * mz);
   oz = (nx * my) - (ny * mx);

   //
   // find the point with the max y value and the
   // point with the min y value
   //

	maxx = minx = ppnts[0].x;
   imaxx = iminx = 0;

   for (i = 1; i < n; i++)
   {
      if (ppnts[i].x > maxx)
      {
         maxx = ppnts[i].x;
         imaxx = i;
      }

      if (ppnts[i].x < minx)
      {
         minx = ppnts[i].x;
         iminx = i;
      }
   }

   //
   // get ready to walk the edge list
   // filling in the edge tables.
   //

   ix1 = adjust(minx);
   ix2 = adjust(maxx);

   if (ix1 == ix2)
      return;


   //
   // walk from the min Y point to the max Y point
   //

   pnt1 = iminx;
   pnt2 = iminx + 1;
   if (pnt2 >= n)
      pnt2 = 0;


   do
   {
      tedge(table1, &ppnts[pnt1], &ppnts[pnt2]);
      pnt1 = pnt2;
      pnt2 = pnt2 + 1;
      if (pnt2 >= n)
         pnt2 = 0;
   } while (pnt1 != imaxx);

   //
   // walk from the max Y point to the min Y point
   //

   pnt1 = imaxx;
   pnt2 = imaxx + 1;
   if (pnt2 >= n)
      pnt2 = 0;

   do
   {
      tedge(table2, &ppnts[pnt1], &ppnts[pnt2]);

      pnt1 = pnt2;
      pnt2 = pnt2 + 1;
      if (pnt2 >= n)
            pnt2 = 0;
   } while (pnt1 != iminx);

   //
   // walk the edge table and fill in all the spans
   //

   ix1 = max(ix1, 0);
   ix2 = min(ix2, ScreenOrient.xpixel);

	do
	{
      lspan(ix1, table1[ix1], table2[ix1]);
		ix1++;
   } while (ix1 < ix2);
}


void blankscreen(void)
{
   tofromdot(-1);
//clear
   memset(screen,0,ScreenOrient.memsize);
   flipscreen(FALSE);
//turn off cabinet/screen
   cabonoff(CAB_OFF);
//wait
   while(TRUE)
	{
      updatesound();
      if(keyorbutpres())
         break;
	}
//turn on cabinet/screen
   cabonoff(CAB_ON);
}


int checkpicchange()
{
   clock_t newtick;
   clock_t tickcount;
   int seconds;

   if(tickstart==0)
   {
      tickstart=clock();
      return TRUE;
   }

   newtick=clock();
   if(newtick>tickstart)
   {
      tickcount=newtick-tickstart;
      seconds=tickcount/clocks_per_second;
      if(seconds>=ShotDelay)
      {
         tickstart=clock();
         return TRUE;
      }
   }
   return FALSE;
}

