#ifndef _SIDEWIND_H_
#define _SIDEWIND_H_

/* Sidewinder information structure */

struct sSidewinder
{
	unsigned long int dwSidewinder[4];	/* Up to 4 sidewinders */
};

/* Function prototypes */

extern unsigned long int GetSidewinderStatus(struct sSidewinder *);

/* Return codes for GetSidewinderStatus */

#define	SW_NOT_FOUND			0xffffffff	/* Sidewinder not attached */
#define	SW_1						0x00000001	/* 1 Sidewinder attached */
#define	SW_2						0x00000002	/* 2 Sidewinders attached */
#define	SW_3						0x00000003	/* 3 Sidewinders attached */
#define	SW_4						0x00000004	/* 4 Sidewinders attached */

/* Bitwise codes in the dwSidewinder[A-D] structures */

#define	SW_PARITY				0x00008000	/* Parity value */
#define	SW_M						0x00004000	/* M Button */
#define	SW_START					0x00002000	/* Start button */
#define	SW_RIGHTFINGER			0x00001000	/* Right finger button */
#define	SW_LEFTFINGER			0x00000800	/* Left finger button */
#define	SW_Z						0x00000400	/* Z Button */
#define	SW_Y						0x00000200	/* Y Button */
#define	SW_X						0x00000100	/* X Button */
#define	SW_C						0x00000080	/* C Button */
#define	SW_B						0x00000040	/* B Button */
#define	SW_A						0x00000020	/* A Button */
#define	SW_LEFT					0x00000010	/* Left direction */
#define	SW_RIGHT					0x00000008	/* Right direction */
#define	SW_DOWN					0x00000004	/* Down direction */
#define	SW_UP						0x00000002	/* Up direction */


#endif
