#include "main.h"
#include "disp.h"
#include "keyasm.h"
#include "info.h"
#include "png.h"
#include "scrasm.h"

static int	bScreenShot;

#define TILESIZE 4

void clearscreenshot()
{
	if(bScreenShot)
	{
		bScreenShot=FALSE;
		bGotBack=getbackdrop();
		if(bGotBack)
		{
			memset(screen,0,ScreenOrient.memsize);
			flipscreen(FALSE);
			makepcxpal();
		}
	}

}
int haveshot()
{
	return bScreenShot;
}

int getscreenshot(int nIndex,int bClear,int bPal,int bAlt)
{
	static char	szWork[512];
	static char szWork2[512];
	char	*pWork=NULL;
	static char	buffer[512];
	int	bFound;
	int	type;
	char	*szName;

	szName=pMameGames[nIndex].GameName;
	if(!szName||!*szName||!Emulators[CurEmu].bScreenShots)
		return FALSE;

	loginfo(1,"Getting screen shot:%s",szName);

	 type=0;
	 while(TRUE)
	 {
		bFound=FALSE;

		if(type)
		{
//second loop, try for a clone
			 szName=pMameGames[nIndex].szParent;
			 if(!szName||!*szName)
				  break;
		}
		strcpy(szWork,szName);
		pWork=0;
		if(bAlt==SCREEN_FLYERS)							// EEA Changed from if (bAlt)
			pWork=Emulators[CurEmu].szFlyerPath;
		else if(bAlt==SCREEN_CABINET)						  // EEA Added this test
			pWork=Emulators[CurEmu].szCabPath;  // EEA
		if(!pWork||!*pWork)
			pWork=Emulators[CurEmu].szPNGPath;
		makefullpath(pWork,szWork2,CurEmu);
		sprintf(buffer,"%s%s.png",szWork2,szWork);

//		loginfo(1,"Checking PNG screen shot %s",buffer);
//		if(checkfile(buffer))
//		{
			loginfo(1,"Loading PNG screen shot %s",buffer);
			bFound=loadpng(buffer,&pcxback);
		if(bFound)		//LasVegas
		{
			break;
		} else
		{
//no PNG, check for a PCX
			pWork=NULL;
			if(bAlt==SCREEN_FLYERS)							// EEA Changed from if (bAlt)
				pWork=Emulators[CurEmu].szFlyerPath;
			else if(bAlt==SCREEN_CABINET)						  // EEA Added this test
				pWork=Emulators[CurEmu].szCabPath;  // EEA

			if(!pWork||!*pWork)
				pWork=Emulators[CurEmu].szPCXPath;

			makefullpath(pWork,szWork2,CurEmu);
			if(*Emulators[CurEmu].szPCXSuffix)
			{
				if(Emulators[CurEmu].bSuffixOW)
				{
					szWork[strlen(szWork)-strlen(Emulators[CurEmu].szPCXSuffix)]=0;
					strcat(szWork,Emulators[CurEmu].szPCXSuffix);
					sprintf(buffer,"%s%s.pcx",szWork2,szWork);
					if(!checkfile(buffer))
					{
						strcpy(szWork,szName);
						if(strlen(szWork)+strlen(Emulators[CurEmu].szPCXSuffix)>8)
							szWork[8-strlen(Emulators[CurEmu].szPCXSuffix)]=0;
						strcat(szWork,Emulators[CurEmu].szPCXSuffix);
					}
				} else
				{
					if(strlen(szWork)+strlen(Emulators[CurEmu].szPCXSuffix)>8)
						szWork[8-strlen(Emulators[CurEmu].szPCXSuffix)]=0;
					strcat(szWork,Emulators[CurEmu].szPCXSuffix);
				}
			}
			sprintf(buffer,"%s%s.pcx",szWork2,szWork);
//			if(checkfile(buffer))
//			{
				loginfo(1,"Loading PCX screen shot %s",buffer);
				bFound=loadpcx(buffer,&pcxback);
			if(bFound)
			{
				break;
			}
		}
		type++; //now try clones
		if(type>1)
		break;
	}
	if(bFound)
	{
		if(bClear)
		{
			memset(screen,0,ScreenOrient.memsize);
			flipscreen(FALSE);
		}
		if(bPal)
			makepcxpal();
//		mosaic();

	}
	bScreenShot=bFound;
	return bFound;
}

void mosaic(void)
{
	pBYTE pOut;
	pBYTE pWork;
	pBYTE ppal;
	int colindex,i,val,lowval;
	int r,g,b,r2,g2,b2,ri,gi,bi;
	int x,y,xx1,yy1;

	for(y=0;y<480;y+=TILESIZE)
	{
		pOut=pcxback.image+(y*640);
		for(x=0;x<640;x+=TILESIZE)
		{
			r=g=b=0;
			for(yy1=0;yy1<TILESIZE;yy1++)
			{
				pOut=pcxback.image+(x+((y+yy1)*640));
				for(xx1=0;xx1<TILESIZE;xx1++,pOut++)
				{
					r+=pcxback.palette[(*pOut*3)];
					g+=pcxback.palette[(*pOut*3)+1];
					b+=pcxback.palette[(*pOut*3)+2];
				}
			}
			r/=(TILESIZE*TILESIZE);
			g/=(TILESIZE*TILESIZE);
			b/=(TILESIZE*TILESIZE);
//then find the nearest match
			lowval=ScreenOrient.memsize;
			ppal=pcxback.palette;
			colindex=0;

			for(i=0;i<256;i++)
			{
				r2=*ppal++;
				g2=*ppal++;
				b2=*ppal++;
				ri=abs(r2-r);
				gi=abs(g2-g);
				bi=abs(b2-b);
				val=(ri+gi+bi);
				if(val<lowval)
				{
					lowval=val;
					colindex=i;
				}
			}
			for(yy1=0;yy1<TILESIZE;yy1++)
			{
				pOut=pcxback.image+(x+((y+yy1)*640));
				for(xx1=0;xx1<TILESIZE;xx1++,pOut++)
					*pOut=colindex;
			}

		}

	}
}
