//#define DEBUG_KEYS
.text
//interrupt visible form real mode portion of AOS
//which installs our protected mode keyboard handler
.globl __rmint
	.align 4
__rmint:
	pushw %ax
	pushw	%bx
  pushw %cx
	pushw %ds
  pushw %es
  pushw %fs
  pushw	%gs
	pushl	%edi
	pushl	%esi
  pushal
  .byte 0x2e
  movw	___djgpp_ds_alias,%ax
  movw	%ax, %ds
  movw   %ax, %es
  movw   %ax, %fs
  movw   %ax, %gs
//as we're calling a C function in the handler, we need to setup a stack for it
  movl %esp, %ecx
  movw %ss, %dx

  movl  _istack,%esp
  movw %ax, %ss
  pushl %ecx
  pushl %edx

  cmpw  $199,_test2
  je    ksetalr

  movw  $199,_test2

  movl  $0x0204,%eax
  movl  $0x09,%ebx
  int   $0x031
//store in our var
  leal  _old_key,%edi
  movl  %edx,%ds:(%edi)
  addl  $4,%edi
  movw  %cx,%ds:(%edi)
//replace the vector using C/DJGPP
  call  _replacekey

ksetalr:

  popl  %edx
  popl  %ecx

  movw %dx, %ss
  movl %ecx, %esp

  cli
  popal
	popl	%esi
	popl	%edi
  popw	%gs
	popw	%fs
  popw	%es
  popw	%ds
  popw  %cx
	popw	%bx
	popw	%ax
  sti
//call the old vector
  ret
//This is just to make locking the code easier
.globl __rmint_end
  .align 4
__rmint_end:
	ret


//our keyboard remapper
.globl __new_key
	.align 4
__new_key:
	pushw %ax
	pushw	%bx
  pushw %cx
	pushw %ds
  pushw %es
  pushw %fs
  pushw	%gs
	pushl	%edi
	pushl	%esi
  pushal
  .byte 0x2e
  movw	___djgpp_ds_alias,%ax
  movw	%ax, %ds
  movw   %ax, %es
  movw   %ax, %fs
  movw   %ax, %gs


//get in the scancode
	movw	$0x60,%dx
	inb		%dx,%al
	movb	%al,%ah
//save keys in buffer for debug
#ifdef DEBUG_KEYS
	lea		_lkeys,%esi
	movw	_lpos,%bx
	addw	%bx,%si
	movb	%al,(%esi)
	incw	%bx
	cmpw	$128,%bx
	jne		nowrap
	movw	$0,%bx
nowrap:
	movw	%bx,_lpos
#endif
//see if we're in the middle of a remap
	cmpw  $0,_keyinp
	jne	inmiddle

//get the scancode
	andb	$127,%al
//and the make/break state
	andb	$128,%ah

//check start1's state (shift)

  cmpb  _ShiftKey,%al

	jne		nostart1
//check make/break
	cmpb	$128,%ah
	jne		nos1brk
//start 1 break
	movw	$0,_start1
  jmp   nostart1
nos1brk:
//start 1 make
  movw  $1,_start1
nostart1:

	cmpb	$56,%al
	jne		noalt
	movb	%ah,_altstate
noalt:

	cmpb	$1,%al
	jne		noesc
	movb	%ah,_escstate
noesc:

//see if the jukebox is running
  cmpw  $1,_JukeBox
  jne   njbox
//Jukebox - flag real mode AOS if user inserts a coin
//(ignore break codes)
  cmpb  $128,%ah
  je    njbox
//check for coin 1
  cmpb  _coin1,%al
	je		coinp
//check for coin 2 (undefined, so default to '4')
	cmpb	$5,%al
  jne    njbox
//flag real mode AOS that there's been a coin press
coinp:
  pushw %ax
	movw	_DOSSeg,%ax
	movw	%ax,%fs
	movl	$0x476,%edi
	movb	$64,%al
	movb	%al,%fs:(%edi)
  movw  $98,_test2
  popw  %ax
njbox:

//the shift functions
  cmpw  $1,_start1
  je    shiftdwn
  jmp   noshiftdwn

shiftdwn:
  leal  _shift,%esi
  leal  _shiftkey,%edi
  xorl  %ecx,%ecx
//loop through all our shift keys
shftloop:
  cmpl  $6,%ecx
  je    noshiftdwn
//get shift scancode to output
	movb	(%esi),%bl
//zero ? - if so quit to end
	cmpb  $0,%bl
  je    noshiftdwn
//check if key pressed/released
  cmpb  (%edi),%al
  jne   notshift
//make/break
  cmpb  $128,%ah
  jne   notshftbrk
//break, see if it's been written
  pushl %edi
  leal  _shiftsent,%edi
  addl  %ecx,%edi
  cmpb  $0,(%edi)
  je    nowrit
//it has, so write the break code
  movb  $0,(%edi)
  orb   $128,%bl
	call	__stuffscancode
nowrit:
  popl  %edi
  jmp   notshift
notshftbrk:
//make, see if shift (start1) is down
  cmpw  $1,_start1
  jne   notshift
//shift down, see if it's already been sent
  pushl %edi
  leal  _shiftsent,%edi
  addl  %ecx,%edi
  cmpb  $0,(%edi)
  jne   beenwrit
//it hasn't, so write the make code
  movb  _ShiftKey,%dl
  movb  %dl,(%edi)
	call	__stuffscancode
beenwrit:
  popl  %edi

notshift:
	incl	%esi
	incl	%edi
  incl  %ecx
  jmp   shftloop

noshiftdwn:

	cmpw	$1,_nStart12Esc
	jne		nostart12
	cmpw	$1,_escsent
	je		nostart12
//start1+2=esc active, so see if start 1's been pressed
//check for start 2
  cmpb  _OStart,%al
	jne		nostart12
//check make/break
	cmpb	$128,%ah
	jne		nos2brk
//break
	movw	$0,_start2
	jmp		nostart12
nos2brk:
//start 2 make
	movw	$1,_start2
	cmpw	$1,_start1
	jne		nostart12
	movw	$4,_escsent
	movw	$1,%ax

nostart12:

	leal	_origcode,%esi
	leal	_newcode,%edi
//now loop through all our remaps
stloop:
//get a remap code
	movb	(%esi),%bl
//zero ? - if so quit to end
	cmpb  $0,%bl
	je    finlp

//see if it matches
	cmpb	%bl,%al
	jne		krnomatch
//it does, so send the new scancode
	movb	(%edi),%bl
	cmpb	$56,%bl
	jne		noalt2
	movb	%ah,_altstate
noalt2:
	orb		%ah,%bl
	call	__stuffscancode
//check if there's an additional scancode
	addl	$44,%edi
	movb	(%edi),%bl
	cmpb	$0,%bl
	je		nosecondc
	cmpb	$56,%bl
	jne		noalt3
	movb	%ah,_altstate
noalt3:
	orb		%ah,%bl
	call	__stuffscancode
nosecondc:

	movb	$0x20,%al
	outb	%al,$0x20
	jmp		nocallold

krnomatch:
	incl	%esi
	incl	%edi
 	jmp		stloop

finlp:

	cmpw	$4,_escsent
	jne		norecesc
//stuff escape if it wasn't remapped
	movw	$1,_escsent
	movb	$1,%bl
	call	__stuffscancode

	movb	$0x20,%al
	outb	%al,$0x20
	jmp		nocallold

norecesc:

  cli

  popal
	popl	%esi
	popl	%edi
  popw	%gs
	popw	%fs
  popw	%es
  popw	%ds
  popw  %cx
	popw	%bx
	popw	%ax
  sti
//call the old vector
  ljmp %cs:_old_key


inmiddle:
   decw  _keyinp
   jmp   finlp

nocallold:
	cmpw	$4,_escsent
	jne		norecesc2
	movw	$1,_escsent
norecesc2:
	cli
	popal
	popl	%esi
	popl	%edi
  popw	%gs
	popw	%fs
  popw	%es
  popw	%ds
  popw  %cx
	popw	%bx
	popw	%ax
  sti
	iret


.globl __waittoxmit
	.align 4
__waittoxmit:
	pushl		%ecx
	pushw		%ax
	xorl		%ecx,%ecx
1:
	inb			$0x64,%al
	testb 	$2,%al
	loopnz   1b
	popw		%ax
	popl		%ecx
	ret



.globl __stuffscancode
	.align 4
__stuffscancode:
	pushw		%ax
	pushw		%bx
	pushl		%ecx

	incw		_keyinp
	xorl		%ecx,%ecx
2:
	inb			$0x64,%al
	testb		$1,%al
	loopnz	2b
	call		__waittoxmit
	movb		$0xd2,%al
	outb		%al,$0x64
//Send the scan code:
	call		__waittoxmit
	movb		%bl,%al
	outb		%al,$0x60

	popl		%ecx
	popw		%bx
	popw		%ax
	ret

//make sure we haven't left alt on
.globl __clearalt
	.align 4
__clearalt:
	pushw		%bx
	cmpb		$0,_altstate
	jne			altup
	movb		$184,%bl
	call		__stuffscancode
altup:
	popw		%bx
	ret

//escape up
.globl __clearesc
	.align 4
__clearesc:
	pushw		%bx
	movb		$129,%bl
	call		__stuffscancode
escup:
	popw		%bx
	ret

//This is just to make locking the code easier
.globl __new_key_end
  .align 4
__new_key_end:
	ret



